-- MySQL dump 10.11
-- Server version	5.0.37

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `comments`
--

DROP TABLE IF EXISTS `comments`;
CREATE TABLE `comments` (
  `hostid` varchar(255) NOT NULL,
  `groupid` int(11) NOT NULL,
  `documentid` varchar(255) NOT NULL,
  `commentid` int(11) NOT NULL default '0',
  `parentid` int(11) NOT NULL default '0',
  `userid` varchar(255) NOT NULL,
  `username` varchar(255) NOT NULL,
  `clientip` varchar(255) NOT NULL,
  `created` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `approved` enum('yes','no') NOT NULL default 'no',
  `title` varchar(255) NOT NULL,
  `comment` text NOT NULL,
  PRIMARY KEY  (`hostid`,`groupid`,`documentid`,`commentid`,`parentid`),
  KEY `userid` (`userid`),
  CONSTRAINT `comments_ibfk_1` FOREIGN KEY (`userid`) REFERENCES `users` (`email`),
  CONSTRAINT `comments_ibfk_2` FOREIGN KEY (`hostid`, `groupid`, `documentid`) REFERENCES `documents` (`hostid`, `groupid`, `documentid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `comments`
--

LOCK TABLES `comments` WRITE;
/*!40000 ALTER TABLE `comments` DISABLE KEYS */;
/*!40000 ALTER TABLE `comments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `configuration`
--

DROP TABLE IF EXISTS `configuration`;
CREATE TABLE `configuration` (
  `paramid` varchar(255) NOT NULL,
  `value` varchar(255) NOT NULL default '',
  `updated` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `description` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`paramid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `configuration`
--

LOCK TABLES `configuration` WRITE;
/*!40000 ALTER TABLE `configuration` DISABLE KEYS */;
INSERT INTO `configuration` VALUES ('404icon','warning.png','2009-06-19 03:56:18','icon used for the 404 document'),('accepticon','accept.png','2009-06-16 04:38:06','confirm/accept icon'),('addbutton','add.png','2009-06-12 10:19:04','add button icon'),('addicon','add.png','2009-06-14 02:59:28','add icon'),('articles','article.png','2009-06-12 00:34:45','articles icon'),('avatardir','/icons/avatars','2009-06-14 10:38:56','subdir where the avatars icons are placed'),('base','/var/www/cms4','2009-06-20 05:20:40','base directory'),('buttondir','/icons/32x32','2009-06-14 10:39:22','directory for the buttons'),('closeicon','remove.png','2009-06-14 10:25:41','icon used in the close command'),('commaddicon','comment_add.png','2009-06-23 12:23:51','icon used in the enable comments command'),('commdelicon','comment_remove.png','2009-06-23 12:24:01','icon used in the disable comments command'),('commedit-fh','480','2009-06-19 09:04:01','height for the edit comment wnd'),('commedit-fw','770','2009-06-19 09:03:39','width for the edit comment wnd'),('comments-fh','900','2009-06-19 08:56:55','height for the edit comment window'),('comments-fw','1200','2009-06-19 08:56:48','width for the edit comment window'),('commentsicon','comments.png','2009-06-14 10:25:59','comments icon'),('config-fh','230','2009-06-12 00:34:45','height for the edit configuration parameters wnd'),('config-fw','750','2009-06-12 00:34:45','width for the edit configuration parameters wnd'),('configicon','process.png','2009-06-14 10:26:06','config params icon'),('cookiehost','softland','2009-06-12 03:24:16','identification cookie'),('copybutton','accept.png','2009-06-13 02:21:24','icon used in the copy command'),('copyicon','windows.png','2009-06-13 02:21:37','icon used in the copy button'),('css','cms3.css','2009-06-15 05:42:43','default CSS'),('debug','','2009-06-28 11:00:32','enable/disable debugging'),('defaultfoldericon','folder_full_accept.png','2009-06-29 08:00:34','icon used for the open folder function'),('defavatar','user.png','2009-06-12 00:34:45','default avatar icons'),('defdocicon','fdcba9c2680d8f9b435c9292fadf602e.png','2009-06-16 03:15:01','default document\'s icon'),('deflang','en','2009-06-13 10:16:40','default language'),('delicon','remove.png','2009-06-13 02:21:56','icon used in the delete or remove command'),('disableicon','search_remove.png','2009-06-13 10:21:50','icon used in the disable display command'),('dociconsdir','/icons/docicons','2009-06-14 10:39:38','documents icon directory'),('documents-fh','720','2009-06-29 16:27:03','height for the edit document window'),('documents-fw','980','2009-06-12 00:34:45','width for the edit document window'),('documentsicon','calendar_empty.png','2009-06-14 10:26:19','document icon'),('downicon','user.png','2009-06-17 03:02:10','Demote to user icon'),('editicon','comment_edit.png','2009-06-23 12:25:27','icon used in the edit comments command'),('edituserheight','800','2009-06-16 03:36:27','height for the edit user window'),('edituserwidth','900','2009-06-12 00:34:45','width for the edit user window'),('emocode','&gt;:( &gt;:-( 8-) 8) :-D :D :-) :) ;-) ;) :\\*( :\\*-( :-( :( ;-P ;-p ;P ;p :-P :P :-p :p','2009-06-23 11:05:18','Code for the emoticons'),('emodecode','mad mad cool cool happy happy glad glad wink wink cry cry sad sad tongue tongue tongue tongue tongue tongue tongue tongue','2009-06-23 11:14:39','Decode for the emoticons'),('emoticonsdir','/icons/emo/','2009-06-14 10:39:49','subdir where the emoticons icons are placed'),('enableicon','search_add.png','2009-06-13 10:21:25','icon used in the enable display command'),('feed-fh','500','2009-06-13 03:42:31','height for the edit RSS feed window'),('feed-fw','930','2009-06-13 03:42:40','width for the edit RSS feed window'),('folderadd','folder_add.png','2009-06-30 13:47:44','Add a folder icon'),('foldericon','folder_full.png','2009-06-29 07:59:23','icon used for the open folder function'),('fragments-fh','300','2009-06-14 03:48:41','height for the edit fragments window'),('fragments-fw','850','2009-06-14 03:48:33','width for the edit fragments windows'),('fragmentsicon','attachment.png','2009-06-14 10:26:26','fragment icon'),('genrssicon','rss.png','2009-06-13 03:47:48','rss feed icon'),('groups-fh','420','2009-06-13 04:32:49','height for the edit group window'),('groups-fw','900','2009-06-13 04:32:59','width for the edit group window'),('groupsicon','folder_full.png','2009-06-14 10:26:33','icon for the groups'),('helpicon','help.png','2009-06-18 05:02:07','icon for the help function'),('helplink','http://help/','2009-07-01 07:10:01','where is the help?'),('hosts-fh','400','2009-06-16 05:46:06','height for the edit host window'),('hosts-fw','900','2009-06-16 05:46:13','width for the edit host window'),('hostsicon','home.png','2009-06-14 10:26:40','hosts icon'),('htmlcode','<[^>]+>,& +,Ã¨,Ã©,Ã‰,Ãˆ,Ã­,Ã¬,Ã²,Ã³,Ã¹,Ãº,Ã€,Ã,Ã¡,Ã ,\",\'','2009-06-24 16:02:43','Code for the char replacement in comments'),('htmldecode',',&amp;,&egrave;,&eacute;,&Egrave;,&Eacute;,&igrave;,&iacute&,&ograve;,&oacute;,&ugrave;,&uacutre&,&Agrave;,&Aacute;,&agrave;,&aacute;,&quot;,&#39;','2009-06-23 11:10:21','Char for the char replacement in comments'),('iconsdir','/icons/16x16','2009-06-14 10:40:01','icons'),('images-fh','480','2009-06-20 04:16:53','height for the edit image wnd'),('images-fw','770','2009-06-20 04:16:38','width for the edit image wnd'),('imgdir','img','2009-06-20 03:35:56','base directory for images'),('imgicon','image.png','2009-06-20 02:33:47','icon for the Images function'),('imgmaxsize','250','2009-06-20 04:58:14','maximum size (in kbyte) o picture to upload'),('ips','','2009-06-12 00:34:45','list of IPs with no viewing restrictions'),('js','/default.js','2009-06-12 00:34:45','default javascript name'),('languages','en it fr nl de','2009-06-14 00:00:06','supported languages'),('limit','4','2009-06-12 00:34:45','max document to list'),('lockicon','lock.png','2009-06-17 02:06:50','lock closed icon'),('login','/cgi-bin/login.pl','2009-06-12 00:34:45','login script to use'),('logindefault','\"scrollbars=1,location=0,toolbar=no,menubar=no,status=0,width=790,height=590,resizable=yes\"','2009-06-12 00:34:45','default options for the login screen'),('loginicon','repeat.png','2009-06-14 10:33:12','login icon'),('logout','/cgi-bin/edituser.pl','2009-06-12 00:34:45','logout user script to use'),('logouticon','eject.png','2009-06-14 10:31:52','logout icon'),('maxsizeicon','10','2009-06-20 05:00:54','Maximum size of a user icon (in Kb)'),('mkthumb','convert -resize 64x64','2009-06-20 04:01:07','instruction used to resize and create thumbnails'),('pageadd','page_add.png','2009-06-30 13:48:04','page add icon'),('postnew','/cgi-bin/postnew.pl','2009-06-12 00:34:45','postnew script to use'),('preview','/cgi-bin/doc.pl','2009-06-12 00:34:45','preview script to use'),('previewicon','search.png','2009-06-14 10:26:53','preview icon (document edit form)'),('publishicon','favorite_add.png','2009-06-13 02:22:20','icon used in the publish command'),('pviewicon','search.png','2009-06-14 02:53:50','icon used for the preview (small)'),('replyicon','comment.png','2009-06-13 22:28:13','icon used in the reply comments command'),('resetpwd','key.png','2009-06-12 00:34:45','reset password icon'),('rssfeeddir','rss','2009-06-21 09:46:18','directory for RSS feed (relative to the base dir)'),('rssicon','rss.png','2009-06-14 10:27:03','rss feed icon'),('selecticon','accept.png','2009-06-13 02:44:40','icon used for the select command'),('templates-fh','270','2009-06-12 00:34:45','height for the edit template window'),('templates-fw','940','2009-06-12 00:34:45','width for the edit template window'),('templatesicon','application.png','2009-06-14 10:27:20','template icon'),('texts-fh','240','2009-06-12 00:34:45','height for the edit text window'),('texts-fw','750','2009-06-12 00:34:45','width for the edit text window'),('textsicon','word.png','2009-06-14 10:27:14','texts icon'),('thumbdir','thumbs','2009-06-20 03:39:08','subdir of the image/host dir where the thumbs are'),('title','CMS Fdt 4.0 - beta','2009-06-26 16:34:29','main title of the web site'),('topics','home.png','2009-06-12 00:34:45','document icon'),('unlockicon','lock_off.png','2009-06-17 02:06:39','lock open icon'),('unpublishicon','favorite_remove.png','2009-06-13 02:22:36','icon used in the un-publish command'),('upicon','user_accept.png','2009-06-17 03:01:55','Promote to root icon'),('uploaddir','/tmp/upload','2009-06-12 00:34:45','temporary directory for uploading'),('userdefault','\"scrollbars=1,location=0,toolbar=no,menubar=no,status=0,width=1000,height=630,resizable=yes\"','2009-06-12 00:34:45','default options for the user edit screen'),('userremoveicon','user_remove.png','2009-06-16 04:38:45','user remove icon'),('users-fh','690','2009-06-12 00:34:45','height fo the edit user window'),('users-fw','900','2009-06-12 00:34:45','width for the edit user window'),('usersicon','users.png','2009-06-14 10:27:29','users icon');
/*!40000 ALTER TABLE `configuration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `deftexts`
--

DROP TABLE IF EXISTS `deftexts`;
CREATE TABLE `deftexts` (
  `hostid` varchar(255) NOT NULL default 'localhost',
  `textid` varchar(255) NOT NULL default '',
  `language` varchar(2) NOT NULL default 'en',
  `content` varchar(255) default NULL,
  PRIMARY KEY  (`hostid`,`textid`,`language`),
  CONSTRAINT `deftexts_ibfk_1` FOREIGN KEY (`hostid`) REFERENCES `hosts` (`hostid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `deftexts`
--

LOCK TABLES `deftexts` WRITE;
/*!40000 ALTER TABLE `deftexts` DISABLE KEYS */;
INSERT INTO `deftexts` VALUES ('helpsite','next','en','next document'),('helpsite','next','it','prossimo documento'),('helpsite','nocomm','en','no comments'),('helpsite','nocomm','it','nessun commento'),('helpsite','onecomm','en','one comment'),('helpsite','onecomm','it','un commento'),('helpsite','postnew','en','post a comment'),('helpsite','postnew','it','aggiungi un commento'),('helpsite','previous','en','previous document'),('helpsite','previous','it','documento precedente');
/*!40000 ALTER TABLE `deftexts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `documents`
--

DROP TABLE IF EXISTS `documents`;
CREATE TABLE `documents` (
  `hostid` varchar(255) NOT NULL,
  `groupid` int(11) NOT NULL,
  `documentid` varchar(255) NOT NULL,
  `language` varchar(2) NOT NULL,
  `template` varchar(255) NOT NULL,
  `css` varchar(255) NOT NULL,
  `icon` varchar(255) NOT NULL,
  `rssid` varchar(255) NOT NULL,
  `display` enum('yes','no') NOT NULL default 'no',
  `approved` enum('yes','no') NOT NULL default 'no',
  `comments` enum('yes','no') NOT NULL default 'no',
  `status` enum('close','open') NOT NULL default 'open',
  `moderated` enum('yes','no') NOT NULL default 'yes',
  `moderator` varchar(255) NOT NULL,
  `author` varchar(255) NOT NULL,
  `created` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `updated` datetime default NULL,
  `published` datetime default NULL,
  `title` varchar(255) NOT NULL default 'default title',
  `excerpt` text,
  `content` text,
  `isdefault` enum('yes','no') NOT NULL default 'no',
  `is404` enum('yes','no') NOT NULL default 'no',
  PRIMARY KEY  (`hostid`,`groupid`,`documentid`,`language`),
  KEY `author` (`author`),
  KEY `moderator` (`moderator`),
  KEY `rssid` (`rssid`),
  KEY `hostid` (`hostid`,`template`),
  CONSTRAINT `documents_ibfk_1` FOREIGN KEY (`hostid`, `groupid`) REFERENCES `groups` (`hostid`, `groupid`),
  CONSTRAINT `documents_ibfk_2` FOREIGN KEY (`author`) REFERENCES `users` (`email`),
  CONSTRAINT `documents_ibfk_3` FOREIGN KEY (`moderator`) REFERENCES `users` (`email`),
  CONSTRAINT `documents_ibfk_4` FOREIGN KEY (`hostid`, `template`) REFERENCES `templates` (`hostid`, `templateid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `documents`
--

LOCK TABLES `documents` WRITE;
/*!40000 ALTER TABLE `documents` DISABLE KEYS */;
INSERT INTO `documents` VALUES ('helpsite',23,'10','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 19:01:42','2009-06-26 10:17:27','Basic principles','Basic principles','<p>In my definition of the system, the document is the king.</p>\n\n<p>A site (host) is defined as a collection of documents, each one of them can be composed by multiple\npart of standard text <b>and</b> some specific text.</p>\n\n<p>The document is connected to a <i>template</i> that specify how the various elements are displayed\non the screen (layout) and where other default bits (not dependent by the document) are displayed\nand if they are there at all.</p>\n\n<p><center>\n<!--img=pagestruct--><br>\nStructure of the page\n</center></p>\n\n<p>Various bits of texts can be loaded on-demand, either by being indicated in the template or by\nbeing indicated in the document itself.</p>\n\n<p>The document can also contains instructions that are executed to generate <i>lists</i> of\nother documents in various way.</p>\n\n<p>This way, changing the layout of a site is only a matter of defining a new template and\nattaching it to the pages you want to change.</p>\n\n<p>The \"instructions\" that can be inserted in the text to perform all these manipulations\nare called <i>metatags</i>, they look like html comments (&lt;!--somebitoftext--&gt;),\nso they do no harm if they are sent to the browser.</p>\n\n<p><!--ref=metatags-->Here</a> there is a list of all the available metatags with an\nexplanation of what they do.</p>\n\n<p>Editing a document is a matter of creating a file containing the text and the various\nmetatags, and then uploading on the system, associating it to a template. The document\nis $then rendered by the frontend putting all the pieces together.</p>\n\n<p>The system has a sophisticated permission and user scheme, that allow some users to\nonly have rights to manage documents, while others can manage templates and other\nthing.</p>\n\n<p>Documents can have <i>comments</i> and be either <i>moderated</i> or not. If a document\nis moderated, a <i>moderator</i> or the same <i>document author</i> will have to approve\nor reject the comments.</p>\n\n<p><b>Write a document</b></p>\n\n<p>After a little, I felt the need to write a bit about <i>how to write the document</i>. Now, the\ndocument (that could be \"the\" document or a fragment or any other bits of text that goes on\nthe screen) should be a \"normal\" HTML text. This means that it should adhere to the HTML\nstandard. This means that it should NOT contains any \"strange\" character and that everything\nshould be html-encoded. So in place of the &amp; use the &amp;amp; format, instead of the\nvarious accented characters, use the equivalent &amp;egrave; thing and so on.</p>\n\n<p>There are thousands of html editors that can makes things easier (or not), just pick\none.</p>\n\n<p><b>Templates</b></p>\n\n<p>A template is, as said, the container to specify the layout where all the other bits and\npieces are. As a rule of thumb, no \"real\" text should go into the template and it should\nonly contains &lt;table&gt; or &lt;div&gt; tags to divide the layout.</p>\n\n<p>To specify the text you use <b>fragments</b> or <b>default texts</b> that can be\nspecified in different <i>languages</i>.</p>\n\n<p><b>Fragments</b></p>\n\n<p>A Fragment is a little piece of HTML text that is placed on the page when requested by\nthe document or by the template. The fragment can contains other fragments or other stuff,\nit is usually a small piece, not so complex.</p>\n\n<p>Fragments have <b>languages</b>, this allow the creation of a multi-language page\nwithout too much trouble. If a fragment doesn\'t exists in the language the user is requesting,\nthe one in the <i>default</i> language will be provided.</p>\n\n<p><b>Default Texts</b></p>\n\n<p>Default texts are very similar to <b>fragments</b>, the main difference is that a default text\nis only placed on the page and not processed for <i>metatags</i>. This means that a\ndefault text can\'t contain another default texts or anything.</p>\n\n<p><b>Groups</b></p>\n\n<p>A group is (in my head) the equivalent of a Directory. It allows documents to be.. herr...\n\"grouped\" in a logical way. They are also used to generate lists of documents.</p>\n\n<p><b>Hosts</b></p>\n<p>An host is a big box to hold all the bits of the site. Templates, default texts, documents...\neverything related to a single host.</p>\n\n<p><b>Users</b></p>\n\n<p>To handle all the elements, or some of them, you need to login. By default, only the \"root\"\n(superuser) user exists, and that user has all the possible rights</p>\n\n<p>A user can be <i>owner</i> of different <i>hosts</i>, in that case he will be able to do\neverything inside those hosts.</p>\n','no','no'),('helpsite',23,'10','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 18:54:22','2009-06-29 13:03:41','Principi di base','Principi di base del CMS','<p>Nella mia definizione del sistema, il documento e\' il Re.</p>\n\n<p>Un sito (host) e\' definito come una collezione di documenti, ognuno dei quali puo\' essere composto\nda molteplici parti di testo standard <b>e</b> testo specifico per il documento.</p>\n\n<p>Il documento e\' connesso ad un <i>template</i> che specifica come le varie parti sono messe \ninsieme sulla pagina risultante e dove ogni elemento deve essere visualizzato. Ogni parte\nche non e\' specificamente del documento e\' definita in un <i>frammento</i> di testo che\nviene incorporato dal template o dal documento stesso.</p>\n\n</p>\n<center>\n<!--img=pagestruct--><br>\nStruttura di una pagina\n</center></p>\n\n<p>Il documento puo\' includere istruzioni per generare <i>liste</i> o <i>elenchi</i> di\naltri documenti letti dal sistema in vari modi.</p>\n\n<p>In questo modo, cambiando il template cambiano tutte le pagine che sono associate\na tale template.</p>\n\n<p>Le \"istruzioni\" che sono usate per eseguire le varie manipolazioni sono dette\n<i>metatag</i>, questi sono esattamente come dei commenti html (&lt;!--somebitoftext--&gt;),\nin questo modo non ci sono danni se sono visti dal browser dell\'utente.</p>\n\n<p><!--ref=metatags-->Qui</a> c\'e\' un elenco di tutti i metatag disponibili.</p>\n\n<p>Creare o modificare un documento e\' solo questione di scrivere un file contenete\nil testo che si vuole visualizzato, aggiungere tutti i metatag richiesti, uploadare il\ntutto nel sistema, associarlo ad un template e \"pubblicarlo\". Il documento verra\'\nmesso insieme dal frontend ed inviato al browser dell\'utente.</p>\n\n<p>Il CMS ha un sofisticato sistema di permessi ed utenti che consente di suddividere le\nresponsabilita\' di gestione degli host e dei documenti tra diversi utenti.</p>\n\n<p>I documenti possono avere <i>commenti</i> e possono essere <i>moderati</i> o no.\nSe un documento e\' moderato, un <i>moderatore</i> che potrebbe essere lo stesso o meno\ndell\'autore dovra\' verificare i commenti ed eventualmente approvarli o cancellarli.</p>\n\n<p><b>Scrivere il documento</b></p>\n\n<p>Dopo un po\', mi sono sentito in dovere di aggiungere questo mini-paragrafo riguardante la\nscrittura dei documenti. Il documento (che sia il <b>documento</b> o un altro pezzo di\ntesto che finira\' visualizzato sulla pagina) dovrebbe seguire gli standard HTML. Il che\nsignifica che <i>sarebbe opportuno</i> che tutti i caratteri \"strani\" siano sostituiti con\nl\'equivalente codice html per la generazione dello stesso (per esempio invece dei \ncaratteri accentati gli equivalenti &amp;egrave; e cosi\' via). Esistono tonnellate di editor\nHTML che possono generare un documento html \"al volo\" senza doversi preoccupare troppo.\nSceglietene uno.</p>\n\n<p><b>Templates</b></p>\n\n<p>Un template e\', come detto precedentemente, solo il <i>contenitore</i> che e\' usato\nper posizionare i vari elementi sulla pagina. A regola, non dovrebbe contenere\nnessun testo vero e proprio che viene visualizzato.</p>\n\n<p>Per il testo si usano i <i>frammenti</i> o i <i>testi di default</i>, che sono\ndisponibili in lingua.</p>\n\n<p><b>Frammenti</b></p>\n\n<p>I frammenti sono usati per gestire parti della pagina che sono sempre costanti tra\nvari documenti. Al posto di inserire il testo nel template, e\' possibile rachiuderlo\nin un <i>frammento</i> che viene poi a sua volta incluso nel template.</p>\n\n<p>Il vantaggio di questo approcio e\' che i frammenti sono disponibili in diverse lingue\ne possono essere condivisi tra diversi templates.</p>\n\n<p><b>Testi di default (deftexts)</b></p>\n\n<p>Simili ai frammenti, ma in genere limitati a pochissime parole.</p>\n\n<p><b>Gruppi</b></p>\n\n<p>I <b>gruppi</b> consentono di raggruppare i documenti in modo logico e vengono usati per\ncostruire liste ed elenchi di documenti da presentare sullo schermo. In effetti, un\ndocumento non puo\' esistere senza un gruppo. La gestione dei gruppi e\' integrata in quella\ndei documenti. Prima di poter creare un documento, occorre creare il gruppo che lo\ncontiene.</p>\n\n<p><b>Hosts</b></p>\n\n<p>Un <i>host</i> altro non e\' che un grosso contenitore per tutti gli elementi che\ncostituiscono un sito, gruppi, documenti, templates, testi, frammenti, tutto e\'\ncollegato ad un host.</p>\n\n<p>Diversi hosts possono coesistere nel sistema senza confondersi tra di loro.</p>\n\n<p><b>Utenti</b></p>\n\n<p>Per gestire i vari elementi del sistema occorre avere un utente. Di default, solo\nl\'utente \'root\' (superutente) esiste, e tale utente ha tutti i privilegi disponibili.</p>\n\n<p>Un utente puo\' avere diversi <i>hosts</i> assegnati, in tal caso diventera\'\n<i>amministratore dell\'host</i> e potra\' creare gruppi, templates, documenti eccetera\nper quell\'host.</p>\n','no','no'),('helpsite',23,'15','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-21 05:05:08','2009-06-21 09:13:19','The Backoffice','The backoffice, a quick tour','The <i>Backoffice</i> is the part of the CMS that is used to add, remove and manage\nthe sites\' content. Is the really important part that no \"normal\" viewer of a web\nsite get to see.<p>\n\nTo access the backoffice you have to type the URL in the address bar. The default\ninstall create a virtual host simply named \'CMS\', see the\n<!--ref=Download and installation-->Download and installation</a> section.<p>\n\nIf somebody installed the CMS for you, ask the sysadmin.<p>\n\nAccessing the b.o. immediately you need to login, once logged in you\'ll see the\nbasic interface.<p>\n\n<center>\n<!--img=bo_justlogin:width=\'600\' height=\'400\':1-->\n</center><p>\n\nThe first thing you can do at this point is to <b>select an host</b> to work with. If\nyou don\'t, the only thing you can do is to manage users or configuration paramters\n(if you are root). Once you\'ve selected an host, the other functions will become\neffective.<p>\n\nTo select an host, simply click on the corresponding \'select\' icon\n<img src=\'/icons/16x16/select.png\'>\nat the right side of the window.<p>\n\n<b>Quick tour of the user interface</b><p>\n\nRegardless of what you are going to do, you\'ll see more or less the same interface. The\nscreen is divided into <i>sections</i>.<p>\n\n<center>\n<!--img=bo_interface:width=\'600\':1-->\n</center><p>\n\nAt the top, right after the title, are reported the <b>current host</b> and the\n<b>current user</b>, on the far right 3 icons allow you to access the help site\n(on the internet or a local copy), open the user\'s edit screen and logout.<p>\n\nRight below the title you can see the <b>system icons</b>, these allow access to all\nthe other functions of the system. Depending by the user, different icons will be\ndisplayed, if you\'re root, you\'ll see all of them. If you\'re only a Document\nadministrator, you won\'t see the \'users\' and \'config\' icons.<p>\n\nThe central part of the screen is reserved to show (in a list fashion) the informations\nthat we are going to manage. Depending by the function selected the list changes. In any\nevent, the first line contains a quick \"reminder\" of which functions are available for\nthat specific functionality. Note that these icons do nothing, they are just to\nremind you.<p>\n\nThe <b>action icons</b> are on the right side of the screen, associated with each\n\'object\' displayed in the list.<p>\n\nAgain, depending by your authority level, you could see more or less functions.<p>\n\nIf the user has enough privileges, on the right side of the \'reminder\' line there will\nbe a green \"+\" sign \n(<img src=\'/icons/16x16/add.png\'>), this is used to add a new element to the list,\nif this icon does not appear, you don\'t have enough privileged to add more items.<p>\n\nUsually the icons that are always present are:<p>\n\n<ul>\n<li><img src=\'/icons/16x16/remove.png\'> Remove. This remove the selected element,\neventually removing all the related elements. Use with care.\n<li><img src=\'/icons/16x16/add.png\'> Add. Is used to add more elements.\n<li><img src=\'/icons/16x16/windows.png\'> Copy. It makes a copy of the selected\nelement and then allow to change the newly created element.\n</ul><p>\n\nThe \"copy\" function allow the quick duplication of an element, in fact, this function\nsimply call the \'edit\' function with pre-initialized values.<p>\n\nIn addition of these functions, some screens have more specific functionalities\n(approve documents/comments and so on).<p>\n\nThe <b>editing</b> of an element is usually done by clicking on the <b>link</b> on the\nleft side of the screen.<p>\n\n<b>The copy doesn\'t copy</b><p>\n\nWarning: the copy function does NOT copy the contents of documents, templates and\nfragments. It only copy the general data. The content have to be added in the \"usual\"\nway.<p>\n\n<b>Editing or adding of objects</b><p>\n\nTo add or edit an object you the system will display a special dialog box, one for\neach different object. Usually, clicking on the \'cancel\' button will simply close\nthe dialog with nothing done, while clicking on the \'ok\' button will perform the\nchanges and then close the box.<p>\n\n<center>\n<!--img=edithost:width=\'600\':1-->\n</center><p>\n\nThe add/edit functions for Templates and Documents <b>do not</b> close the window\nafter performing the editing. This allow editors to makes same changes, see the result\nin the preview window, makes more changes and so on.<p>\n\nBasic differences between the editing and adding of an object is that some informations\nonce entered cannot be changed later.<p>\n\n<b>Icons selection</b><p>\n\nSome screens requires/allows to select \"icons\". Usually the available icons are displayed\nin a box and simply clicking on an icon select the clicked icon and display it in a \nspecific spot on the screen.<p>\n\n<b>Special functions</b><p>\n\nSome screens uses special functions, these are usually in the title bar, at the right of\nthe window. For example, the edit document window has a \'preview\' icon that allow the\neditor to see a preview of the document.<p>\n\n','no','no'),('helpsite',23,'15','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-21 05:06:14','2009-06-21 08:32:43','Il Backoffice','Un rapido tour del backoffice','Il <i>Backoffice</i> e\' la parte del CMS che si utilizza per gestire, aggiungere,\nrimuovere e manipolare il contenuto del sito e gli altri siti. E\' la parte che chi\nvisita semplicemente il sito non vede mai.<p>\n\nPer accedere al backoffice e\' necessario digitare l\'indirizzo (URL) dello stesso\nnella barra del titolo. L\'installazione di default crea un host chiamato semplicemente\n\"cms\" per questo scopo. Vedere la sezione\n<!--ref=Download ed Installazione-->Download ed Installazione</a> al riguardo.<p>\n\nSe il CMS e\' stato installato per voi, domandate all\'Amministratore di sistema come\naccedervi.<p>\n\nAccedendo al b.o. per la prima volta viene richiesto di fare login, una volta fatto\ncio\' si puo\' vedere l\'interfaccia di base.<p>\n\n<center>\n<!--img=bo_justlogin:width=\'600\' height=\'400\':1-->\n</center><p>\n\nLa prima cosa da fare a questo punto e\' <b>selezionare un host</b>. Se non si \nseleziona un host, le uniche funzioni disponibili saranno la gestione degli\nutenti e dei parametri di configurazione. Nessuna delle altre funzionalita\' sara\'\noperativa.<p>\n\nPer selezionare un host, cliccare sull\'icona di selezione\n<img src=\'/icons/16x16/select.png\'>\ncorrispondente sulla destra.<p>\n\nUna volta selezionato l\'host, sara\' possibile gestire tutte le informazioni\nrelative a quello specifico host.<p>\n\n<b>L\'interfaccia di gestione</b><p>\n\nTutte le funzioni di gestione seguono la stessa struttura, l\'interfaccia di gestione e\'\ndivisa in varie <i>sezioni</i>.<p>\n\n<center>\n<!--img=bo_interface:width=\'600\':1-->\n</center><p>\n\nNella parte alta, subito a destra del titolo sono riportati <b>l\'host corrente</b>\ne <b>l\'utente</b> con cui si e\' fatto login. Sulla destra, 3 icone consentono di accedere\nall\'help in linea (che puo\' essere direttamente su internet o una copia locale),\naprire la maschera di configurazione dell\'utente o fare logout.<p>\n\nImmediatamente sotto vi sono le <b>icone di sistema</b>, queste consentono di accedere alle\nvarie funzioni di gestione. Notare che <b>non tutti gli utenti vedono tutte le funzioni</b>,\nse l\'utente e\' un <i>superutente</i>, tutte le icone sono  mostrate, se l\'utente e\'\nun <i>host administrator</i> vedra\' solo le icone relative agli host\n(le icone \"users\" e \"config\" non sono mostrate), e cosi\' via.<p>\n\nLa parte centrale dello schermo e\' riservata per la visualizzazione dei dati. Questi\ndati dipendono (ovviamente) dalla funzione che si e\' selezionata. In ogni caso, la\nprima linea e\' riservata ad una descrizione delle <b>icone operative</b> che sono\ndisponibili per la gestione delle informazioni. Queste sono solo per ricordare\nall\'utente cosa fa\' ogni icona.<p>\n\nLe <b>icone operative</b> appaiono sulla destra dello schermo, associate con ogni \"riga\"\ndella lista visualizzata.<p>\n\nAnche in questo caso, diversi utenti possono vedere diverse icone.<p>\n\nSe l\'utente ha i diritti necessari, nella stessa linea sulla destra viene visualizzata\nuna icona di aggiunta (<img src=\'/icons/16x16/add.png\'>), questa serve ad aggiungere\nvoci all\'elenco. Se l\'utente non puo\' aggiungere voci, l\'icona non compare.<p>\n\nLe icone disponibili in genere sono:<p>\n\n<ul>\n<li><img src=\'/icons/16x16/remove.png\'> Cancella. Elimina l\'elemento selezionato,\neventualmente anche tutti gli elementi che dipendono da questo elemento. Usare con\nmolta cautela.\n<li><img src=\'/icons/16x16/add.png\'> Aggiungi. Consente di aggiungere elementi\n<li><img src=\'/icons/16x16/windows.png\'> Copia. Consente di \"copiare\" un elemento in un\nnuovo elemento.\n</ul><p>\n\nLa funzione di \"copia\" consente di duplicare rapidamente una voce, in effeti questa\nrichiama sempre la funzione di \'aggiunta\' ma con i dati preimpostati con quelli \ndell\'elemento che si e\' \"copiato\".<p>\n\nOltre alle funzioni sopracitate, diverse funzioni hanno icone specifiche (approvazione \ndi documenti, gestione commenti etc.).<p>\n\nLa <b>modifica</b> di una voce in genere si attua facendo click sul link alla sinistra\ndell\'elenco.<p>\n\n<b>La copia non copia</b><p>\n\nUna nota importante riguardo la funzione di \"copia\": la \"copia\" di un documento, template o\nframmento <b>non copia il contenuto</b> dello stesso, ma solo le informazioni\ngenerali associate, il contenuto deve essere aggiunto in seguito.<p>\n\n<b>Editing o aggiunta di oggetti</b><p>\n\nPer modificare o aggiungere un oggetto si usano delle maschere di dialogo specifiche\nper ogni oggetto. La maschera viene visualizzata in una finestra separata. In genere,\ncliccare sul pulsante \"cancel\" serve a chiudere la finestra senza apportare alcuna\nmodifica, mentre cliccare sul pulsante \"ok\" esegue l\'aggiunta o modifica.<p>\n\n<center>\n<!--img=edithost:width=\'600\':1-->\n</center><p>\n\nLe funzioni di aggiunga/modifica dei template e dei documenti <b>non chiudono</b> la\nfinestra dopo aver eseguito i cambiamenti, in questo modo e\' possibile fare un refresh\ndel sito e vedere immediatamente i cambiamenti apportati ed eventualmente apportarne\naltri senza dover richiamare di nuovo la stessa finestra di editing.<p>\n\nLa differenza fondamentale tra l\'editing e l\'aggiunta di elementi e\' che certi\nvalori, una volta inserito l\'elemento nel sistema, non possono piu\' essere modificati.<p>\n\n<b>Selezione di icone</b><p>\n\nAlcune maschere di editing consentono la selezione di una icona, per esempio i\ndocumenti e gli utenti. Le icone sono in genere mostrate in un elenco, cliccare\nsull\'icona desiderata la seleziona automaticamente.<p>\n\n<b>Funzioni \"speciali\"</b><p>\n\nAlcune maschere di editing hanno delle funzioni \"speciali\", queste sono, di solito,\nriportate nella linea del titolo della finestra. Per esempio la maschera di editing\ndei documenti ha una icona per la visualizzazione di un <i>preview</i> del\ndocumento.<p>\n\n','no','no'),('helpsite',23,'20','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 19:02:12','2009-06-21 08:09:08','Users and permissions','Users and permissions','Users are primarily used to identify <i>owners</i> of elements in the system. A user\ncan be <i>superuser</i>, <i>host owner</i>, <i>group owner</i>, <i>document owner</i>\nor simply a <i>moderator</i>.<p>\n\nThe <i>superuser</i> is the master of the whole system, he can create more hosts,\ncreate and manage users, and basically do everything.<p>\n\nThe <i>host owner</i> can create and destroy elements inside his hosts, but he can\'t\ncreate new users or change values of the configuration parameters.<p>\n\nBelow the host owner is the <i>group owner</i>, whose can create documents\ninside his own group and perform any change on the documents of such group, but\ncan\'t create other groups or other things.<p>\n\nA level even lower is the <i>document owner</i>, this is (as the name suggest)\nthe owner (or author) of a document and can manage that document but nothing\nmuch more.<p>\n\nThe lowest level of authority is the <i>moderator</i>, who can only manage comments\non documents.<p>\n\nThe following picture shows how the various authority overlaps.<p>\n<center>\n<!--img=userlayer:width=\'600\' height=\'400\':1-->\n</center><p>\n\nNote that is possible to completely manage the whole system with just one \'root\'\nuser and nothing more. The use of multiple users is, however, recommended when \nhandling larger project that involve multiple persons.<p>\n\n<b>Users\' management</b><p>\n\nTo manage users you need to be the <i>root</i> user. If you login in the system as\nthe root user, you\'ll see the \"user\" icon \n<img src=\'/icons/16x16/users.png\'>\nin your icon bar.<p>\n\nThis will call the users\' management function that will display a list of all the\nusers of the system. If you\'ve just installed the system you\'ll se just one\nuser: the root user.<p>\n\n<center>\n<!--img=userlist:width=\'600\' height=\'400\':1-->\n</center><p>\n\nFor each user are given a series of informations: the \"icon\" of the user, the e-mail,\nthe user\'s name, when he was created, the last time he logged in (if this information\nis empty, it means the user never logged in the system) and the number of posts \n(comments) and documents. A list of all the documents that the user has at his name \nis also displayed. Clicking on one of the document will call a display of the same\ndocument in a new window.<p>\n\nOn the right side of each user, you\'ll see a series of icons, each one has a double\nfunctions: they\'ll tell you something about the user, and if you click on them\nsomething will happen to the user itself. The functions are:<p>\n\n<ul>\n<li><img src=\'/icons/16x16/remove.png\'> remove the current user<br>\nIf the user has comments, documents or other things, all of them will be assigned\nto the currently logged in user (root).<br>\n<li><img src=\'/icons/16x16/user.png\'> this icon indicate that the user is a \"normal\"\nuser, clicking on it, the user will be turned into a \"superuser\" with root\nability.<br>\n<li><img src=\'/icons/16x16/user_add.png\'> this icon indicate that the user is a \"root\"\nuser, clicking on it the user will be \'demoted\' to normal user.<br>\n<li><img src=\'/icons/16x16/lock.png\'> clicking on this icon will generate a random\npassword and send it to the user.<br>\n<li><img src=\'/icons/16x16/user_remove.png\'> this icon indicate that the user has a valid\npassword, clicking on it will disable the user.<br>\n<li><img src=\'/icons/16x16/accept.png\'> this icon indicate that the user doesn\'t have\na password or has been disabled, clicking on it will generate a new password and\nsent it to the user, enabling it.\n</ul>\n<p>\n\nA \"reminder\" of the functionalities is always displayed just below the main icons at the\ntop of the screen.<p>\n\nOn the right side of that line you should see a green \"+\" sign\n(<img src=\'/icons/16x16/add.png\'>)\nclicking this icon is possible to add a new user to the system.<p>\n\nTo edit an existing user, simply click on the icon or on the e-mail shown in the\nlist.<p>\n\nBoth the editing and adding of the user is done through the Edit user window.<p>\n\n<center>\n<!--img=edituser:width=\'600\' height=\'400\':1-->\n</center>\n<p>\n\nOnly the superuser can change the password for some other user. Normal users can only\nchange their own password.<p>\n\nThe \"description\" area at the bottom of the window is used to add user\'s descriptions\nin different languages. The descriptions can be then displayed on documents that\nbelongs to that user by using the metatag &lt;!--author--&gt;<p>\n\nA user can upload a personalized \"avatar\" (icon), the maximum size of the icon\nis specified in the configuration parameters.<p>\n\nNote that, in the edit window, there is no way to change either the username or\nthe e-mail once added to the system. If somebody wants to change e-mail, the only\nway to do it is to add a new user, temporarily promote him to \'root\' user, login\nas the new user and then delete the old one. This way, all the posts and documents\nwill be attributed to the new user in automatic.<p>\n\n<b>Attributing different permissions</b><p>\n\nYou don\'t do it from the users\' management. You do it directly in the\nHosts, Groups or Documents management.<p>\n\n','no','no'),('helpsite',23,'20','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 18:55:12','2009-06-21 08:08:38','Utenti e permessi','Differenti utenti e struttura dei permessi','Gli utenti sono usati principalmente per identificare il <i>proprietario</i> di un\nelemento nel sistema. Un utente puo\' essere <i>superutente</i> (root),\n<i>proprietario di sito</i>, <i>proprietario di gruppo</i>, \n<i>proprietario di documento</i> o semplicemente <i>moderatore</i>. Ed un singolo\nutente puo\' anche essere piu\' di una di queste cose allo stesso tempo.<p>\n\nIl <i>superutente</i> e\' il capo di tutto il sistema, lui puo\' creare piu\' hosts,\ngruppi, aggiungere e rimuovere utenti... praticamente tutto.<p>\n\nIl <i>proprietario di host</i> puo\' creare e distruggere elementi all\'interno\ndell\'host ma non puo\' creare o gestire nuovi host o utenti.<p>\n\nAl di sotto del livello di host, c\'e\' il <i>proprietario di gruppo</i>, che puo\'\ncreare o rimuovere documenti all\'interno dei suoi gruppi ma non puo\' fare niente\nal di sopra di questo livello.<p>\n\nAncora piu\' in basso c\'e\' <i>l\'autore di documento</i>, che puo\' gestire i propri\ndocumenti ed i commenti, ma non puo\' creare nuovi documenti.<p>\n\nAll\'ultimo livello c\'e\' il <i>moderatore</i> che puo\' solo approvare o cancellare\ncommenti.<p>\n\nQuesto e\' un diagramma di come i vari permessi si sovrappongono.<p>\n<center>\n<!--img=userlayer:width=\'600\':1=-->\n</center><p>\n\nE\' possibilissimo gestire l\'intero sistema con un solo utente \"root\". L\'uso di\nutenti diversi tuttavia, e\' raccomandabile per progetti piu\' vasti in cui le\ncompetenze sono distribuite tra varie persone.<p>\n\n<b>Gestione utenti</b><p>\n\nPer gestire gli utenti dovete avere privilegi di superutente. Se avete fatto login\nnel sistema come \'root\', vederete l\'icona degli utenti\n<img src=\'/icons/16x16/users.png\'>\nnella barra delle icone nella parte alta dello schermo.<p>\n\nTramite quella icona si accede alla funzione di gestione degli utenti, che visualizza\nun elenco degli utenti nel sistema. Se avete appena installato il sistema, gli unici\nutenti presenti sono root e l\'utente \'anonymous\'.<p>\n\n<center>\n<!--img=userlist:width=\'600\':1-->\n</center><p>\n\nPer ogni utente sono visualizzate una serie di informazioni: l\'icona (avatar) \ndell\'utente, l\'e-mail, il nome, quando e\' stato registrato e quando ha fatto\nlogin per l\'ultima volta, il numero di post (commenti) ed il numero di documenti\nappartententi a questo utente. Nella riga inferiore vengono riportati tutti \ni documenti di questo utente.<p>\n\nNell\'ultima colonna a destra vengono riportate una serie di icone che forniscono\nulteriori informazioni e consentono di \"operare\" sull\'utente.<p>\n\n<ul>\n<li><img src=\'/icons/16x16/remove.png\'> rimuove l\'utente.\nSe l\'utente ha documento o commenti, tutti questi verranno associati con l\'utente\ncorentemente loggato e poi l\'utente verra\' cancellato.<br>\n<li><img src=\'/icons/16x16/user.png\'> questa icona indica che l\'utente e\' un \"normale\"\nutente, cliccandola l\'utente verra\' \"promosso\" a superutente<br>\n<li><img src=\'/icons/16x16/user_add.png\'> indica che l\'utente ha privilegi di \nsuperutente, cliccandola verra\' \"ridotto\" ad utente normale.<br>\n<li><img src=\'/icons/16x16/lock.png\'> reset della password dell\'utente. La nuova\npassword viene automaticamente inviata via mail all\'utente.<br>\n<li><img src=\'/icons/16x16/user_remove.png\'> l\'icona indica che l\'utente ha una\npassword valida, cliccandola l\'utente viene <i>disabilitato</i>.\n<li><img src=\'/icons/16x16/accept.png\'> l\'icona indica che l\'utente si e\' appena\nregistrato e non ha una password. Cliccandola una nuova password viene inviata\ne l\'utente e\' reso \"attivo\".\n</ul>\n<p>\n\nNella riga sotto le icone di sistema e\' sempre presente una indicazione di cosa fanno\nle varie icone.<p>\n\nNella stessa linea, sulla destra e\' presente un \"+\" verde\n(<img src=\'/icons/16x16/add.png\'>)\nche consente di aggiungere un nuovo utente al sistema.<p>\n\nPer modificare un utente esistente, fare click sull\'indirizzo di mail.<p>\n\nPer modificare o aggiungere un nuovo utente si utilizza la maschera di modifica\ndell\'utente.<p>\n\n<center>\n<!--img=edituser:width=\'600\':1-->\n</center>\n<p>\n\nSolo il superutente puo\' cambiare la password per qualche altro utente, normali\nutenti possono solo cambiare la propria di password.<p>\n\nL\'area \"descrizione\" in basso e\' usata per aggiungere o modificare le\ndescrizioni in lingua per l\'utente. Queste descrizioni possono essere visualizzate\nnei vari documenti di proprieta\' dell\'utente usando il metatag \n&lt;!--author--&gt;<p>\n\nUn utente puo\' aggiungere una icona personalizzata, la dimensione massima di icona\ne\' specificata nei parametri di configurazione.<p>\n\nNotare che, nella maschera di modifica, non c\'e\' modo di cambiare il nome utente\no la mail. Se qualcuno vuole cambiare tali informazioni l\'unica e\' creare un nuovo\nutente, assegnargli diritti di superutente, fare login come tale utente, quindi\nrimuovere il vecchio utente e per ultimo rendere l\'utente di nuovo \"normale\"\nutente.<p>\n\n<b>Assegnare differenti permessi</b><p>\n\nI permessi vengono assegnati agli utenti rendendoli \"proprietari\" (owner) dell\'oggeto\na cui si vogliono dare permessi.<p>\n\n','no','no'),('helpsite',23,'30','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 19:02:41','2009-06-21 09:40:59','Hosts','Hosts management','The <b>hosts</b> function is used to manage the hosts, an Host is like a container that is\nused to collect all the element for a web site (documents, templates, texts, picture).<p>\n\nOnly the superuser can add or remove hosts.<p>\n\n<center>\n<!--img=hosts:width=\'600\':1-->\n</center><p>\n\nEach host has an <b>owner</b>, this is the user that can handle every information\ninside the host (creating new documents, templates and so on), an host owner will be\nable to select and edit his own host to manage it, but will only be able to select\nsomebody else host without any editing possibility.<p>\n\n<b>Host information</b><p>\n\nEach host has a series of <i>default</i> information that are used when new elements\nare added or searched for that host.<p>\n\n<center>\n<!--img=edithost:width=\'600\':1-->\n</center><p>\n\n<ul>\n<li><b>CSS</b> specify the default CSS that is reported in every document, the CSS\ncan be changed later on the group or the document itself.\n<li><b>default language</b> is the language that is automatically selected when a new\ndocument, fragment or template is created, and is the language that is used if the\nuser\'s browser doesn\'t specify a language or the specified one isn\'t found in the\nsite.\n<li><b>owner</b> is the host owner, is also the default user that is used as\nowner/author for documents and groups.\n</ul>\n<p>\n\nOnly the superuser can change the owner of an host.<p>\n\n<b>Aliases</b><p>\n\nThe <b>aliases</b> play an important role in the host structure. How does the CMS\nunderstand which site a user wants when he arrives? He looks at the aliases.<p>\n\nWhen a user type \'www.something.com\' in the address bar, the browser look up the\nip address of the site and then send a request to that machine. The system at this\npoint intercept the request and has to figure out which host is the correct one.\nTo do so, it try to match the hostname typed by the user (www.something.com) with\nany of the aliases inserted for the host. This means that the aliases <b>must</b>\ncontains all the possible version of an host name.<p>\n\nNote tha the system perform a <i>partial</i> match anyway, so an alias\n\'www.something.com\' will match also \'something.com\' or \'thing.com\'.<p>\n\n<b>CSS</b><p>\n\nThe CSS is the default css that is reported in every document created for the host.\nIt goes without saying that the CSS has to exist.<p>\n\n<b>Images</b><p>\n\nWhen a new host is created, a directory for the images is automatically created\n(if the system has the correct OS rights to do so), otherwise the sysadmin will\nhave to manually create the directory.<p>\n\nThe same way, when an host is removed, all the associated images are removed with it.<p>\n\n','no','no'),('helpsite',23,'30','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 18:57:05','2009-06-21 09:51:45','Gestione degli host','Differenti hosts','La funzione di gestione degli <b>host</b> consente di creare e mantenere gli host del \nsistema, un host e\' un grosso contenitore che raccoglie tutti gli elementi di un sito\n(documenti, templates, testi, immagini...).<p>\n\nSolo il superutente puo\' aggiungere o rimuovere hosts.<p>\n\n<center>\n<!--img=hosts:width=\'600\':1-->\n</center><p>\n\nOgni host ha un <b>owner</b> (proprietario), questo utente e\' autorizzato a modificare\nle informazioni relative all\'host e gestire tutti gli elementi che l\'host contiene\n(creare nuovi gruppi, documenti etc.). Un proprietario puo\' selezionare altri hosts,\nma non puo\' gestire hosts di cui non e\' proprietario. Allo stesso modo non e\'\nautorizzato a <b>cancellare</b> i propri host.<p>\n\n<b>Informazioni riguardo l\'Host</b><p>\n\nOgni host contiene una serie di informazioni che sono usate come <i>default</i> quando\nvengon creati nuovi elementi o quando un elemento viene cercato ma non trovato.<p>\n\n<center>\n<!--img=edithost:width=\'600\':1-->\n</center><p>\n\n<ul>\n<li><b>CSS</b> specifica il css di default per i documenti, ogni documento puo\' \ncomunque specificare un suo css personale.\n<li><b>default language</b> specifica il linguaggio di default dell\'host che viene\nproposto sui vari documenti, frammenti etc. ed e\' il linguaggio usato se il browser\ndell\'utente non specifica nessun linguaggio o nessun linguaggio presente per\nl\'host.\nsite.\n<li><b>owner</b> e\' il proprietario dell\'host.\n</ul>\n<p>\n\nSolo il superutente puo\' cambiare il proprietario di un host.<p>\n\n<b>Aliases</b><p>\n\nGli <b>aliases</b> giocano una parte molto importante nella struttura del sito. Come\nfa\' il cms a capire quale host un utente vuole quando digita qualche cosa sulla \nbarra degli indirizzi del browser? Usando gli alias.<p>\n\nQuando un utente digita \'www.qualcosa.com\' nella barra, il browser cerca l\'indirizzo\nip del server corrispondente ed invia una richiesta con quel nome host dentro al\nserver trovato. Il cms a questo punto legge il nome dell\'host e cerca un Host in cui\nuno degli alias corrisponde con quanto cercato dall\'utente. Questo significa che\ngli alias devono contenere tutti i nomi con cui un host e\' riconosciuto.<p>\n\nNotare che il sistema esegue sempre una ricerca parziale, il che significa che\n\'www.qualchecosa.com\' come alias corrispondera\' ad una ricerca per \'www.qualchecosa.com\'\nma anche a \'qualchecosa.com\' e \'cosa.com\'.<p>\n\n<b>CSS</b><p>\n\nIl CSS e\' il css di default da usare nei documenti. Ovviamente deve esistere.<p>\n\n<b>Immagini (images)</b><p>\n\nQuando un host e\' creato, una directory per le immagini viene creata automaticamente\ndal sistema (se ne ha i diritti a livello OS), in caso tale directory non possa essere\ncreata, il sysadmin dovra\' farlo a mano.<p>\n\nQuando un host viene eliminato, la directory e tutte le immagini viene eliminata.<p>\n\n','no','no'),('helpsite',23,'32','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-20 16:13:17','2009-06-21 12:37:29','Default texts','Default texts','The default texts are used to display the correct translation for small parts of the\ndocument. Usually is a matter of one or two words that are displayed without special\nmodification or style. Or using the internal style of the CSM.<p>\n\nBasic difference between <i>fragments</i> and <i>deftexts</i> is that the latters\nare not processed before display. So a deftext can\'t contain <i>metatags</i>. They\ncan, however, contain normal html tags.<p>\n\nNote tha some default texts are automatically added by the system when a new\nhost is created, those texts are used for internal manipulation.<p>\n\nOnly the superuser and the host owner can manage deftexts.<p>\n\nClicking on the \'text\' icon <img src=\'/icons/16x16/word.jpg\'> the list of deftexts\nfor the selected host is displayed.<p>\n\n<center>\n<!--img=deftexts:width=\'600\':1-->\n</center><p>\n\nIn this function is available the <b>copy</b> option to copy an existing text and then\nchange the language.<p>\n\nThe editing screen is restricted to the text itself.<p>\n\n<center>\n<!--img=edittext:width=\'600\':1-->\n</center><p>\n\nDefault texts can be inserted in the document or in templates using the\nmetatag &lt;!--getatext=...--&gt; specifying the textid of the text.<p>\n','no','no'),('helpsite',23,'32','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-20 16:13:42','2009-06-21 12:32:36','Testi di default','Testi di default','I testi di default (deftexts) sono usati per fornire la traduzione in lingua di piccole\nparti del documento. In genere si tratta di elementi minimi (una o due parole), che\nvengono visualizzate senza un particolare stile o con lo stile di un elemento\ninterno del cms.<p>\n\nA differenza dei <i>Frammenti</i>, i testi non sono elaborati ulteriormente prima di\nessere visualizzati, quindi non possono conetenere <i>metatags</i>. Possono tuttavia\ncontenere tag html.<p>\n\nNotare che alcuno testi di default sono automaticamente inseriti dal sistema quando \nun nuovo host viene creato. Questi testi sono quelli usati dai meccanismi interni del\nCMS.<p>\n\nSolo superusers e host owners possono accedere ai testi di default.<p>\n\nCliccando sull\'icona dei testi <img src=\'/icons/16x16/word.jpg\'> viene visualizzato\nl\'elenco dei testi presenti per l\'host.<p>\n\n<center>\n<!--img=deftexts:width=\'600\':1-->\n</center><p>\n\nNella gestione dei testi e\' possibile usare la funzione <b>copia</b> per copiare\nun testo esistente e poi cambarne la lingua.<p>\n\nLa maschera di editing dei testi consente l\'aggiunt e la modifica di un testo\nesistente. Nel caso della modifica l\'unica cosa moificabile e\' il testo stesso.<p>\n\n<center>\n<!--img=edittext:width=\'600\':1-->\n</center><p>\n\nI testi di default possono essere inseriti in un documento usando il\ntag &lt;!--getatext=...--&gt; specificando l\'id del testo stesso. Il CMS\ncerca automaticamente un testo nella lingua adatta o quello della lingua\ndi default dell\'host se non presente.<p>\n\n','no','no'),('helpsite',23,'35','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-20 16:14:38','2009-06-21 12:50:49','Fragments','Fragments','Similar to <!--ref=Default texts-->default texts</a>, <i>fragments</i> are small bits\nof texts that are inserted in the document or in the template during processing.\nThe basic difference is that <i>fragment</i> are <b>processed</b> before being\ndisplayed. This means that a fragment can contain <i>metatags</i>.<p>\n\nA fragment can in fact include another fragment.<p>\n\nThis can lead to an infinite loop: a fragment including itself.<p>\n\n<center>\n<!--img=fragments:width=\'600\':1-->\n</center><p>\n\nFragments cannot be \"published\" or \"unpublished\", if a fragment in the language\nexists, it will be used, if no fragment can be found, nothing will be added in the\ndocument and the CMS will simply ignore it.<p>\n\n<b>Adding or editing a fragment</b><p>\n\nThe add or edit fragments window has a peculiarity: in order to add or edit a\nfragment you need to prepare the text on your computer, using your favourite\neditor and then upload the document using the \"upload\" button.<p>\n\n<center>\n<!--img=editfrag:width=\'600\':1-->\n</center><p>\n\nTo modify an existing fragment, the \"download\" link will allow the user to download the\noriginal text, change it and then upload it again.<p>\n\nFragment can be inserted in the document, in the template and even in other\nfragmens using the metatag  &lt;!--include=<i>fragmentid</i>--&gt;.<p>\n\n','no','no'),('helpsite',23,'35','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-20 16:14:59','2009-06-21 13:31:49','Frammenti','Frammenti','Simili ai <!--ref=Default texts-->testi di default</a>, i <i>frammenti</i> sono piccoli\npezzi di testo che vengono inseriti nel documento o nel template mentre il documento\nviene processato. La differenza fondamentale tra un frammento ed un testo e\' che il\nframmento viene processato a sua volta prima di essere inserito nel documento. Questo\nsignifica che un frammento puo\' contenere <i>metatags</i>.<p>\n\nUn frammento puo\', in effetti, includere un altro frammento. Questo puo\' portare a\ndelle complicazioni, come l\'avere un frammento che include se\' stesso.<p>\n\n<center>\n<!--img=fragments:width=\'600\':1-->\n</center><p>\n\nI frammenti non possono essere \"pubblicati\" o \"non pubblicati\" come avviene con i documenti,\nse un frammento non esiste non verra\' inserito, il cms semplicemente ignora il corrispondente\nmetatag di inclusione.<p>\n\n<b>Aggiunta o modifica di un frammento</b><p>\n\nL\'aggiunto o modifica di un frammento ha una peculiarita\': prima di tutto occorre creare il\nframmento sul proprio computer con un qualunque editor di testo e poi \"uploadarlo\" usando\nl\'apposito comando sulla maschera di modifica.<p>\n\n<center>\n<!--img=editfrag:width=\'600\':1-->\n</center><p>\n\nPer la modifica e\' possibile fare il download del frammento usando l\'apposito link, modificare\nil testo e poi ri-uploadarlo.<p>\n\nI frammenti vengono inseriti nel documento usando il metatag\n&lt;!--include=<i>fragmentid</i>--&gt;.<p>\n\n','no','no'),('helpsite',23,'36','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-20 17:11:32','2009-06-21 14:10:35','RSS Feeds','RSS Feeds','RSS Feeds are used to... manage the Rss feeds. Told like this it sounds stupid. And in\nfact it is.<p>\n\nEach feed is identified by an ID and a filename. The filename is the one generated when the\nfeed is generated. Each feed is generated in the \'rss feed dir\', that is composed by the\n\'global\' directory, specified in the configuration parameters, and a subdir with the host\nname.<p>\n\n<center>\n<!--img=rss:width=\'600\':1-->\n</center><p>\n\nNote the two \'feed\' command identified by the \'rss\' icon (<img src=\'/icons/16x16/rss.png\'>).\nThe one by the \"add\" button is used to generate all the feeds at once, the one by each\nspecific feed is used to generate just that specific feed.<p>\n\nFor each feed the last generation date is also given.<p>\n\nThe edit/add feed screen allow to manage the general information for a specific feed.<p>\n\n<center>\n<!--img=editrss:width=\'600\':1-->\n</center><p>\n\n<b>Symlink</b><p>\n\nTo insert in a document the feed symlink a special metatag can be used, the tag\n&lt;!--feed=<i>feedid</i>--&gt;. This tag generate a link (relative to the / of the\nsite) and returns it.<p>\n\n','no','no'),('helpsite',23,'36','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','no','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-20 17:11:54','2009-06-21 14:05:36','Feed RSS','Feed RSS','I feed RSS sono usati per generare i feed RSS. Che detto cosi\' suona come una cosa ovvia...\ned infatti lo e\'.<p>\n\nOgni Feed e\' identificato da un \"nome\" ed un \"file\". Il file e\' quello che viene generato quando\nil feed viene prodotto. Per definizione i feed sono generati in una directory per i feed che e\'\ncomposta da una directory \"base\", specificata nei parametri di configurazion ed il nome\ndell\'host.<p>\n\n<center>\n<!--img=rss:width=\'600\':1-->\n</center><p>\n\nPer ogni feed presente per l\'host viene indicata la data di ultima generazione.\nQuesta data viene aggiornata ogni volta che il feed viene generato.<p>\n\nUno dei comandi speciali di questa funzione e\' la generazione immediata del feed.\nVi sono due comandi, entrambi indicati dall\'icona \'feed\' (<img src=\'/icons/16x16/rss.png\'>),\nuno vicino al comando di aggiunta ed uno per ogni singolo feed.<p>\n\nIl comando generale, genera <b>tutti</b> i feed, quello singolo genera solo il feed\na cui e\' associato.<p>\n\nLa maschera di aggiunta/editing del feed consente di immettere o modificare le informazioni\ngenerali per il feed. Notare che il nome del file e\' relativo alla directory dei\nfeed del sistema.<p>\n\n<center>\n<!--img=editrss:width=\'600\':1-->\n</center><p>\n\n<b>Symlink per i feed</b><p>\n\nIl symlink per un feed puo\' essere inserito nel documento usando il metatag\n&lt;!--feed=<i>feedid</i>--&gt; questo metatag costruisce il link (rispetto alla radice\ndel sito) del feed e lo ritorna.<p>\n\n<p>\n\n','no','no'),('helpsite',23,'37','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-20 16:12:04','2009-06-21 14:57:33','Templates','How to manage the templates','<i>Templates</i> are the framework that put the pages of the site together.<p>\n\nWhile the <i>documents</i> provide the contents, <i>fragment</i> and <i>texts</i> provides\ntranslations for common parts and <i>images</i> provide the colourful bits, the \n<i>templates</i> provide the skeleton that keep each piece on his own place.<p>\n\nA template is a simple text containing HTML code. There is no rule that says that you shouldn\'t\nhave \"real\" texts in a template. In fact, you can ignore the documents and put all the text in\ndifferent templates. But the idea is that the template only contains <i>structural</i>\ntags (tables, div, span and so on) to specify where all the bits are, and put the real\ncontent of the site in the documents, fragments and so ono.<p>\n\nTo specify where the bits are, the template can (and should) include <i>metatags</i>.<p>\n\nThe most important is the &lt;!--text--&gt; tag that specify where the <i>content</i> of the\ndocument has to go. Without it, the document will never be seen.<p>\n\n<b>Template example</b><p>\n\nA <u>really simple</u> template could be the following:<p>\n\n<code><pre>\n&lt;!--text--&gt;\n</pre></code><p>\n\nYep, that\'s it. Nothing else. That simple thing will have the document\'s content printed. Nothing\nmore. Of course is not really fancy. So let\'s see a template a little more complicated:<p>\n\n<code><pre>\n&lt;h1&gt;&lt;!--title--&gt;&lt;/h1&gt;\n&lt;!--updated--&gt;&lt;p&gt;\n\n&lt;!--text--&gt;\n&lt;p&gt;\n\n&lt;!--author--&gt;\n&lt;hr&gt;\n&lt;!--include=somefrag--&gt;\n</pre></code>\n<p>\n\nThis template will print the document\'s title, the updated date, the content of the document,\nthe author\'s information and then include a fragment named \'somefrag\' at the bottom of the page.<p>\n\nAgain, very simple, yet effective. Let\'s try with something more daring:<p>\n\n<code><pre>\n&lt;table width=\'90%\' border=\'0\' cellspacing=\'2\' cellpadding=\'2\' \n	bgcolor=\'darkblue\'&gt;\n&lt;tr&gt;\n&lt;td class=\'title\'&gt;&lt;!--title--&gt;&lt;/td&gt;\n&lt;td class=\'title\' align=\'right\'&gt;&lt;!--icon--&gt;&lt;/td&gt;\n&lt;/tr&gt;\n&lt;/table&gt;\n&lt;hr&gt;\n&lt;table width=\'90%\' border=\'0\' cellspacing=\'2\' cellpadding=\'2\' \n	bgcolor=\'white\'&gt;\n&lt;tr&gt;\n&lt;td class=\'doctext\' width=\'70%\' aligh=\'left\' valign=\'top\'&gt;\n&lt;!--text--&gt;\n&lt;p&gt;\n&lt;!--author--&gt;&lt;br&gt;\n&lt;!--updated--&gt;&lt;p&gt;\n&lt;hr&gt;\n&lt;!--comments--&gt;\n&lt;/td&gt;\n&lt;td class=\'doctext\' bgcolor=\'lightgrey\' valign=\'top\' alignt=\'left\'&gt;\n&lt;!--include=sidebar--&gt;\n&lt;/td&gt;\n&lt;/tr&gt;\n&lt;/table&gt;\n&lt;center&gt;\n&lt;!--include=copyright--&gt;\n</pre></code>\n<p>\n\nThis is a slightly more complex template, that defines a single title bar with a darkblue\nbackground and an icon on the right side and a two-columns layout for the actual content,\nthe document appear on the left column while the right one is reserved for a \"sidebar\"\ndefined in one fragment. After the document the <i>comments</i> for that document are\nprinted (if any and the document has comments enabled) and at the bottom of the page\nanother fragment named \'copyright\' is inserted.<p>\n\n<b>Templates to display lists</b><p>\n\nLet\'s suppose you want to display a list of the documents in a specific group in your\nsite. Let\'s say the group is named \"content\". Ok, you just need to add wherever you want\nyour list the list metatag: &lt;!--list=content--&gt; and that\'s it. But... the list that\nis generated this way isn\'t very nice. You want to tweak it.<p>\n\nOk, you need to specify a <i>template</i> to build your list.<p>\n\nLet\'s specify a template called \'fancylist\' defined like this:<p>\n\n<pre><code>\n&lt;div class=\'doctitle\'&gt;\n&lt;!--icon--&gt;\n&lt;a href=\'&lt;!--docname--&gt;\' border=\'0\'&gt;\n&lt;!--title--&gt;&lt;/a&gt;&lt;/div&gt;\n&lt;div class=\'docdetails\'&gt;\n&lt;!--getatext=by--&gt;\n&lt;!--field=name--&gt;\n&lt;!--getatext=updated--&gt;\n&lt;!--updated--&gt;\n-\n&lt;!--numcomments--&gt;\n&lt;/div&gt;\n&lt;div class=\'docexcerpt\'&gt;\n&lt;!--excerpt--&gt;\n&lt;/div&gt;\n&lt;p&gt;\n</code></pre><p>\n\nThen change your list tag to include the template id:\n&lt;!--list=content:fancylist--&gt;<p>\n\nVoila\'! The list is generated using your custom template!<p>\n\n<b>Templates management</b><p>\n\nWhen you click on the template icon in the interface, you\'ll see the list of all the templates\navailable i your host. For each template a count of the documents where the template is used\nis given.<p>\n\n<center>\n<!--img=templates:width=\'600\':1-->\n</center><p>\n\nNote that that count does not includes the templates that are used for lists (like our last\nexample above). At the same time, if a template is used for a document it can\'t be deleted\n(the remove icon won\'t appear), but if the template is only used for lists it can be removed.<p>\n\n<b>Editing or adding templates</b><p>\n\nIs done through the edit template window. Like the fragments, to edit/add a template you need\nto first prepare the file with an editor and then upload it.<p>\n\n<center>\n<!--img=edittpl:width=\'600\':1-->\n</center><p>\n\nThe \"default\" flag in the screen identify which template is proposed when a new document is\ncreated in the host. The \'default\' template is also marked in the list by a green icon nearby\nthe template\'s title. Only one template can be \'default\'. So if you define a template as\nthe default one, any other template that has the \'default\' flag set will be re-set.<p>\n\n<b>Note:</b> the \"copy\" icon replicate only the general informations of a template, the\nactual content of the template (the real template) is not copyed.<p>\n\n','no','no'),('helpsite',23,'37','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-20 16:12:33','2009-06-21 15:17:16','Templates','Come gestire i templates','I <i>templates</i> sono l\'intelaiatura che tiene insieme un sito.<p>\n\nMentre i <i>documenti</i> forniscono il contenuto, i <i>frammenti</i> ed i <i>testi</i>\nforniscono traduzioni per parti comuni e le <i>immagini</i> fanno colore, il <i>template</i>\nfornisce lo scheletro che specifica dove ogni pezzo deve andare per comporre il puzzle.<p.\n\nUn template e\' un semplice testo contenente istruzioni HTML. Non c\'e\' nessuna legge che dice\nche un template non dovrebbe contenre testo \"normale\". In effetti, e\' possibilissimo mettere\ntutto il contenuto nel template ed ignorare i documenti. Solo che non e\' molto efficiente.\nL\'idea e\' che il template dovrebbe solo contenere informazioni <i>strutturali</i>, roba come\nla definizione di tabelle, <i>div</i>, <i>span</i> e cosi\' via. Ed ovviamente, i metatag\nche consentono di prendere gli altri pezzi e metterli insieme.<p>\n\nIl metatag piu\' importante che <b>deve</b> essere in un template (almeno per i template che\nsi applicano a documenti, vedere dopo) e\' il tag \n&lt;!--text--&gt; , questo specifica dove deve andare il testo del documento nel\ntemplate. Senza questo tag, il documento non verra\' mai visto.<p>\n\n<b>Esempio di templates</b><p>\n\nUn template <u>veramente</u> semplice potrebbe essere il seguente:<p>\n\n<code><pre>\n&lt;!--text--&gt;\n</pre></code><p>\n\nYep. Tutto li\'. Niente altro. Questo semplicissimo template includera\' il contenuto del\ndocumento e basta. Ovviamente, questo lascia un po\' a desiderare. Vediamo qualche cosa di\nun pelo piu\' complesso:<p>\n\n<code><pre>\n&lt;h1&gt;&lt;!--title--&gt;&lt;/h1&gt;\n&lt;!--updated--&gt;&lt;p&gt;\n\n&lt;!--text--&gt;\n&lt;p&gt;\n\n&lt;!--author--&gt;\n&lt;hr&gt;\n&lt;!--include=somefrag--&gt;\n</pre></code>\n<p>\n\nQuesto template stampa il titolo del documento, la data di aggiornamento, il contenuto,\nle informazioni dell\'autore e quindi include un frammento chiamato \"somefrag\" alla fine\ndella pagina.<p>\n\nDi nuovo, molto seplice pero\' effettivo. Vediamo qualche cosa di piu\' complesso:<p>\n\n<code><pre>\n&lt;table width=\'90%\' border=\'0\' cellspacing=\'2\' cellpadding=\'2\' \n	bgcolor=\'darkblue\'&gt;\n&lt;tr&gt;\n&lt;td class=\'title\'&gt;&lt;!--title--&gt;&lt;/td&gt;\n&lt;td class=\'title\' align=\'right\'&gt;&lt;!--icon--&gt;&lt;/td&gt;\n&lt;/tr&gt;\n&lt;/table&gt;\n&lt;hr&gt;\n&lt;table width=\'90%\' border=\'0\' cellspacing=\'2\' cellpadding=\'2\' \n	bgcolor=\'white\'&gt;\n&lt;tr&gt;\n&lt;td class=\'doctext\' width=\'70%\' aligh=\'left\' valign=\'top\'&gt;\n&lt;!--text--&gt;\n&lt;p&gt;\n&lt;!--author--&gt;&lt;br&gt;\n&lt;!--updated--&gt;&lt;p&gt;\n&lt;hr&gt;\n&lt;!--comments--&gt;\n&lt;/td&gt;\n&lt;td class=\'doctext\' bgcolor=\'lightgrey\' valign=\'top\' alignt=\'left\'&gt;\n&lt;!--include=sidebar--&gt;\n&lt;/td&gt;\n&lt;/tr&gt;\n&lt;/table&gt;\n&lt;center&gt;\n&lt;!--include=copyright--&gt;\n</pre></code>\n<p>\n\nQuesto e\' un pelo piu\' compesso, definisce una barra del titolo blu scuro con l\'icona del\ndocumento a destra, ed un layout a due colonne per il contenuto, con il contenuto nella\ncolonna di sinistra e la colonna di destra riservata per un frammento chiamato \"sidebar\".\nDopo il contenuto del documento i <i>commenti</i> sono visualizzati (se il documento ha i\ncommenti abilitati) ed al termine della pagina un frammento \"copyright\" e\' inserito.<p>\n\n<b>Templates per mostrare liste</b><p>\n\nSupponiamo di voler inserire nel documento una lista dei documenti di uno specifico\ngruppo. Per esempio il gruppo \"contenuti\". Ok, dobbiamo semplicemente aggiungere, dove\nvogliamo la nostra lista, il tag &lt;!--list=contenuti--&gt; ed e\' fatto. Ma... la lista\nprodotta e\' molto rudimentale. Vogliamo migliorarla.<p>\n\nQuello che ci serve, e\' aggiungere un <i>template</i> per gestire la lista.<p>\n\nSpecifichiamo quindi un template \'listabella\' come segue:<p>\n\n<pre><code>\n&lt;div class=\'doctitle\'&gt;\n&lt;!--icon--&gt;\n&lt;a href=\'&lt;!--docname--&gt;\' border=\'0\'&gt;\n&lt;!--title--&gt;&lt;/a&gt;&lt;/div&gt;\n&lt;div class=\'docdetails\'&gt;\n&lt;!--getatext=by--&gt;\n&lt;!--field=name--&gt;\n&lt;!--getatext=updated--&gt;\n&lt;!--updated--&gt;\n-\n&lt;!--numcomments--&gt;\n&lt;/div&gt;\n&lt;div class=\'docexcerpt\'&gt;\n&lt;!--excerpt--&gt;\n&lt;/div&gt;\n&lt;p&gt;\n</code></pre><p>\n\nQuindi cambiamo il nostro tag per includere il template:\n&lt;!--list=content:listabella--&gt;<p>\n\nEt-voila\': la lista e\' generata usando il nostro template.<p>\n\n<b>Gestione templates</b><p>\n\nCliccando sull\'icona dei template nell\'interfaccia, verranno  mostrati tutti i template\ndisponibili per l\'host. Per ogni template un conteggio dei documenti che usano tale\ntemplate e\' fornito.<p>\n\n<center>\n<!--img=templates:width=\'600\':1-->\n</center><p>\n\nNotare che il conteggio include solo i template che sono usati dal documento, non i template\nche sono usati all\'interno di un documento per generare liste o simili. Nello stesso modo, se\nun documento e\' usato per un documento non puo\' essere cancellato, ma se e\' usato per una lista\nsi\'.<p>\n\n<b>Modifica o aggiunta di template</b><p>\n\nLa modifica ed aggiunta sono fatte attraverso la finestra di modifica, come i frammenti, per\nmodificare o aggiungere un template e\' necessario prima preparare il file su disco e quindi usare\nla funzione Upload per caricarlo.<p>\n\n<center>\n<!--img=edittpl:width=\'600\':1-->\n</center><p>\n\nL\'indicazione di \'default\' identifica il template che e\' proposto di default quando un nuovo\ndocumento e\' aggiunto. Il template di default e\' indicato nella lista con una icona verde\naccanto al nome. Solo un template puo\' essere di default per host. Se si definisce un template\ncome default, ogni altro template perdera\' la designazione di default.<p>\n\n<b>Nota:</b> la \"copia\" non copia il contenuto del template ma solo le informazioni generali.<p>\n\n','no','no'),('helpsite',23,'38','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-21 12:16:07','2009-06-21 15:41:30','Images','Images for the documents','Pictures add colour to a site.<p>\n\nThe only reason to have an image manager function in here is to provide an easy way to have\nan overview of all the pictures used in a site and an easy way to upload an image in the system\nwithout the need for an FTP or SSH connection.<p>\n\nImages are stored on disk, only the filename is stored in the database. It is possible to\ninclude a picture in a document by using a metatag &lt;!--img=...--&gt; or a normal\n\"img src=\" tag.<p>\n\n<center>\n<!--img=images:width=\'600\':1-->\n</center><p>\n\nFor each image a <i>thumbnail</i> is shown, the filename, who is the author of the picture,\nwhen the picture has been updated and two links. The first one is the special metatag and\nthe second one is the normal html link. This way it is possible to simply cut &amp; past them\nin the document.<p>\n\nTo upload an image is necessary to do an upload.<p>\n\n<center>\n<!--img=editimage:width=\'600\':1-->\n</center><p>\n\nThe max size of a picture can be configured, the file  is <b>always</b> renmaed and the \ncorrect extension (.jpg or .png) added. The file is also checked to see if it is a png or jpg\nimage. Files are stored in the /img/ directory (configurable) in a subdir with the same name\nof the host. Of course, if the host is removed the whole subdir is removed too.<p>\n\nTo include an image in a document it is possible to use the img metatag reported in the\nlist above. Note that the metatag can be personalized:<p>\n\n&lt;--img=<i>imgid</i>:<i>special</i>:<i>newwin</i>--&gt;<p>\n\n<b>special</b> can be any parameter you want to add to the img tag, for example, specifying\nwidth=\'600\' , the \'width\' parameter will be added to the resulting img tag.<br>\n<b>newwin</b> if this is valorized an href tag is added to see the full picture in a new\nwindow.<p>\n\ngenerato dal sistema. Per esempio specificando \"width=\'600\'\", il tag img generato\nincludera\' l\'indicazione della larghezza dell\'immagine.<p>\n<b>newwin</b> se valorizzato, consente il click dell\'immagine con apertura in una\nfinestra diversa.<p>\n\n','no','no'),('helpsite',23,'38','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-21 12:16:28','2009-06-21 15:34:20','Immagini','Immagini per i documenti','Le immagini servono ad aggiungere colore al sito.<p>\n\nL\'unico scopo della funzione di gestione delle immagini e\' di provvedere una vista d\'insieme delle\nimmagini disponibili per un sito e fornire agli utenti un sistema semplice per aggiungere immagini\nad un sito senza dover necessariamente usare un client ftp o scp per copiare i files sul server\n(e provvedere quindi una login all\'utente).<p>\n\nLe immagini che sono uploadate con il sistema sono memorizzate su disco, mentre un riferimento\ne\' inserito nel database. E\' possibile quindi usare il tag \n&lt;!--img=<i>imageid:special:newwin</i>--&gt; per visualizzare l\'immagine.<p>\n\n<center>\n<!--img=images:width=\'600\':1-->\n</center><p>\n\nPer ogni immagine presente e\' fornito un <i>thumbnail</i> il nome del file, chi e\'\nl\'autore dell\'immagine, quando e\' stata aggiornata e vengon presentati due link:\nil metatag che consente di visualizzare l\'immagine ed il link relativo per l\'immagine\nstessa.<p>\n\nPer aggiornare o creare una immagine e\' necessario fare un upload.<p>\n\n<center>\n<!--img=editimage:width=\'600\':1-->\n</center><p>\n\nLa massima dimensione di upload consentito e\' specificata nei parametri di configurazione.\nNotare anche che il tipo di file da uploadare e\' ristretto a PNG o JPEG. Il file\nuploadato viene <b>sempre</b> rinominato e l\'estensione (.jpg o .png) viene \naggiunta.<p>\n\nI files sono memorizzati nell\'apposita directory delle immagini (configurabile) in una\nsottodirectory per-host. Ovviamente, se l\'host viene rimosso, tutte le immagini sono\nrimosse.<p>\n\nPer includere una immagine in un documento e\' possibile usare il metatag indicato\nnell\'elenco immagini. Da notare che il metatag puo\' essere personalizzato:<p>\n\n&lt;--img=<i>imgid</i>:<i>special</i>:<i>newwin</i>--&gt;<p>\n\n<b>special</b> possono essere una serie di particolarita\' da aggiungere al tag \"img\"\ngenerato dal sistema. Per esempio specificando \"width=\'600\'\", il tag img generato\nincludera\' l\'indicazione della larghezza dell\'immagine.<p>\n<b>newwin</b> se valorizzato, consente il click dell\'immagine con apertura in una\nfinestra diversa.<p>\n\n','no','no'),('helpsite',23,'50','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 19:03:39','2009-07-01 10:49:07','Documents','Documents management','<p><i>Documents</i> are those things for which everybody goes to a web site: they are\nthe content of the site.</p>\n\n<p>Documents can be managed directly by the host owner, the group owner or by the\nspecific author (once the document has been added). And of course by the superuser.\nThis allow a certain degree of delegation in the various tasks between groups and\nauthors.</p>\n\n<p><b>What\'s in a document</b></p>\n\n<p>In his simplest form, a document is a bit of text. Like this one for example:\n\n<p><pre><code>\na simple bit of text.\n</code></pre></p>\n\n<p>A document can contain any kind of HTML tag, including &lt;HTML&gt; and\n&lt;BODY&gt;, even if those tags are automatically generated by the CMS, so they\ncould just confuse the user\'s browser.</p>\n\n<p>Besides html tags and normal text a document can contain <i>metatags</i>, that\nare specialized \'tags\' that are read by the CMS and allow the system to include\nother informations in the document before sending it to the user. Like building\nhyperlinks, lists and the like with the informations that came from the document\nor the database.</p>\n\n<p>You can find a list of metatags <!--ref=metatags-->here</a>.</p>\n\n<p>Metatags appears like html comments (&lt;!--...--&gt;) this way if a tag is\nsent to the user\'s browser it won\'t do any harm.</p>\n\n<p>To make a new document first of all you need to make a file, using your favourite\ntext editor, containing all the contents, tags and the like. Then you add the document\nto the system and upload the file using the editing window.</p>\n\n<p><b>Documents management</b></p>\n\n<p>By selecting the Documents\' icon (<img src=\'/icons/16x16/calendar_empty.png\'>) the\nlist of groups is shown. Groups are arranged in a hyerarchical structure, just like\ndirectories on the disk, each group can contain other groups and documents. At least\none \'root\' group has to exists. If no group exists (new host), you\'ll see a message\nthat invite you to create one.</p>\n\n<p>Once the \'root\' group has been created, more groups and documents can be created\ninside.</p>\n\n<p>For each group the number of documents (total and to approve) and the number\nof comments (total and to approve) are shown.</p>\n\n<p><center>\n<!--img=documents:width=\'600\':1-->\n</center></p>\n\n<p>For each group the basic informations are shown, if you\'re a group owner, beside\nthe group\'s name, an icon will allow you to <b>edit</b> the group. If you are\nan <i>host owner</i> an \'add\' icon on the top left of the list will allow you to\nadd more groups and icons on the right side of each group will allow you to delete\nor copy the whole group. A group can be removed only if it does not contains\nother groups. Documents in the group are automatically removed, but not subgroups.\nThis is to avoid to delte half of a site with one click.</p>\n\n\n<p><center>\n<!--img=editgroup:width=\'600\':1-->\n</center></p>\n\n<p>Clicking on a group you\'ll see the \ndocuments that belongs to you (unless you\'re the group owner or above).</p>\n\n<p>If you\'re not group owner or above and you don\'t own any document in that group, nothing\nwill happens.</p>\n\n<p>For each document the title <b>in the site\'s default language</b> is shown, if the\ndocument has many different versions, the languages will be shown beween squares\nafter the title ([it],[en]...). If one of the version ain\'t published, the\ncorresponding language will be in <b>bold</b>. The <i>default</i> document for\nthe group (if any) is marked with a green icon near the title \n(<img src=\'/icons/16x16/accept.png\'>).</p>\n\n<p>Note that, if you are not author for a version, the corresponding version won\'t be\nshown.</p>\n\n<p>On the same line the icon, template, css, RSS feed, creation and update date are\nshown. And the total and to approve number of comments. If the document has\ncomment to approve the number will be on a jellow background.</p>\n\n<p>On the right side the action icon for the document are displayed.</p>\n\n<p><ul>\n<li><img src=\'/icons/16x16/remove.png\'> remove <b>all versions</b> of a document\nand all the associated comments. Only the group owner or above can delete a\ndocument.\n<li><img src=\'/icons/16x16/favorite_add.png\'> This icon shows that the document is\npublished. Clicking on the icon turn all the versions you own (or all the\nversions if you\'re group owner or above) to \'not published\'.\n<li><img src=\'/icons/16x16/favorite_remove.png\'> This icon shows that the document is\nnot-published. Like above, clicking reverse the status.\n<li><img src=\'/icons/16x16/search_add.png\'> This icon shows that the document is included\nin lists composed by the system. Like above, clicking it, reverse the status for all\nthe versions you own.\n<li><img src=\'/icons/16x16/search_remove.png\'> Like the previous but with the\nopposite meaning.\n<li><img src=\'/icons/16x16/comments_add.png\'> The icon shows that new comments can be\nadded to the document, like above, clicking turn the status to \'close\'. This command\ncan be performed by <i>moderators</i> too.\n<li><img src=\'/icons/16x16/comments_remove.png\'> Like the above but with opposite\nmeaning and action.\n<li><img src=\'/icons/16x16/search.png\'> Display the comments on a document.\n</ul></p>\n\n<p><b>Editing of a document</b><br>\n\n<p>To edit a document you need to select the language you want to edit (link by the\ndocument\'s title), this will show the edit document window.</p>\n\n<p><center>\n<!--img=editdocument:width=\'600\':1-->\n</center></p>\n\n<p>As you can see, the window is quite complicated, this because the document contains\na lot of informations besides the simple content. These informations are used by\nthe front-end to display various things. See also\n<!--ref=Come funziona il front-end-->How the front-end works</a>.</p>\n\n<p><ul>\n<li><b>default</b> means that the document is the default document for that group.\n<li><b>404 (not found)</b> means that the document is the \'not found\' document for the\nwhole site. Only one document can be \'not found\' for a site.\n<li><b>template</b> is the template tha the document uses. When a new document\nis added, the default template for the group is used as default.\n<li><b>RSS feed</b> is the RSS feed which the document belongs to.\n<li><b>CSS</b> is the CSS used by the document. Like the template, when adding a new\ndocument the group\'s CSS is automatically proposed.\n<li><b>Author</b> is the author (owner) of the document. The \'author\' parameter\nof the group is automatically proposed when a new document is added.\n<li><b>Language</b> is the language for the document.\n<li><b>Title</b> is the document\'s title.\n<li><b>Creation date and update date</b> these are automatically maintined by\nthe system.\n<li><b>Display</b> means that the document is included in lists auto-generated by\nthe front-end.\n<li><b>Approved</b> means that the document is published and can be served by the\nfront-end when requested. A un-approved document is literally invisible, unless\nthe author himself login in the frontend and request it. This way it is possible\nto have a \"preview\" of the document.\n<li><b>Comments</b> enable or disable comments on the document.\n<li><b>Status</b> allow the addition of new comments on a doument (if the comments\nare turned on of course).\n<li><b>Moderated</b> enable or disable moderation of the comments. An un-moderated\ndocument let every post to be displayed immediately. It is strongly suggested that\nyou leave this to \'yes\' all the time.\n<li><b>Moderator</b> who is the moderator for this document.\n<li><b>Excerpt</b> is a short synopsis of the document. It is used by the front-end\nfor some list and can be displayed using metatags.\n<li><b>Icon</b> of the document.\n</ul></p>\n\n<p>If the document already exists, you\'ll see the <i>links</i> that are connected\nwith the document. A <i>link</i> is an URL that will display the document. A document\ncan have one or more links. One link is automatically created when the document is\nadded.</p>\n\n<p><b>Adding a document</b></p>\n\n<p>Only Group owner or above can add a new document in a group, by clicking on the \"add a document\"\nicon or by copying an existing document in the group.</p>\n\n<p><b>Upload and Download</b></p>\n\n<p>Just like the tempaltes and fragments, to edit or add a document you need a text \nfile, that can be edited with whatever text editor you like.</p>\n\n<p>Once the text is ready, you can upload it with the \'Upload\' box on the editing\nwindow.</p>\n\n<p>The Download link allow you to download an existing document for editing.</p>\n\n<p><b>Preview</b></p>\n\n<p>In the title bar of the editing window there is the icon of a magnifier\n(<img src=\'/icons/16x16/search.png\'>), clicking on that icon a preview of the\ndocument is shown.</p>\n\n<p>It is possible to update the document doing an upload, then click on the \"apply\"\nbutton to update the document and then refresh the preview window to appreciate\nimmediately the changes.</p>\n\n<p><b>Add a new document</b></p>\n\n<p>When a new document is added to a group, a new ID is generated by taking the last\nid in the group and increasing by 1. Note that if your ids are all letteral\n(a,b,c...) the <i>next letter</i> is picked. If the ids are strings, the last\ncharacter is increased. This way, you can have ids like \'doc0001\' and the\n\'next\' document will be \'doc0002\'.</p>\n\n<p><b>List and directories</b></p>\n\n<p>Like said above, the <b>display</b> parameter shows if a document goes into a list\nof not. It is possible to have a document published on the site but not included in\nlists that are autogenerated.</p>\n\n<p>If a document is un-published it won\'t be included in lists and if requested in some\nway the users will receive either a \'not found\' document or the \'default\' document for\nthe site.</p>\n\n<p>Usually documents are added to lists sorted by IDs. So if you want to be able to\nmanage the way your documents are shown use meaningful IDs.</p>\n\n<p>If you have documents with IDs like \'100\', \'200\' and so on, you\'ll be able to\nput a document between other two by simply giving him an id of \'150\'.</p>\n\n','no','no'),('helpsite',23,'50','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 18:58:10','2009-07-01 10:25:19','Documenti','Gestione dei documenti','<p>I <i>documenti</i> sono quello per cui tutti quanti vanno su un sito web: sono il\ncontenuto del sito.</p>\n\n<p>I documenti possono essere gestiti dal proprietario dell\'host, dal proprietario del\ngruppo o dall\'autore del documento (una volta che il documento e\' stato aggiunto).\n<p>Ed ovviamente dal superutente. Questo consente di delegare la gestione di interi\ngruppi di documenti o di singoli documenti in diversi gruppi.</p>\n\n<p><b>Cosa e\' un documento</b></p>\n\n<p>Nella sua forma piu\' semplice, un documento e\' un semplice testo. Per esempio questo:\n\n<p>\n<pre><code>\nun semplice testo\n</code></pre></p>\n\n<p>e\' un documento valido.</p>\n\n<p>Un documento puo\' contenere qualunque tipo di tag HTML, inclusi &lt;HTML&gt; e\n&lt;BODY&gt;, anche se tali tag sono automaticamente gestiti dal CMS e quindi\naggiungerli potrebbe solo confondere il browser dell\'utente.</p>\n\n<p>Oltre a tag html il documento puo\' contenere <i>metatags</i> che sono degli\nspeciali \'tag\' che vengono interpretati dal cms per produrre contenuto basato\nsui dati del database. Un elenco dei metatag e\' disponibile\n<!--ref=metatags-->qui</a>.</p>\n\n<p>Un metatag appare come un commento html (&lt;!--...--&gt;) in questo modo anche se\nnon viene elaborato (perche\' e\' scritto sbagliato per esempio) e viene inviato al\nbrowser, il browser si limita ad ignorarlo.</p>\n\n<p>Per produrre un documento occorre per prima cosa scrivere un file, per questo e\'\npossibile usare qualsiasi editor che generi un file di testo ASCII. Una volta che il\nfile e\' pronto si carica nel sistema usando la maschera di gestione.</p>\n\n<p><b>Visualizzazione e gestione dei documenti</b></p>\n\n<p>I documenti esistono all\'interno di <b>gruppi</b>, un documento non esiste se non\ne\' contenuto in un gruppo. In effetti, la prima cosa da fare dopo aver creato un host\nsarebbe creare un template di default e quindi aggiungere un gruppo \'root\'.</p>\n\n<p>Selezionando l\'icona di gestione dei documenti (<img src=\'/icons/16x16/calendar_empty.png\'>)\nvengono visualizzati i gruppi presenti. In genere, viene visualizzato il gruppo \'root\', \nselezionando il gruppo vengono visualizzati i sottogruppi ed i documenti presenti.</p>\n\n<p>Un gruppo puo\' contenere altri gruppi o documenti.</p>\n\n<p>Se si hanno i diritti necessari, si possono creare altri sottogruppi o documenti all\'interno\ndi gruppi esistenti.</p>\n\n<p><center>\n<!--img=documents:width=\'600\':1-->\n</center></p>\n\n<p>Per ogni gruppo e\' anche fornito il numero totale di documenti, il numero di documenti\nda approvare (se ve ne sono), il numero di commenti ed il numero di commenti da\napprovare. Se vi sono documenti o commenti da approvare questi sono riportati\n<b>in grassetto</b>.</p>\n\n<p>I proprietari di gruppo (o superiori) vedranno una icona accanto al nome del gruppo,\nfacendo click su tale icona viene richiamata la finestra di modifica del gruppo ed e\'\npossibile apportare modifiche al gruppo.<p>\n<p>Allo stesso modo sono visualizzate le icone di <b>aggiunta di un gruppo</b>\n(<img src=\'/icons/16x16/folder_add.png\'>), di <b>aggiunta di un documento</b>\n(<img src=\'/icons/16x16/page_add.png\'>) e di \n<b>eliminazione del gruppo</b> (<img src=\'/icons/16x16/remove.png\'>). Rimuovere un\ngruppo significa rimuovere tutti i documenti associati, i loro commenti eccetera.\nUn gruppo puo\' essere rimosso solo <u>se non contiene altri gruppi</u>:\nla cancellazione non e\' recursiva. Questo per evitare che, con un click, mezzo sito\nscompaia nel nulla.</p>\n\n<p><center>\n<!--img=editgroup:width=\'600\':1-->\n</center></p>\n\n<p>Facendo click sul nome del gruppo, la lista viene espensa ed e\' possibile vedere i \nsottogruppi ed i documenti appartenenti a quel gruppo <i>di cui si e\' proprietari</i>.\nSe non si e\' proprietari di nessun documento all\'interno del gruppo non succedera\' niente.</p>\n\n<p>Per ogni documento viene visualizzato il titolo <b>della versione nella lingua di\ndefault</b> per il sito, se vi sono piu\' lingue disponibili per un documento queste\nsono visualizzate di seguito tra parentesi quadre ([it], [en]...). Se una delle\nversioni non e\' pubblicata, la lingua corrispondente viene visualizzata \n<b>in grassetto</b>.</p>\n\n<p>Notare che, se non si e\' proprietari della versione in lingua, tale versione non\nverra\' visualizzata.</p>\n\n<p>E\' possibile a colpo d\'occhio vedere quali documenti sono pubblicati e quali no.</p>\n\n<p>Oltre al titolo viene visualizzata l\'icona, il template, il CSS, il Feed e le\ndate di creazione ed ultimo aggiornamento. Il numero di commenti totali e da\napprovare.</p>\n\n<p>Se un documento ha commenti da approvare il numero corrispondente\nviene visualizzato <b>in grassetto</b> e l\'intera linea ha sfondo giallo.</p>\n\n<p>Sulla destra sono visualizzate le icone operative per i documenti.</p>\n\n<p><ul>\n<li><img src=\'/icons/16x16/remove.png\'> cancella <b>tutte le versioni</b> del documento\ne tutti i commenti associati. Solo il proprietario del gruppo o superiore puo\' \ncancellare un documento.\n<li><img src=\'/icons/16x16/favorite_add.png\'> Questa icona indica che il documento e\'\npubblicato, se si e\' proprietari di piu\' versioni del documento, le versioni del documento\nnon pubblicate sono riportate dopo il nome del documento in grassetto, cliccando sull\'icona\nlo stato del documento verra\' impostato a \"non pubblicato\". Se non si e\' proprietari di\ntutte le versioni, solo le versioni di cui si e\' proprietari saranno de-pubblicate.\n<li><img src=\'/icons/16x16/favorite_remove.png\'> Questa icona indica che il\ndocumento e\' in stato \"non pubblicato\". Come per l\'icona precedente, diverse versioni\nsono indicate dopo il titolo del documento e cliccare sull\'icona cambia lo stato solo\ndelle versioni di cui si e\' proprietari.\n<li><img src=\'/icons/16x16/search_add.png\'> Questa icona indica che il documento e\'\nincluso nella generazione di liste ed elenchi, come per le icone precedenti, l\'effetto\ne l\'indicazione sono ristrette ai documenti di cui si e\' proprietari.\n<li><img src=\'/icons/16x16/search_remove.png\'> Come per l\'icona precedente, ma indica che\nil documento <b>non e\'</b> incluso in liste ed elenchi.\n<li><img src=\'/icons/16x16/comments_add.png\'> L\'icona indica che il documento ha commenti\ne nuovi commenti possono essere aggiunti (stato \"open\"), come per le icone precedenti,\nlo stato e\' ristretto ai documenti di cui si e\' proprietari.\n<li><img src=\'/icons/16x16/comments_remove.png\'> Il documento non accetta nuovi\ncommenti.\n<li><img src=\'/icons/16x16/search.png\'> Visualizza i commenti sul documento.\n</ul></p>\n\n<p><b>Modifica di un documento</b><br>\n\n<p>Per modificare un documento si seleziona la versione in lingua che si vuole modificare\n(link dopo il titolo del documento), questo visualizza la finestra di modifica del\ndocumento.</p>\n\n<p><center>\n<!--img=editdocument:width=\'600\':1-->\n</center></p>\n\n<p>Come si vede, la maschera di modifica/inserimento e\' piuttosto complessa, questo\nperche\' il documento contiene parecchi parametri che sono usati dal front end per\nvisualizzare i documenti, generare liste eccetera. Vedere anche\n<!--ref=Come funziona il front-end-->Come funziona il front-end</a>.</p>\n\n<p><ul>\n<li><b>default</b> indica se il documento e\' da considerare il documento di default\nper il gruppo.\n<li><b>404 (not found)</b> indica che il documento e\' da considerare documento di\n\"non trovato\". Solo un documento <i>per sito</i> puo\' essere 404. Impostare questo\nflag su un documento rimuove lo stesso flag da tutti gli altri documenti.\n<li><b>template</b> e\' il template che viene usato per visualizzare il documento.\nIn fase di aggiunta il template per il gruppo e\' proposto come default.\n<li><b>RSS feed</b> e\' il feed rss a cui questo documento appartiene, di default\ne\' impostato a \'none\'.\n<li><b>CSS</b> e\' il CSS che viene usato per il documento, di default e\' il CSS del\ngruppo.\n<li><b>Author</b> e\' l\'autore - proprietario del documento, in fase di aggiunta di\nun documento il parametro \"author\" del gruppo viene usato per inizializzare questo\nvalore.\n<li><b>Language</b> la lingua di questo documento\n<li><b>Title</b> il titolo del documento.\n<li><b>Data di creazione ed aggiornamento</b> sono impostate ed aggiornate\nautomaticamente.\n<li><b>Display</b> indica se il documento e\' incluso nella creazione di liste\ned elenchi prodotti con i documenti del gruppo.\n<li><b>Approved</b> indica se il documento e\' visualizzato sul sito e puo\'\nessere richiesto o meno. Un documento non approvato e\' letteralmente invisibile.\nIl parametro \"approved\" e\' ignorato dal front-end se l\'autore del documento effettua\nlogin. In questo modo e\' possibile avere un \"preview\" del documento prima della\npubblicazione.\n<li><b>Comments</b> abilita o disabilita i commenti sul documento.\n<li><b>Status</b> indica se il documento accetta nuovi commenti o meno. Se il \ndocumento ha commenti attivi (Comments=Yes) ma ha Status=Close, i commenti\nesistenti verranno visualizzati, ma nuovi commenti non potranno essere aggiunti.\n<li><b>Moderated</b> indica se i comenti sono moderati o meno - e\' caldamente\nconsigliato il lasciare questo parametro a \'yes\' sempre e comunque.\n<li><b>Moderator</b> chi e\' il moderatore dei commenti per questo documento.\n<li><b>Excerpt</b> e\' un breve riassunto o descrizione del contenuto, viene usata\ndal front-end per la costruzione di certe liste.\n<li><b>Icona</b> del documento. Puo\' essere visualizzata sulla pagina.\n</ul></p>\n\n<p>Se il documento e\' in fase di modifica, sono visualizzati i <b>links</b> attraverso\ni quali il documento e\' raggiungibile. Un link e\' sempre aggiunto automaticamente\nquando il documento e\' creato, altri link sono aggiungibili dall\'utente. In questo\nmodo e\' possibile creare URL che sono \"user-friendly\" e \"search-engine-friendly\".</p>\n\n<p>Per aggiungere un link digitare il link nello spazio disponibile e fare click sull\'icona\ndi aggiunta a destra. Per rimuovere un link fare click sull\'icona di rimozione. Notare\nche l\'ultimo link non e\' rimovibile.</p>\n\n<p><b>Aggiunta di un documento</b></p>\n\n<p>Per aggiungere un documento occorre essere come minimo proprietari del gruppo\nin cui il documento risiede. Se si hanno i diritti necessari in corrispondenza del\ngruppo vi sara\' l\'icona di aggiunta.</p>\n\n<p><b>Upload e Download</b></p>\n\n<p>Come per i template ed i frammenti, per creare o modificare un documento occorre\ncreare o modificare un file con un editor e poi fare un upload.</p>\n\n<p>Il link \"Downlad\" sulla maschera di gestione consente di scaricare la versione\nattuale del documento per editing e la funzione di Upload consente di aggiornare\nil documento esistente.</p>\n\n<p><b>Preview</b></p>\n\n<p>Sulla barra del titolo della finestra di editing si trova l\'icona di una\nlente d\'ingrandimento (<img src=\'/icons/16x16/search.png\'>), cliccando l\'icona\nun preview del documento e\' visualizzato in una finestra diversa.</p>\n\n<p>E\' possibile aggiornare il documento facendo un upload, cliccare sul pulsante \"apply\"\ne quindi rinfrescare il preview per vedere immediatamente l\'effetto delle modifiche.</p>\n\n<p>Il pulsante Close chiude la finestra.</p>\n\n<p><b>Aggiunta di un nuovo documento</b></p>\n\n<p>Quando si aggiunge un nuovo documento un ID per il documento e\' generato prendendo\nl\'ID dell\'ultimo documento del gruppo ed incrementandolo. Notare che se tutti i\ndocumenti hanno ID letterali (a, b, c...) l\'id che e\' generato e\' comunque letterale:\nviene presa la lettera successiva.</p>\n\n<p>Se l\'id e\' composto da una parola, l\'ultimo carattere della parola viene incrementato.</p>\n\n<p>In questo modo e\' possibile avere ID sensati ma comunque consequenziali. Per\nesempio se si inserisce un documenti \"doc0001\", il documento successivo sara\'\nautomaticamente chiamato \"doc0002\".</p>\n\n<p><b>Liste ed elenchi</b></p>\n\n<p>Come detto sopra, il parametro <b>Display</b> indica se il documento deve essere \nincluso o meno in liste ed elenchi. E\' possibile avere un documento riportato sul\nsito (mediante un link) ma non incluso in una lista autogenerata.</p>\n\n<p>Se il documento e\' non-approvato, non verra\' visualizzato comunque nelle liste e\nse richiesto direttamente si ricevera\' un errore (o il documento di default).</p>\n\n<p>I documenti sono inseriti nelle liste generalmente in ordine di ID. Quindi se volete \nalterare l\'ordine in cui i documenti appaiono, l\'unica cosa da fare e\' pensare prima\nin che ordine li volete o usare degli id che consentano di modificare l\'ordine\nsuccessivamente. Per esempio usando 100, 200, 300 et similia, se si vuole aggiungere\nun documento tra 100 e 200 bastera\' chiamarlo 150.</p>\n\n','no','no'),('helpsite',23,'55','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-20 16:25:57','2009-06-22 20:25:26','Metatags','Metatags','<i>Metatags</i> are special tags that are processed by the front-end of the CMS to\nproduce the final document that is sent to the user.<p>\n\nMetatags looks like HTML comments (&lt;!--...--&gt;). Each metatag produce some\nkind or processes that, in the end, generate some text that is inserted in the\nfinal page to send to the user. This way is possible to extract informations from\nthe document and the rest of the database, put them all together and send i\neverything to the user.<p>\n\nThere are 3 main categories of metatags:<p>\n\n<ol>\n<li><b>Substitution</b><br>\nThis kind of tags are replaced with some kind of value that came from the\ndatabase or from the http requst, the value is inserted in the line in the\nsame place occupied by the tag, that is removed. The processing then proceed\nas nothing happened.<p>\n\n<li><b>Informational</b><br>\nThis kind of tag search for some kind of information in the database and\neither generate html tag and insert them or insert the information itself.\nMost of the time, the information recovered is connected with the document.<p>\n\n<li><b>List</b><br>\nThis sort of tags scan the documents of a group and produce a list of some\nsort with the various documents in it. Most of the differences between the\nvarious list is the sorting order and the kind of default list that is\ngenerated.<p>\n\n</ol><p>\n\nBy this list it could appear that Informational and Substitution tags are the same,\nbut they are not. There are two specific differences between these two kind of tags:<p>\n\nFirst of all, substitution tags are processed first. What does it mean? It mean that\n<i>a tag could be used as an argument in another tag</i>.<p>\n\nSecond, substitution tag require no arguments, while information tags most of\nthe time require at least one.<p>\n\n<b>Metatag that require or accept arguments</b><p>\n\nSome metatag accept (or require) arguments that are used to change the result\nof the tag itself. Some arguments are mandatory, some are not.<p>\n\nFor example, the List tag (&lt;!--list=...--&gt;)\nrequire the group id to use for the list. Other arguments that could be added\nare the special template to use and the number of documents to include in the\nlist.<p>\n\nUsually, only the first argument is mandatory.<p>\n\nArguments are separated by colons (:).<p>\n\n<b>Uso of metatags</b><p>\n\nA metatag can appear everywhere in an element that is <b>processed</b> by the\nfrontend, this means <i>Fragments</i>, <i>Templates</i> or <i>Documents</i>,\nnot in default texts.<p>\n\nMetatags can appear anywhere on a line, even more than one on the same line, but\n<b>they cannot be broken on multiple lines</b>.<p>\n\n<b>Substitution metatag</b><p>\n\n<table width=\'100%\' bgcolor=\'white\' border=\'1\' cellpadding=\'1\' cellspacing=\'1\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'>tag</font></td>\n<td><font color=\'white\'>description</font></td>\n<td><font color=\'white\'>example</font></td>\n</tr>\n\n<tr><td>&lt;!--title--&gt;</td><td>\nReport the document\'s title in the selected language.\n</td>\n<td>&lt;!--title--&gt;</td></tr>\n\n<tr><td>&lt;!--data--&gt;</td>\n<td>Report the creation date of the document</td>\n<td>&lt;!--data--&gt;</td></tr>\n\n<tr><td>&lt;!--date--&gt;</td>\n<td>Report the system\'s date (current date and time on the server)</td>\n<td>&lt;!--date--&gt;</td></tr>\n\n<tr><td>&lt;!--updated--&gt;</td>\n<td>Report the update date of the document</td>\n<td>&lt;!--updated--&gt;</td></tr>\n\n<tr><td>&lt;!--uptime--&gt;</td>\n<td>Report the uptime value of the server (number of days since the last reboot.\nIn order to work the web server has to have enough rights to run the \'uptime\'\ncommand.\n</td>\n<td>&lt;!--uptime--&gt;</td></tr>\n\n<tr><td>&lt;!--name--&gt;</td>\n<td>Report the author\'s name from the user\'s table.\n</td>\n<td>&lt;!--name--&gt;</td></tr>\n\n<tr><td>&lt;!--docname--&gt;</td>\n<td>Report the full document name, including the group.\n</td>\n<td>&lt;!--docname--&gt;</td></tr>\n\n<tr><td>&lt;!--excerpt--&gt;</td>\n<td>Report the document\'s excerpt</td>\n<td>&lt;!--excerpt--&gt;</td></tr>\n\n<tr><td>&lt;!--numcomments--&gt;</td>\n<td>Report the number of approved comments of the document. Note that this tag\nworks regardless if the document has comment enabled or not.</td>\n<td>&lt;!--numcomments--&gt;</td></tr>\n\n<tr><td>&lt;!--referer--&gt;</td>\n<td>\nReport the \"referer\" from the HTTP request. The referer is the page from which the\nuser arrived. Note that is not the same as the \'back\' button in the browser.\n</td>\n<td>&lt;!--referer--&gt;</td></tr>\n\n<tr><td>&lt;!--position--&gt;</td>\n<td>\nReturn a symlink with the full \"position\" of the document, including \nhomepage, group and the document. This allow a sort of \"navigation\" control\nin the documents.\n</td>\n<td>&lt;!--position--&gt;</td></tr>\n\n<tr><td>&lt;!--icon--&gt;</td>\n<td>\nReturn an IMG tag that display the document\'s icon. Check also the <b>icon=</b>\ntag below.\n</td>\n<td>&lt;!--icon--&gt;</td></tr>\n\n<tr><td>&lt;!--login--&gt;</td>\n<td>\nIf the user ain\'t logged it will use the fragment identified by \"login\" to show\na login text pointing to the login window. If the user is logged the \"logout\"\nfragment is used to point to the logout/user management window. If the fragments\ndoes not exists, a default one is built.\n</td>\n<td>&lt;!--login--&gt;</td></tr>\n\n<tr><td>&lt;!--loginform--&gt;</td>\n<td>\nBuild and display a fully functional login form.\n</td>\n<td>&lt;!--loginform--&gt;</td></tr>\n\n<tr><td>&lt;!--author--&gt;</td>\n<td>\nRecover and return the author\'s description from the user\'s descriptions table.\n</td>\n<td>&lt;!--author--&gt;</td></tr>\n\n<tr><td>&lt;!--text--&gt;</td>\n<td>\nProcess and insert the document\'s content.\n</td>\n<td>&lt;!--text--&gt;</td></tr>\n\n<tr><td>&lt;!--prev--&gt;</td>\n<td>\nSearch a \"previous\" document in the actual group and, if found and published,\nbuild an hyperlink using the \"previous\" text in the deftexts table that load ist.\n</td>\n<td>&lt;!--prev--&gt;</td></tr>\n\n<tr><td>&lt;!--next--&gt;</td>\n<td>\nSearch the \"next\" document in the actual group, if found and published,\nbuild an hyperlink using the \"next\" text in the deftexts table that load ist.\n</td>\n<td>&lt;!--next--&gt;</td></tr>\n\n<tr><td>&lt;!--<i>var</i>--&gt;</td>\n<td>\nInsert the value of the variable identified by <i>var</i>. This tag, in conjunction\nwith the assign tag explained later, allow to recall a variable assigned from a\nsymlink or other way.\n</td>\n<td>&lt;!--<i>var</i>--&gt;</td></tr>\n</table><p>\n\n<b>Informations Metatag</b><p>\n\n<table width=\'100%\' bgcolor=\'white\' border=\'1\' cellpadding=\'1\' cellspacing=\'1\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'>tag</font></td>\n<td><font color=\'white\'>description</font></td>\n<td><font color=\'white\'>example</font></td>\n</tr>\n\n<tr><td>\n&lt;!--<i>var</i>=<i>value</i>--&gt;\n<td>\nAssign the value <i>value</i> to the variable <i>var</i>. This tag allow to set\na variable that can be recovered in another document using the \"var\" tag\nexplained above. The variable can then be used in another tag.\n</td>\n<td>\n&lt;!--year=1999--&gt;<br>\n&lt;!--include=reportfor&lt;!--year--&gt;--&gt;\n</td></tr>\n\n<tr><td>\n&lt;!--getatext=<i>textid</i>--&gt;\n</td><td>\nSearch a default text <i>textid</i> with the correct language and return it.\n</td><td>\n&lt;!--getatext=descsito--&gt;\n</td></tr>\n<tr><td>\n&lt;!--feed=<i>feedid</i>--&gt;\n</td><td>\nBuild a symlink pointing to the RSS Feed file of the specified feed.\n</td><td>\nThis doc feed is  &lt;a href=\'&lt;!--feed=mydoc--&gt;\'&gt;qui&lt;/a&gt;\n</td></tr>\n<tr><td>\n&lt;!--img=<i>imgid</i>[:<i>extra</i>:<i>link</i>]--&gt;\n</td><td>\nSearch the image identified by <i>imgid</i> and build an IMG tag with it. The\n<i>extra</i> and <i>link</i> arguments can be added if needed. The \"extra\" arg\nis simply attached to the IMG tag, the \"link\" arguments create an HREF link\naround the img to display the image in a different window.\n</td><td>\nSimple image: &lt;!--img=<i>imgid</i>--&gt;&lt;br&gt;<br>\nResized: &lt;!--img=<i>imgid</i>:<i>width=\'45\'&nbsp;height=\'60\'--&gt;&lt;br&gt;<br>\nResized with link: &lt;!--img=<i>imgid</i>:width=\'45\'&nbsp;height=\'60\':1--&gt;&lt;br&gt;\n</td></tr>\n<tr><td>\n&lt;!--icon=<i>extra</i>--&gt;\n</td><td>\nBuild an IMG tag that display the document\'s icon with some special parameter\nadded to it.\n</td><td>\nIcon: &lt;!--icon=width=\'60\'--&gt;\n</td></tr>\n<tr><td>\n&lt;!--field=<i>fieldid</i>--&gt;\n</td><td>\nReturn the content of the field specified. The field is from the current\ndocument.\n</td><td>\nQuesto documento e\' moderato da: &lt;!--field=moderator--&gt;\n</td></tr>\n<tr><td>\n&lt;!--include=<i>fragid</i>--&gt;\n</td><td>\nRecover and process the specified fragment. If the fragment contains other tags, these\nwill be processed immediately.\n</td><td>\n&lt;!--include=sidebar--&gt;\n</td></tr>\n<tr><td>\n&lt;!--ref=<i>documenttitle</i>--&gt;\n</td><td>\nBuild the first part of an HREF tag (the &lt;A href=...&gt; part) that refers to a\ndocument identified by the specified title. No matter the language. This allow to build\nhyperlink that don\'t break if the document is moved to another group or if you\ndon\'t know the document id but you remember the title. Since the title ain\'t\na primary key, if there are more document with the same title, the first one is\npicked.\n</td><td>\nMore info &lt;!--ref=altreinfo--&gt;here&lt;/a&gt;\n</td></tr>\n<tr><td>\n&lt;!--comments[=<i>templateid</i>--&gt;\n</td><td>\nIf the current document has comments enabled, this tag will show all the comments\nusing a simple template or the one specified. Before the comments a link is\nprovided to add more comments if the document has \"open\" comments.\n</td><td>\nComments with default template: &lt;!--comments--&gt;<br>\nComments with personal template: &lt;!--comments=myfunkytemplate--&gt;<br>\n</td></tr>\n</table><p>\n\n<b>List metatags</b><p>\n\nThese are the tags that are used to generate lists and directories of documents.\nAll of them require at least an argument: the groupid to process.<p>\n\n<table width=\'100%\' bgcolor=\'white\' border=\'1\' cellpadding=\'1\' cellspacing=\'1\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'>tag</font></td>\n<td><font color=\'white\'>description</font></td>\n<td><font color=\'white\'>example</font></td>\n</tr>\n\n<tr><td>\n&lt;!--process=<i>groupid</i>[:<i>tplid</i>:<i>limit</i>--&gt;\n</td><td>\nMakes a list of the documents contained in the <i>groupid</i> group in alphabetical\norder and format it using the template <i>tplid</i> if specified and exists.\n<i>Limit</i> is the maximum number of documents to show in the list, if not specified\nall the documents in the group are shown. If a template isn\'t specified a default\ntemplate is built and used. The default template contains the document\'s title\nas a link to the document, the author\'s name, update date, number of comments and\nthe document\'s Excerpt.\n</td><td>\nList with default template:\n&lt;!--process=mygroup--&gt;<br>\nList with a personalized template:\n&lt;!--process=mygroup:mytpl--&gt;<br>\nList with personalized template and maximum 10 documents:\n&lt;!--process=mygroup:mytpl:10--&gt;\n</td></tr>\n\n<tr><td>\n&lt;!--whatsupdoc=<i>groupid</i>[:<i>tplid</i>--&gt;\n</td><td>\nBuild a list of the documents contained in the <i>groupid</i> group in update\ndate reverse order (newer docs first), format the list using the <i>tplid</i>\ntemplate if it is specified and it exists, otherwise a default template is built\nand used. Only the last \'n\' documents are shown, where \'n\' is the\n\"limit\" configuration parameter value.<br>\nThe default template contains the document\'s icon, the title as a link to the\ndocument, the author\'s name, update date, number of comments and the\ndocument\'s excerpt.\n</td><td>\nLast documents are:&lt;!--whatsupdoc=mygroup--&gt;\n</td></tr>\n\n<tr><td>\n&lt;!--journal=<i>groupid</i>[:<i>tplid</i>:<i>limit</i>--&gt;\n</td><td>\nJust like \'whatsupdoc\' before, but the limit is specified in the tag.\n</td><td>\nLast 10 documents: &lt;!--journal=mygroup::10--&gt;\n</td></tr>\n\n<tr><td>\n&lt;!--list=<i>groupid</i>[:<i>tplid</i>:<i>limit</i>--&gt;\n</td><td>\nCreate a list of the documents in the group <i>groupid</i> order by title, format it\nusing the template <i>tplid</i> if specified and exists and print at maximum of\n<i>limit</i> document. If the limit is not specified, all the documents are\nprinted. The default template is extremely simple and only contains the\ndocument\'s title as a symlink to the document.\n</td><td>\nA really simple list: &lt;!--list=mygroupid--&gt;\n</td></tr>\n\n<tr><td>\n&lt;!--guests=<i>groupid</i>[:<i>tplid</i>:<i>limit</i>--&gt;\n</td><td>\nGenerate a list of the documents <b>grouped by author</b> and sorted by\ntitle. The default template prints the author\'s name and then\nall the documents are printed one after the  other separated by a comma.\nAn empty line is left between the authors.\n</td><td>\nOther\'s people stuff:\n&lt;!--guests=contributors--&gt;\n</td></tr>\n</table><p>\n\n','no','no'),('helpsite',23,'55','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-20 16:26:15','2009-06-22 16:09:24','Metatags','Metatags','I <i>metatag</i> sono tag speciali che vengono interpretati dal front-end del CMS\nper produrre il documento finale da inviare all\'utente.<p>\n\nI metatag appaiono come dei commenti html (&lt;!--...--&gt;). Ogni metatag produce\nun qualche tipo di elaborazione che risulta nella generazione di un testo che viene\ninserito nel documento da inviare all\'utente. In questo modo e\' possibile\nestrarre informazioni dal documento o da altre parti del sistema ed includerle\nin un documento unico.<p>\n\nI metatag si dividono in 3 categorie:\n\n<ol>\n<li><b>Sostituzione</b><br>\nQuesto tipo di metatag vengono sostituiti con un qualche valore che proviene dal\ndatabase o da altri metatag nel documento, il valore viene inserito nella stessa\nposizione occupata dal metatag che viene rimosso. L\'elaborazione continua poi in\nmodo normale.<p>\n\n<li><b>Informazione</b><br>\nQuesto tipo di tag recupera una informazione dal database e la visualizza come\nnormale testo o come hyperlink. Questi tag possono recuperare informazioni dal\ndocumento stesso o da altre parti del database non connesse con il documento.<p>\n\n<li><b>Lista</b><br>\nQuesto tipo di metatag serve a produrre liste o elenchi di documenti presenti \nin un gruppo. Vi sono diversi metatag che producono diversi tipi di liste per lo\npiu\' con diversi ordinamenti.<p>\n\n</ol><p>\n\nDall\'elenco precedente si potrebbe pensare che i tag di Sostituzione e di\nInformazione sono la stessa cosa. Ma vi sono due differenze fondamentali tra\ni due.<p>\n\nLa prima differenza e\' che i tag di sostituzione sono processati prima \ndi tutti gli altri. Cosa significa? Significa che <i>un tag potrebbe essere usato come\nparametro all\'interno di un altro tag</i>.<p>\n\nLe seconda differenza e\' che i tag di Sostituzione non accettano parametri, mentre \nquelli di Informazione richiedono almeno un parametro.<p>\n\n<b>Metatag che accettano o richiedono parametri</b><p>\n\nAlcuni metatag accettano <i>parametri</i> che sono usati per modificare il\nrisultato del tag o per specificare come il tag deve operare. Alcuni di questi\nparametri sono obbligatori altri no.<p>\n\nPer esempio, il tag per la generazione di una Lista (&lt;!--list=...--&gt;)\nrichiede come parametro l\'id del gruppo di cui generare la lista. Altri parametri\nche posono essere aggiunti sono il template da usare per la lista ed il numero\nmassimo di documenti da analizzare.<p>\n\nIn genere il primo parametro e\' obbligatorio e gli altri sono facoltativi.<p>\n\nI parametri sono separati nel tag da due punti (:).<p>\n\n<b>Uso dei metatag</b><p>\n\nI metatag possono apparire in un qualunque elemento che viene <b>processato</b>\ndal frontend, il che significa <i>Frammenti</i>, <i>Templates</i> o nel\n<i>Documento</i>, ma non nei testi di default.<p>\n\nI metatag possono essere ovunque, anche piu\' di uno sulla stessa linea, ma\n<b>non possono essere spezzati su piu\' righe</b>.<p>\n\n<b>Metatag di Sostituzione</b><p>\n\n<table width=\'100%\' bgcolor=\'white\' border=\'1\' cellpadding=\'1\' cellspacing=\'1\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'>tag</font></td>\n<td><font color=\'white\'>descrizione</font></td>\n<td><font color=\'white\'>esempio</font></td>\n</tr>\n\n<tr><td>&lt;!--title--&gt;</td><td>\nInserisce il titolo del documento nella lingua selezionata</td>\n<td>&lt;!--title--&gt;</td></tr>\n\n<tr><td>&lt;!--data--&gt;</td>\n<td>Inserisce la data di creazione del documento</td>\n<td>&lt;!--data--&gt;</td></tr>\n\n<tr><td>&lt;!--date--&gt;</td>\n<td>Inserisce la data di sistema (data attuale del server)</td>\n<td>&lt;!--date--&gt;</td></tr>\n\n<tr><td>&lt;!--updated--&gt;</td>\n<td>Inserisce la data di aggiornamento del documento</td>\n<td>&lt;!--updated--&gt;</td></tr>\n\n<tr><td>&lt;!--uptime--&gt;</td>\n<td>Inserisce il valore di uptime del server (numero di giorni dal precedente reboot).\nPerche\' questo tag funzioni e\' necessario che il server web sia in grado di eseguire\nil comando <i>uptime</i>.\n</td>\n<td>&lt;!--uptime--&gt;</td></tr>\n\n<tr><td>&lt;!--name--&gt;</td>\n<td>Inserisce il nome dell\'autore del documento estratto dalla tabella degli\nutenti.</td>\n<td>&lt;!--name--&gt;</td></tr>\n\n<tr><td>&lt;!--docname--&gt;</td>\n<td>Inserisce l\'id del documento comprensivo di gruppo.</td>\n<td>&lt;!--docname--&gt;</td></tr>\n\n<tr><td>&lt;!--excerpt--&gt;</td>\n<td>inserisce il contenuto del campo \'excerpt\' del documento.</td>\n<td>&lt;!--excerpt--&gt;</td></tr>\n\n<tr><td>&lt;!--numcomments--&gt;</td>\n<td>Inserisce il numero di commenti presenti per il documento. Notare che questo\ne\' indifferente al fatto che il documento abbia commenti abilitati o meno.</td>\n<td>&lt;!--numcomments--&gt;</td></tr>\n\n<tr><td>&lt;!--referer--&gt;</td>\n<td>Inserisce il contenuto dell\'header \"referer\" dalla richiesta. Il referer e\' la\npagina dalla quale si arriva, che e\' di solito diversa dalla pagina che si ottiene\nusando il tasto \"back\" del browser.</td>\n<td>&lt;!--referer--&gt;</td></tr>\n\n<tr><td>&lt;!--position--&gt;</td>\n<td>Costruisce la \"posizione\" nel sito in funzione del gruppo e dell\'id del\ndocumento e visualizza una serie di link che consentono la navigazione tra il\ndocumento, il gruppo e la home page.</td>\n<td>&lt;!--position--&gt;</td></tr>\n\n<tr><td>&lt;!--icon--&gt;</td>\n<td>Ritorna un tag img che consente la visualizzazione dell\'icona associata al\ndocumento. Notare la differenza tra questo tag ed il tag <b>icon=</b> tra i tag di\ninformazione piu\' sotto.\n</td>\n<td>&lt;!--icon--&gt;</td></tr>\n\n<tr><td>&lt;!--login--&gt;</td>\n<td>Se l\'utente non e\' loggato usa il frammento identificato da \'login\' per visualizzare\nun testo di login, viceversa, se l\'utente e\' loggato usa il frammento \'logout\'. Se il\nframmento non esiste ne viene generato uno di default.</td>\n<td>&lt;!--login--&gt;</td></tr>\n\n<tr><td>&lt;!--loginform--&gt;</td>\n<td>Genera ed inserisce una maschera di login di default.</td>\n<td>&lt;!--loginform--&gt;</td></tr>\n\n<tr><td>&lt;!--author--&gt;</td>\n<td>Recupera il contenuto della descrizione dell\'autore del documento in lingua\ne la visualizza.</td>\n<td>&lt;!--author--&gt;</td></tr>\n\n<tr><td>&lt;!--text--&gt;</td>\n<td>Inserisce il contenuto del documento</td>\n<td>&lt;!--text--&gt;</td></tr>\n\n<tr><td>&lt;!--prev--&gt;</td>\n<td>Cerca il documento <i>precedente</i> all\'attuale nel gruppo, se esiste,\ncostruisce un hyperlink usando il testo del testo di default \'previous\' e lo\ninserisce.</td>\n<td>&lt;!--prev--&gt;</td></tr>\n\n<tr><td>&lt;!--next--&gt;</td>\n<td>Cerca il documento <i>successivo</i> all\'attuale nel gruppo, se esiste,\ncostruisce un hyperlink usando il testo del testo di default \'next\' e lo\ninserisce.</td>\n<td>&lt;!--next--&gt;</td></tr>\n\n<tr><td>&lt;!--<i>var</i>--&gt;</td>\n<td>Inserisce la variabile identificata da <i>var</i>. Questo tag, in combinazione con\nil tag di assegnazione (descritto nella sezione seguente) consente di richiamare un\nvalore assegnato attraverso un symlink o altro.\n</td>\n<td>&lt;!--<i>var</i>--&gt;</td></tr>\n</table><p>\n\n<b>Metatag di Informazione</b><p>\n\n<table width=\'100%\' bgcolor=\'white\' border=\'1\' cellpadding=\'1\' cellspacing=\'1\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'>tag</font></td>\n<td><font color=\'white\'>descrizione</font></td>\n<td><font color=\'white\'>esempio</font></td>\n</tr>\n\n<tr><td>\n&lt;!--<i>var</i>=<i>value</i>--&gt;\n<td>Assegna un valore ad una variabile. Questo tag consente di <i>dichiarare una\nvariabile</i> ed <i>assegnargli un valore</i>. La variabile puo\' essere poi usata\nin un altro tag usando il tag di sostituzione &lt;!--<i>var</i>--&gt;.\n</td>\n<td>\n&lt;!--year=1999--&gt;<br>\n&lt;!--include=reportfor&lt;!--year--&gt;--&gt;\n</td></tr>\n\n<tr><td>\n&lt;!--getatext=<i>textid</i>--&gt;\n</td><td>\nRecupera il testo di default identificato da <i>textid</i> e lo inserisce al\nposto del tag. Se il testo non e\' trovato non viene inserito nulla.\n</td><td>\n&lt;!--getatext=descsito--&gt;\n</td></tr>\n<tr><td>\n&lt;!--feed=<i>feedid</i>--&gt;\n</td><td>\nCostruisce il path relativo per il file dei feed RSS del documento e lo ritorna.\n</td><td>\nil feed per questo documento e\' &lt;a href=\'&lt;!--feed=mydoc--&gt;\'&gt;qui&lt;/a&gt;\n</td></tr>\n<tr><td>\n&lt;!--img=<i>imgid</i>[:<i>extra</i>:link]--&gt;\n</td><td>\nTrova l\'immagine identificata da <i>imgid</i> e costruisce un tag IMG che la\nvisualizza. Il parametro <i>extra</i>, se specificato, viene aggiunto al tag IMG.\nil parametro <i>link</i>, se specificato, indica che il tag deve anche essere un link all\'immagine\noriginale, quindi il tag IMG verra\' circondato da un tag HREF.\n</td><td>\nImmagine semplice: &lt;!--img=<i>imgid</i>--&gt;&lt;br&gt;<br>\nImmagine ridimensionata: &lt;!--img=<i>imgid</i>:<i>width=\'45\'&nbsp;height=\'60\'--&gt;&lt;br&gt;<br>\nImmagine ridimensionata e con link: &lt;!--img=<i>imgid</i>:width=\'45\'&nbsp;height=\'60\':1--&gt;&lt;br&gt;\n</td></tr>\n<tr><td>\n&lt;!--icon=<i>extra</i>--&gt;\n</td><td>\nCostruisce un tag IMG che visualizza l\'icona associata al documento. Il parametro <i>extra</i> viene aggiunto\nal tag IMG prodotto.\n</td><td>\nIcona del documento: &lt;!--icon=width=\'60\'--&gt;\n</td></tr>\n<tr><td>\n&lt;!--field=<i>fieldid</i>--&gt;\n</td><td>\nRitorna il contenuto del campo indicato dal parametro <i>fieldid</i> preso direttamente dal database. Questo\nsi applica solo al record Documents corrente.\n</td><td>\nQuesto documento e\' moderato da: &lt;!--field=moderator--&gt;\n</td></tr>\n<tr><td>\n&lt;!--include=<i>fragid</i>--&gt;\n</td><td>\nRecupera il frammento indicato da <i>fragid</i>, lo processa ed inserisce il risultato. Notare che il frammento\nviene <b>processato</b> prima di essere inserito, il che significa che se il frammento contiene degli altri\nmetatag, questi verranno analizzati ed eseguiti prima che il risultato sia incluso.\n</td><td>\n&lt;!--include=sidebar--&gt;\n</td></tr>\n<tr><td>\n&lt;!--ref=<i>documenttitle</i>--&gt;\n</td><td>\nCostruisce la prima parte di un tag HREF (la parte &lt;A href=...&gt;) che referenzia il documento che ha come\ntitolo <i>documenttitle</i>. In qualunque lingua. Questo consente di costruire un Hyperlink che non si \"rompe\"\nanche se il documento viene spostato in un altro gruppo o l\'id viene cambiato. Da notare che, dato che il titolo\npotrebbe non essere univoco, se esistono piu\' documenti con lo stesso titolo, solo il primo viene preso in\nconsiderazione.\n</td><td>\nTrovate altre informazioni &lt;!--ref=altreinfo--&gt;qui&lt;/a&gt;\n</td></tr>\n<tr><td>\n&lt;!--comments[=<i>templateid</i>--&gt;\n</td><td>\nSe il documento attuale ha i commenti attivati, questo tag visualizza i commenti presenti usando il template\nindicato da <i>templateid</i> se questo e\' specificato ed esiste, in caso contrario un template di default\nviene costruito ed utilizzato. Prima dell\'elenco dei commenti viene fornito il numero totale di commenti\napprovati ed un link per l\'aggiunta di un nuovo commento.\n</td><td>\nCommenti con template di default: &lt;!--comments--&gt;<br>\nCommenti con template personalizzato: &lt;!--comments=myfunkytemplate--&gt;<br>\n</td></tr>\n</table><p>\n\n<b>Metatag di lista</b><p>\n\nQuesti sono i tag che sono usati per produrre liste ed elenchi di documenti. Richiedono come minimo un\nparametro: l\'identificativo del gruppo da processare.<p>\n\n<table width=\'100%\' bgcolor=\'white\' border=\'1\' cellpadding=\'1\' cellspacing=\'1\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'>tag</font></td>\n<td><font color=\'white\'>descrizione</font></td>\n<td><font color=\'white\'>esempio</font></td>\n</tr>\n\n<tr><td>\n&lt;!--process=<i>groupid</i>[:<i>tplid</i>:<i>limit</i>--&gt;\n</td><td>\nCrea un elenco dei documenti contenuti nel gruppo <i>groupid</i> in ordine alfabetico,\nlo visualizza usando il template <i>tplid</i> se e\' specificato ed esiste. <i>Limit</i>\ne\' il massimo numero di documenti da visualizzare, se non e\' specificato il limite e\'\n999 documenti. Il template di default di Process contiene il titolo del documento\ncome Hyperlink al documento, il nome dell\'autore, la data di aggiornamento, il numero\ndi commenti e l\'excerpt del documento.\n</td><td>\nElenco con template di default:\n&lt;!--process=mygroup--&gt;<br>\nElenco con template personalizzato:\n&lt;!--process=mygroup:mytpl--&gt;<br>\nElenco con template personalizzato e limite a 10 documenti:\n&lt;!--process=mygroup:mytpl:10--&gt;\n</td></tr>\n\n<tr><td>\n&lt;!--whatsupdoc=<i>groupid</i>[:<i>tplid</i>--&gt;\n</td><td>\nCrea un elenco dei documenti contenuti nel gruppo <i>groupid</i> in ordine di data\ndi aggiornamento inversa (i piu\' nuovi prima),\nlo visualizza usando il template <i>tplid</i> se e\' specificato ed esiste.\nSolo gli ultimi \'n\' documenti sono visualizzati, \'n\' e\' dato dal parametro di \nconfigurazione \'limit\'.\nIl template di default contiene l\'icona del documento, il titolo del documento \ncome Hyperlink al documento, il nome dell\'autore, la data di aggiornamento, il \nnumero di commenti e l\'excerpt del documento.\n</td><td>\nGli ultimi documenti sono:&lt;!--whatsupdoc=mygroup--&gt;\n</td></tr>\n\n<tr><td>\n&lt;!--journal=<i>groupid</i>[:<i>tplid</i>:<i>limit</i>--&gt;\n</td><td>\nEsattamente come \'whatsupdoc\' ma consente di specificare il limite nel tag.\n</td><td>\nGli ultimi 10 documenti sono:&lt;!--journal=mygroup::10--&gt;\n</td></tr>\n\n<tr><td>\n&lt;!--list=<i>groupid</i>[:<i>tplid</i>:<i>limit</i>--&gt;\n</td><td>\nProduce un elenco dei documenti del gruppo <i>groupid</i> in ordine alfabetico di titolo, applicando \nil template indicato da <i>tplid</i> e con un limite di <i>limit</i> documenti. Se il limite non e\' \nspecificato, tutti i documenti sono visualizzati. Se il template non e\' specificato un template di \ndefault viene usato, tale template e\' estremamente semplice e contiene solo il titolo del documento \ncome hyperlink al documento.\n</td><td>\nUn elenco minimalista: \n&lt;!--list=mygroupid--&gt;\n</td></tr>\n\n<tr><td>\n&lt;!--guests=<i>groupid</i>[:<i>tplid</i>:<i>limit</i>--&gt;\n</td><td>\nProduce un elenco dei documenti del gruppo <i>groupid</i> <b>raggruppati per autore</b> ed in\nordine alfabetico di titolo. Come per gli altri tag, tplid e limit consentono di specificare un\ntemplate ed un limite. Il template di default visualizza il nome dell\'autore e poi produce\nl\'elenco dei documenti uno in seguito all\'altro separati da virgole. Tra un autore e l\'altro\ninserisce un paragrafo (&lt;p&gt;).\n</td><td>\nDocumenti di altra gente:\n&lt;!--guests=contributors--&gt;\n</td></tr>\n</table><p>\n\n<!--HTML-->\n','no','no'),('helpsite',23,'60','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 19:04:11','2009-07-01 11:10:07','Comments','Comments management','<p><i>Comments</i> are user-generated input that is incorporated in the document\nif the owner of the document say so.</p>\n\n<p>In the current version of the CMS, you can either have comments or not to have comments,\nthere is no way to have comments only from registered users.</p>\n\n<p>Comments are attached to a document, when you remove a document all the comments are\nremoved with it. Comments can be moderated or not. If they are not moderated, everything\nthat the user type will be immediately displayed in the document. It is strongly\nrecommended to keep comments always moderated, unless the site is an internal site\nand not available on the internet.</p>\n\n<p>If the comments have to be moderated, the document owner (or anyone with higher \nauthority) can define a moderator to do the job.</p>\n\n<p>Selecting the Comments icon (<img src=\'/icons/16x16/comments.png\'>) the group list will \nbe shown. This list differs from the <b>documents</b> list by the fact that all the groups\nare \"flattened\". Instead of a hyerarchical structure you\'ll see a flat list of groups.\nThe reason to have such display is that is much easier to see which groups contains\ncomments to approve if all the groups are displayed in one page. You don\'t need to drill\ndown the tree to see which group has comments.</p>\n\n<p>\n<center>\n<!--img=comments:width=\'600\':1-->\n</center>\n</p>\n\n<p>Clicking on a group name, the group will be \'expanded\' and you\'ll see all the\ndocuments that have comments enabled and you are the moderator of. If no\ndocument has comments enabled, the group will be empty.</p>\n\n<p>Just the default language is displayed for each document. Clicking on the\ndocument\'s title will display a preview of the document.</p>\n\n<p>On the right side of each line there are 2 icons:<br>\n<ul>\n<li><img src=\'/icons/16x16/lock.png\'> or <img src=\'/icons/16x16/lock_off.png\'>\nto indicate if the document is \"closed\" or \"open\" and to change its status.\n<li><img src=\'/icons/16x16/search.png\'> to show the comments on the document.\n</ul>\n</p>\n\n<p>For each document the total number of comments and the number of comments to\napprove is given. If there are comments to approve the number will be highlighted.</p>\n\n<b>Closed and Open document</b></p>\n\n<p>A document can have comments enabled but not accepting any more comments. This is\nwhen a document is \"closed\". A closed document can show the existing comment, but won\'t\naccept any other comment anymore. Disabling the comments on the document on the\nother hand, will make all the comments disappear.</p>\n\n<p>Clicking on the \"show comment\" icon will display the actual comments for the document.</p>\n\n<p>\n<center>\n<!--img=showcomments:width=\'600\':1-->\n</center>\n</p>\n\n<p>Each comment is shown on a row, <i>unapproved</i> comments will be highlighted.\n<p>For each comment a series of icons specify the possible actions:</p>\n\n<ul>\n<li><img src=\'/icons/16x16/comment_remove.png\'> De-approve de comment (if approved)\n<li><img src=\'/icons/16x16/comment_add.png\'> Approve de comment (if not approved)\n<li><img src=\'/icons/16x16/remove.png\'> Completely remove the comment\n<li><img src=\'/icons/16x16/comment_edit.png\'> Edit the comment\n<li><img src=\'/icons/16x16/comments_add.png\'> Answer the comment\n</ul></p>\n\n<p>Only the moderator or higher in authority can edit somebody else comment.</p>\n\n<p>The editing or adding of a comment is done through a different window. This window\nis specialized to handle comments.</p>\n\n<p><center>\n<!--img=editcomment:width=\'600\':1-->\n</center></p>\n\n<p>The window will show the user\'s icon (if the user hasn\'t logged in, a default\nicon will be shown and a red message will inform that the user is posting as\nanonymous) and allow for a \"author\'s name\", subject and a content to be entered.</p>\n\n<p>When added or edited, the message will be processed by \n<a href=\'http://spamassassin.apache.org/\'>SpamAssassin</a> to filter out spam and\njunk and if the message is considered spam, it won\'t be posted.</p>\n\n<p>Messages that pass through spamassassin are added to the system.</p>\n\n<b>Emoticons</b></p>\n\n<p>Lots of people like to put \"emoticons\" in their messages. I mean\n<img src=\'/icons/emo/happy.png\' width=\'16\'>, how <img src=\'/icons/emo/cool.png\' width=\'16\'>\netc. etc. <img src=\'/icons/emo/tongue.png\' width=\'16\'>...</p>\n\n<p>The display function for the comments automatically try to translate the various\ntexts in the corresponding icons. To do so, it uses two config parameters:\n<i>emocode</i> and <i>emodecode</i> that are processed in parallel. The <i>emocode</i>\nparameter contains the character-based emoticons separated by spaces. The\n<i>emodecode</i> parameter contains the equivalent icons. The icon\'s name is\ncomposed with the <i>emoticonsdir</i> to retrieve the correct icon to display.</p>\n\n<p>Note that the icon is only displayed, the code is not replaced in the message itself.</p>\n\n<p>At the same time, the display function try to \"clean up\" the message\nremoving all sort of junk, html coding and the like.</p>\n\n<b>Text style in the comments</b></p>\n\n<p>Yes, it is possible to have <b>bold</b>, <i>italic</i> and\n<u>underlined</u> in the comments. You only need to use the correct\ntext. If you put a word (or more) between asterisks (*...*), the\ntext will be rendered in bold. For the italic you need to use\nthe \"pipe\" (|) and for the underlined the underscore (_).</p>\n\n','no','no'),('helpsite',23,'60','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 18:58:34','2009-07-01 11:14:13','Commenti','Gestione dei commenti','<p>I <i>commenti</i> sono contenuti generati dagli utenti ed incorporati nel\ndocumento se il proprietario del documento decide di incorporarli.</p>\n\n<p>Nella versione attuale del CMS, si possono avere commenti o non avere\ncommenti, non c\'e\' modo di restringere i commenti ai soli utenti registrati.</p>\n\n<p>I commenti sono \"attaccati\" ad un documento, rimuovendo un documento tutti\ni commenti ad esso associati sono rimossi. I commenti possono essere moderati o \nmeno, se sono moderati prima di comparire dovranno essere approvati dal moderatore \no utente con privilegi, se i commenti non sono moderati verranno semplicemente \nvisualizzati immediatamente. Si consiglia vivamente di tenere sempre i commenti \nmoderati.</p>\n\n<p>Selezionando l\'icona Comments (<img src=\'/icons/16x16/comments.png\'>) l\'elenco dei\ngruppi viene visualizzato. Questo elenco differisce dalla visualizzazione usata per\ni <b>documenti</b> perche\' e\' <i>piatto</i>. Tutti i gruppi sono visualizzati in\nuna unica schermata, senza struttura gerarchica. Il motivo di questa visualizzazione\ne\' che e\' molto piu\' semplice vedere quali gruppi hanno dei commenti da approvare.\n</p>\n\n<p>\n<center>\n<!--img=comments:width=\'600\':1-->\n</center></p>\n\n<p>Selezionando il nome di un gruppo, il gruppo viene \"espanso\" e si potranno vedere i\ndocumenti che hanno commenti abilitati e di cui si e\' moderatori (o superiore). Se\nnessun documento del gruppo puo\' essere visualizzato, il gruppo rimarra \"chiuso\".</p>\n\n<p>Solo il linguaggio di default e\' visualizzato per ogni documento. Cliccando sul\ntitolo del documento si ottiene un preview dello stesso.</p>\n\n<p>Per ogni documento sono dati il numero totale di commenti ed il numero di commenti\nda approvare. Se un documento ha commenti da approvare viene evidenziato,\nsulla destra vengono fornite due icone:</p>\n\n<p>\n<ul>\n<li><img src=\'/icons/16x16/lock.png\'> o <img src=\'/icons/16x16/lock_off.png\'>\nper indicare che il documento e\' in stato \"chiuso\" (non accetta ulteriori commenti) o\n\"aperto\" e per cambiare da uno stato all\'altro.\n<li><img src=\'/icons/16x16/search.png\'> mostra i commenti sul documento.\n</ul>\n</p>\n\n<p><b>Documenti chiusi ed aperti</b></p>\n\n<p>Un documento \"chiuso\" non accetta nuovi commenti ma continua a visualizzare quelli\nesistenti. Un documento \"aperto\" accetta nuovo commenti. Un documento con i commenti\ndisabilitati non visualizza i commenti anche se sono presenti.</p>\n\n<p>Cliccando sull\'icona \"mostra commenti\" (<img src=\'/icons/16x16/search.png\'>) viene\nmostrato l\'elenco dei commenti per il documento. Se il documento non ha commenti\nverra\' mostrato un elenco vuoto.</p>\n\n<p><center>\n<!--img=showcomments:width=\'600\':1-->\n</center></p>\n\n<p>Ogni commento e\' mostrato su una riga, i commenti <i>da approvare</i> verranno\nevidenziati. Per ogni commento una serie di icone forniscono le possibili azioni:</p>\n\n<p>\n<ul>\n<li><img src=\'/icons/16x16/comment_remove.png\'> de-pubblica il documento (se pubblicato)\n<li><img src=\'/icons/16x16/comment_add.png\'> pubblica il documento (se non pubblicato)\n<li><img src=\'/icons/16x16/remove.png\'> cancella il commento\n<li><img src=\'/icons/16x16/comment_edit.png\'> modifica il commento\n<li><img src=\'/icons/16x16/comments_add.png\'> risponde al commento\n</ul></p>\n\n<p>Solo il moderatore o utente con permessi superiori puo\' modificare i commenti di\nqualcun\'altro.</p>\n\n<p>La modifica o aggiunta di un commento sono fatte usando una maschera di immissione dei\ncommento. Questa maschera e\' specializzata per gestire i commenti.</p>\n\n<p>\n<center>\n<!--img=editcomment:width=\'600\':1-->\n</center></p>\n\n<p>La maschera mostra l\'icona dell\'utente, se l\'utente non ha fatto login, una icona di\ndefault viene usata ed un messaggio che informa l\'utente che sta\' postando come \"anonimo\".\nConsente all\'utente di digitare il nome, soggetto ed il testo vero e proprio.</p>\n\n<p>Quando un commento viene aggiunto o modificato, viene processato da\n<a href=\'http://spamassassin.apache.org/\'>SpamAssassin</a> \nper eliminare spam ed altra immondizia. Se SpamAssassin pensa che il commento sia\nSpam, non verra\' inserito.</p>\n\n<p><b>Emoticons</b></p>\n\n<p>Ad un sacco di gente piace mettere \"emoticons\" nei loro messaggi. Voglio dire\n<img src=\'/icons/emo/happy.png\' width=\'16\'>, <img src=\'/icons/emo/cool.png\' width=\'16\'>\netc. etc. <img src=\'/icons/emo/tongue.png\' width=\'16\'>...</p>\n\n<p>La funzione che mostra a video i commenti cerca automaticamente di trasformare il\n\"testo\" nella corrispondente icona. Per fare cio\' usa due parametri di configurazione\nche contengono il testo da una parte e l\'icon dall\'altra. I parametri sono\n<i>emocode</i> ed <i>emodecode</i>.</p>\n\n<p>Notare che l\'icona e\' solo visualizzata, il codice non viene modificato.</p>\n\n<p><b>Stili di testo nei commenti</b></p>\n\n<p>E\' possibile usare degli stili di testo come <b>grassetto</b>, <i>corsivo</i> e\n<u>sottolineato</u> nei commenti, per selezionarli occorre rachiudere il testo che\nsi vuole formattare in \'*\' per il grassetto, \'|\' (pipe) per corsivo e \'_\' per\nsottolineato.</p>\n\n','no','no'),('helpsite',23,'70','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 19:04:41','2009-06-24 20:28:10','Configuration parameters','Configuration parameters','The configuration parameters are used by both the front and the backoffice, this\nway, changing one parameter affect both side in the same way.<p>\n\nIn the beginning, all the parameters were in the configuration file. But that\nmeant that the config file was getting huge and manual modifications required\ndirect access to the file. So I decided to change that and move <b>all</b> the\nparameters into the database, leaving in the config file just the bits \nrequired to access the database.<p>\n\nThese are the configuration parameter of the system:<p>\n\n<table width=\'100%\' bgcolor\'lightblue\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>parametro</b></td>\n<td><font color=\'white\'><b>descrizione</b></td>\n</tr>\n<tr><td>404icon </td><td>icon used for the 404 document </td></tr>\n<tr><td>accepticon</td><td>confirm/accept icon</td></tr>\n<tr><td>addbutton </td><td>add button icon</td></tr>\n<tr><td>addicon </td><td>add icon </td></tr>\n<tr><td>articles</td><td>articles icon</td></tr>\n<tr><td>avatardir </td><td>subdir where the avatars icons are placed</td></tr>\n<tr><td>base</td><td>base directory </td></tr>\n<tr><td>buttondir </td><td>directory for the buttons</td></tr>\n<tr><td>closeicon </td><td>icon used in the close command </td></tr>\n<tr><td>commaddicon </td><td>icon used in the enable comments command </td></tr>\n<tr><td>commdelicon </td><td>icon used in the disable comments command</td></tr>\n<tr><td>commedit-fh </td><td>height for the edit comment wnd</td></tr>\n<tr><td>commedit-fw </td><td>width for the edit comment wnd </td></tr>\n<tr><td>comments-fh </td><td>height for the edit comment window </td></tr>\n<tr><td>comments-fw </td><td>width for the edit comment window</td></tr>\n<tr><td>commentsicon</td><td>comments icon</td></tr>\n<tr><td>config-fh </td><td>height for the edit configuration parameters wnd </td></tr>\n<tr><td>config-fw </td><td>width for the edit configuration parameters wnd</td></tr>\n<tr><td>configicon</td><td>config params icon </td></tr>\n<tr><td>cookiehost</td><td>identification cookie</td></tr>\n<tr><td>copybutton</td><td>icon used in the copy command</td></tr>\n<tr><td>copyicon</td><td>icon used in the copy button </td></tr>\n<tr><td>css </td><td>default CSS</td></tr>\n<tr><td>debug </td><td>enable/disable debugging </td></tr>\n<tr><td>defavatar </td><td>default avatar icons </td></tr>\n<tr><td>defdocicon</td><td>default document\'s icon</td></tr>\n<tr><td>deflang </td><td>default language </td></tr>\n<tr><td>delicon </td><td>icon used in the delete or remove command</td></tr>\n<tr><td>disableicon </td><td>icon used in the disable display command </td></tr>\n<tr><td>dociconsdir </td><td>documents icon directory </td></tr>\n<tr><td>documents-fh</td><td>height for the edit document window</td></tr>\n<tr><td>documents-fw</td><td>width for the edit document window </td></tr>\n<tr><td>documentsicon </td><td>document icon</td></tr>\n<tr><td>downicon</td><td>Demote to user icon</td></tr>\n<tr><td>editicon</td><td>icon used in the edit comments command </td></tr>\n<tr><td>edituserheight</td><td>height for the edit user window</td></tr>\n<tr><td>edituserwidth </td><td>width for the edit user window </td></tr>\n<tr><td>emocode </td><td>Code for the emoticons </td></tr>\n<tr><td>emodecode </td><td>Decode for the emoticons </td></tr>\n<tr><td>emoticonsdir</td><td>subdir where the emoticons icons are placed</td></tr>\n<tr><td>enableicon</td><td>icon used in the enable display command</td></tr>\n<tr><td>feed-fh </td><td>height for the edit RSS feed window</td></tr>\n<tr><td>feed-fw </td><td>width for the edit RSS feed window </td></tr>\n<tr><td>fragments-fh</td><td>height for the edit fragments window </td></tr>\n<tr><td>fragments-fw</td><td>width for the edit fragments windows </td></tr>\n<tr><td>fragmentsicon </td><td>fragment icon</td></tr>\n<tr><td>genrssicon</td><td>rss feed icon</td></tr>\n<tr><td>groups-fh </td><td>height for the edit group window </td></tr>\n<tr><td>groups-fw </td><td>width for the edit group window</td></tr>\n<tr><td>groupsicon</td><td>icon for the groups</td></tr>\n<tr><td>helpicon</td><td>icon for the help function </td></tr>\n<tr><td>helplink</td><td>where is the help? </td></tr>\n<tr><td>hosts-fh</td><td>height for the edit host window</td></tr>\n<tr><td>hosts-fw</td><td>width for the edit host window </td></tr>\n<tr><td>hostsicon </td><td>hosts icon </td></tr>\n<tr><td>htmlcode</td><td>Code for the char replacement in comments</td></tr>\n<tr><td>htmldecode</td><td>Char for the char replacement in comments</td></tr>\n<tr><td>iconsdir</td><td>icons</td></tr>\n<tr><td>images-fh </td><td>height for the edit image wnd</td></tr>\n<tr><td>images-fw </td><td>width for the edit image wnd </td></tr>\n<tr><td>imgdir</td><td>base directory for images</td></tr>\n<tr><td>imgicon </td><td>icon for the Images function </td></tr>\n<tr><td>imgmaxsize</td><td>maximum size (in kbyte) o picture to upload</td></tr>\n<tr><td>ips </td><td>list of IPs with no viewing restrictions </td></tr>\n<tr><td>js</td><td>default javascript name</td></tr>\n<tr><td>languages </td><td>supported languages</td></tr>\n<tr><td>limit </td><td>max document to list </td></tr>\n<tr><td>lockicon</td><td>lock closed icon </td></tr>\n<tr><td>login </td><td>login script to use</td></tr>\n<tr><td>logindefault</td><td>default options for the login screen </td></tr>\n<tr><td>loginicon </td><td>login icon </td></tr>\n<tr><td>logout</td><td>logout user script to use</td></tr>\n<tr><td>logouticon</td><td>logout icon</td></tr>\n<tr><td>maxsizeicon </td><td>Maximum size of a user icon (in Kb)</td></tr>\n<tr><td>mkthumb </td><td>instruction used to resize and create thumbnails </td></tr>\n<tr><td>postnew </td><td>postnew script to use</td></tr>\n<tr><td>preview </td><td>preview script to use</td></tr>\n<tr><td>previewicon </td><td>preview icon (document edit form)</td></tr>\n<tr><td>publishicon </td><td>icon used in the publish command </td></tr>\n<tr><td>pviewicon </td><td>icon used for the preview (small)</td></tr>\n<tr><td>replyicon </td><td>icon used in the reply comments command</td></tr>\n<tr><td>resetpwd</td><td>reset password icon</td></tr>\n<tr><td>rssfeeddir</td><td>directory for RSS feed (relative to the base dir)</td></tr>\n<tr><td>rssicon </td><td>rss feed icon</td></tr>\n<tr><td>selecticon</td><td>icon used for the select command </td></tr>\n<tr><td>templates-fh</td><td>height for the edit template window</td></tr>\n<tr><td>templates-fw</td><td>width for the edit template window </td></tr>\n<tr><td>templatesicon </td><td>template icon</td></tr>\n<tr><td>texts-fh</td><td>height for the edit text window</td></tr>\n<tr><td>texts-fw</td><td>width for the edit text window </td></tr>\n<tr><td>textsicon </td><td>texts icon </td></tr>\n<tr><td>thumbdir</td><td>subdir of the image/host dir where the thumbs are</td></tr>\n<tr><td>title </td><td>main title of the web site </td></tr>\n<tr><td>topics</td><td>document icon</td></tr>\n<tr><td>unlockicon</td><td>lock open icon </td></tr>\n<tr><td>unpublishicon </td><td>icon used in the un-publish command</td></tr>\n<tr><td>upicon</td><td>Promote to root icon </td></tr>\n<tr><td>uploaddir </td><td>temporary directory for uploading</td></tr>\n<tr><td>userdefault </td><td>default options for the user edit screen </td></tr>\n<tr><td>userremoveicon</td><td>user remove icon </td></tr>\n<tr><td>users-fh</td><td>height fo the edit user window </td></tr>\n<tr><td>users-fw</td><td>width for the edit user window </td></tr>\n<tr><td>usersicon </td><td>users icon </td></tr>\n</table><p>\n\n<b>Note:</b> if the parameters aren\'t in the db, things will start not-working.<p>\n','no','no'),('helpsite',23,'70','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 18:59:20','2009-06-24 17:01:45','Parametri di configurazione','Parametri di configurazione','I parametri di configurazione sono usati sia dal backoffice che dal frontoffice. In\nquesto modo, modificando un solo parametro si agisce su entrambi i fronti in un\ncolpo solo.<p>\n\nAll\'inizio, tutti i parametri erano nel file di configurazione. Il che significava\npero\' che il file era mastodontico e richiedeva modifiche manuali troppo laboriose.\nPer questo motivo ho deciso di spostare <b>tutti</b> i parametri di configurazione\nnel database e lasciare nel file solo i parametri necessari per l\'accesso al\ndatabase.<p>\n\nDi seguito e\' fornito un elenco dei parametri di configurazione usati dal sistema.<p>\n\n<table width=\'100%\' bgcolor\'lightblue\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>parametro</b></td>\n<td><font color=\'white\'><b>descrizione</b></td>\n</tr>\n<tr><td>404icon </td><td>icon used for the 404 document </td></tr>\n<tr><td>accepticon</td><td>confirm/accept icon</td></tr>\n<tr><td>addbutton </td><td>add button icon</td></tr>\n<tr><td>addicon </td><td>add icon </td></tr>\n<tr><td>articles</td><td>articles icon</td></tr>\n<tr><td>avatardir </td><td>subdir where the avatars icons are placed</td></tr>\n<tr><td>base</td><td>base directory </td></tr>\n<tr><td>buttondir </td><td>directory for the buttons</td></tr>\n<tr><td>closeicon </td><td>icon used in the close command </td></tr>\n<tr><td>commaddicon </td><td>icon used in the enable comments command </td></tr>\n<tr><td>commdelicon </td><td>icon used in the disable comments command</td></tr>\n<tr><td>commedit-fh </td><td>height for the edit comment wnd</td></tr>\n<tr><td>commedit-fw </td><td>width for the edit comment wnd </td></tr>\n<tr><td>comments-fh </td><td>height for the edit comment window </td></tr>\n<tr><td>comments-fw </td><td>width for the edit comment window</td></tr>\n<tr><td>commentsicon</td><td>comments icon</td></tr>\n<tr><td>config-fh </td><td>height for the edit configuration parameters wnd </td></tr>\n<tr><td>config-fw </td><td>width for the edit configuration parameters wnd</td></tr>\n<tr><td>configicon</td><td>config params icon </td></tr>\n<tr><td>cookiehost</td><td>identification cookie</td></tr>\n<tr><td>copybutton</td><td>icon used in the copy command</td></tr>\n<tr><td>copyicon</td><td>icon used in the copy button </td></tr>\n<tr><td>css </td><td>default CSS</td></tr>\n<tr><td>debug </td><td>enable/disable debugging </td></tr>\n<tr><td>defavatar </td><td>default avatar icons </td></tr>\n<tr><td>defdocicon</td><td>default document\'s icon</td></tr>\n<tr><td>deflang </td><td>default language </td></tr>\n<tr><td>delicon </td><td>icon used in the delete or remove command</td></tr>\n<tr><td>disableicon </td><td>icon used in the disable display command </td></tr>\n<tr><td>dociconsdir </td><td>documents icon directory </td></tr>\n<tr><td>documents-fh</td><td>height for the edit document window</td></tr>\n<tr><td>documents-fw</td><td>width for the edit document window </td></tr>\n<tr><td>documentsicon </td><td>document icon</td></tr>\n<tr><td>downicon</td><td>Demote to user icon</td></tr>\n<tr><td>editicon</td><td>icon used in the edit comments command </td></tr>\n<tr><td>edituserheight</td><td>height for the edit user window</td></tr>\n<tr><td>edituserwidth </td><td>width for the edit user window </td></tr>\n<tr><td>emocode </td><td>Code for the emoticons </td></tr>\n<tr><td>emodecode </td><td>Decode for the emoticons </td></tr>\n<tr><td>emoticonsdir</td><td>subdir where the emoticons icons are placed</td></tr>\n<tr><td>enableicon</td><td>icon used in the enable display command</td></tr>\n<tr><td>feed-fh </td><td>height for the edit RSS feed window</td></tr>\n<tr><td>feed-fw </td><td>width for the edit RSS feed window </td></tr>\n<tr><td>fragments-fh</td><td>height for the edit fragments window </td></tr>\n<tr><td>fragments-fw</td><td>width for the edit fragments windows </td></tr>\n<tr><td>fragmentsicon </td><td>fragment icon</td></tr>\n<tr><td>genrssicon</td><td>rss feed icon</td></tr>\n<tr><td>groups-fh </td><td>height for the edit group window </td></tr>\n<tr><td>groups-fw </td><td>width for the edit group window</td></tr>\n<tr><td>groupsicon</td><td>icon for the groups</td></tr>\n<tr><td>helpicon</td><td>icon for the help function </td></tr>\n<tr><td>helplink</td><td>where is the help? </td></tr>\n<tr><td>hosts-fh</td><td>height for the edit host window</td></tr>\n<tr><td>hosts-fw</td><td>width for the edit host window </td></tr>\n<tr><td>hostsicon </td><td>hosts icon </td></tr>\n<tr><td>htmlcode</td><td>Code for the char replacement in comments</td></tr>\n<tr><td>htmldecode</td><td>Char for the char replacement in comments</td></tr>\n<tr><td>iconsdir</td><td>icons</td></tr>\n<tr><td>images-fh </td><td>height for the edit image wnd</td></tr>\n<tr><td>images-fw </td><td>width for the edit image wnd </td></tr>\n<tr><td>imgdir</td><td>base directory for images</td></tr>\n<tr><td>imgicon </td><td>icon for the Images function </td></tr>\n<tr><td>imgmaxsize</td><td>maximum size (in kbyte) o picture to upload</td></tr>\n<tr><td>ips </td><td>list of IPs with no viewing restrictions </td></tr>\n<tr><td>js</td><td>default javascript name</td></tr>\n<tr><td>languages </td><td>supported languages</td></tr>\n<tr><td>limit </td><td>max document to list </td></tr>\n<tr><td>lockicon</td><td>lock closed icon </td></tr>\n<tr><td>login </td><td>login script to use</td></tr>\n<tr><td>logindefault</td><td>default options for the login screen </td></tr>\n<tr><td>loginicon </td><td>login icon </td></tr>\n<tr><td>logout</td><td>logout user script to use</td></tr>\n<tr><td>logouticon</td><td>logout icon</td></tr>\n<tr><td>maxsizeicon </td><td>Maximum size of a user icon (in Kb)</td></tr>\n<tr><td>mkthumb </td><td>instruction used to resize and create thumbnails </td></tr>\n<tr><td>postnew </td><td>postnew script to use</td></tr>\n<tr><td>preview </td><td>preview script to use</td></tr>\n<tr><td>previewicon </td><td>preview icon (document edit form)</td></tr>\n<tr><td>publishicon </td><td>icon used in the publish command </td></tr>\n<tr><td>pviewicon </td><td>icon used for the preview (small)</td></tr>\n<tr><td>replyicon </td><td>icon used in the reply comments command</td></tr>\n<tr><td>resetpwd</td><td>reset password icon</td></tr>\n<tr><td>rssfeeddir</td><td>directory for RSS feed (relative to the base dir)</td></tr>\n<tr><td>rssicon </td><td>rss feed icon</td></tr>\n<tr><td>selecticon</td><td>icon used for the select command </td></tr>\n<tr><td>templates-fh</td><td>height for the edit template window</td></tr>\n<tr><td>templates-fw</td><td>width for the edit template window </td></tr>\n<tr><td>templatesicon </td><td>template icon</td></tr>\n<tr><td>texts-fh</td><td>height for the edit text window</td></tr>\n<tr><td>texts-fw</td><td>width for the edit text window </td></tr>\n<tr><td>textsicon </td><td>texts icon </td></tr>\n<tr><td>thumbdir</td><td>subdir of the image/host dir where the thumbs are</td></tr>\n<tr><td>title </td><td>main title of the web site </td></tr>\n<tr><td>topics</td><td>document icon</td></tr>\n<tr><td>unlockicon</td><td>lock open icon </td></tr>\n<tr><td>unpublishicon </td><td>icon used in the un-publish command</td></tr>\n<tr><td>upicon</td><td>Promote to root icon </td></tr>\n<tr><td>uploaddir </td><td>temporary directory for uploading</td></tr>\n<tr><td>userdefault </td><td>default options for the user edit screen </td></tr>\n<tr><td>userremoveicon</td><td>user remove icon </td></tr>\n<tr><td>users-fh</td><td>height fo the edit user window </td></tr>\n<tr><td>users-fw</td><td>width for the edit user window </td></tr>\n<tr><td>usersicon </td><td>users icon </td></tr>\n</table><p>\n\n<b>Nota:</b> i parametri devono esserci, altrimenti le cose cominciano a funzionare poco bene.\nIl database di default contiene valori relativamente giusti per una installazione di default.<p>\n','no','no'),('helpsite',23,'80','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 19:08:21','2009-06-26 13:05:03','Download and Installation','Download and Installation','<b>Warning!:</b><p>\n\nThis installations refer to a generic Linux system.<p>\n\n<b>System Requirements</b><p>\n\nBefore installing check if all the required softwares and modules are there and\nrunning, otherwise there is no sense.<p>\n\n<ol>\n<li><b>Apache</b><br>\nI suppose the CMS could also run on something else, but I\'ve never tested, if\nyou try and doesn\'t work, don\'t ask me. On the other hand, if it does work, please\ndrop me a mail so I can fix the docs.<p>\n\n<li><b>Perl 5.8.8 or better</b><br>\nAnd a lot of extra modules:<p>\n\n<ul>\n<li>DBI e DBI::mysql for database support\n<li>CGI e CGI::Cookie for login\n<li>Shell for a lot of things\n<li>Config::General for the configuration\n<li>Mail::Sendmail to send mail\n<li>Email::Valid to check addresses\n<li>Digest::MD5 for password encryption\n<li>Date::Format and Date::Parse\n<li>XML::RSS to generate the Feed\n<li>Mail::SpamAssassin for comments\' control\n</ul><p>\n\nA lot of these modules requires more modules. Expecially things like XML::RSS,\nSpamAssassin and Sendmail. My suggestion is to go with CPAN and check which\nmodules are ok and which you need to install.<p>\n\n<li><b>\n<a href=\'http://www.imagemagick.org/\'>ImageMagick</a></b><br>\nIs used to resize pictures and icons.<p>\n\n<li><b>File</b><br>\nThe <code>file</code> utility is used to check file types. It should be part of\nany distribution.<p>\n\n<li><b>MySQL with InnoDB</b><br>\nYou need MySQL with InnoDB support.<p>\n\n</ol>\n\n<b>Download</b><p>\n\nGet the whole shebang from:\n<a href=\'http://www.soft-land.org/archivio/cmsfdt40.tar.gz\'>\nhttp://www.soft-land.org/archivio/cmsfdt40.tar.gz</a>.<p>\n\n<b>Installation</b><p>\n\nDecide where you want to install the CMS, usually around /var/www, \n/var/httpd or /var/html, depending on your distribution and the way your\nsystem is configured.<p>\n\nJust as example, we are going to install it in <b>/opt/cmsfdt4</b>.<p>\n\n<code><pre>\nmkdir -p /opt/cmsfdt4\nchmod 755 /opt /opt/cmsfdt4\ncd /opt/cmsfdt4\nwget http://www.soft-land.org/archivio/cmsfdt40.tar.gz\ntar xzvf cmsfdt40.tar.gz\n</pre></code>\n\nThis will make up the basic structure and all the required files. Now is\ntime to configure it.<p>\n\n<b>Configuration</b><p>\n\nTo configure the CMS there is an installation script <b>install.pl</b> in the\nmain directory. The script asks some questions and perform 99.9% of the whole\ninstallation. Unfortunately, it can\'t do everything. In specific, it can\'t\nconfigure Apache for you since he doesn\'t know where the config files are and\nwhat kind of configuration your system uses.<p>\n\nSo he\'ll make a \"basic\" config and then you\'ll have to finish it. See below\nthe part related with Apache.<p>\n\nIf you don\'t want to use the script, or you like to know what\'s going on under\nthe hood, keep reading.<p>\n\n<b>Database creation</b><p>\n\nTo create the database you can use any interface tool with MySQL, the standard\nmysql client is fine. Obviously you\'ll need to know the Root password. If you\ncan\'t create a new database you\'ll have to ask the Sysadmin to create it for\nyou and provide a username and password to use it.<p>\n\nOnce you have the empty database and a user, it is possible to create the\nstructure and to import the minimal data for the system to work. To do so,\nthere is a .sql script in the <code>scripts</code> directory called\n\'cms40.sql\'.<p>\n\n<b>Rights and Permissions</b><p>\n\nBe sure that all the directories and the files are readable by the web server,\nat least they should be 644 for files and 755 for directories.<p>\n\nThe .pl scripts in the <code>cgi-bin</code> should be executable also, a simple\n<code>chmod 755 cgi-bin/*.pl</code> should be enough.<p>\n\nNote: cmsfdtcommon.pl doesn\'t need to be executed.<p>\n\nThe directories <code>icons/avatars/custom</code>, <code>rss</code> and\n<code>img</code> have to be writeable by the web server, so you either \nchange the owner of the directories or give them write permissions to\neverybody or the group. Another directory Apache need to write into is a\ntemporary directory, usually /tmp/upload. No other dirctories are written\nby Apache, so give everything else to the root user with 755 \npermissions.<p>\n\n<b>CMS Configuration</b><p>\n\nThe basic CMS config file (cms.conf) is in the cgi-bin directory. The file has\nto contain the informations required to access the database. Nothing else.<p>\n\n<pre><code>\ndbname          -the dbname-\ndbuser          -the dbuser-\ndbpass		-the dbpass-\ndbserv          localhost\ndbport          3306\n</code></pre><p>\n\nAt least the first 3 parameters have to be modified with the <b>correct</b>\nparameters.<p>\n\n<u>DO NOT USE <i>root</i> to access the database</u>.<p>\n\n<b>Apache Configuration</b><p>\n\nYou need to configure a couple of VHosts. If you\'ve used the install script a\nconfiguration script for apache has been generated in the scripts directory,\nwhat you need to do is to review it and then \"merge\" that into the default\nApache configuration. The script is \'httpd-cms40.conf\'. If you haven\'t used the\ninstall script, get the \'example\' one and fix it for your needs.<p>\n\nFirst of all, all the ROOTDIR instances should be replaced with the correct\nweb site root dir (in our example /opt/cmsfdt4), then you need to specify\nthe name/aliases for each site, the default one and the backoffice.<p>\n\nHow to \"merge\" this into your Apache configuration depends on the kind of\ndistribution and how they manage different configuration files. For CentOS/RH\nyou only need to put the generated/edited .conf file in /etc/httpd/conf.d.<p>\n\n<b>SpamAssassin</b><p>\n\nIn the cgi-bin dir there is a Spamassassin preference file named \'user_prefs\',\nthis should be ok for 99.9% of cases but can be tailored for your own needs.<p>\n\n<b>Testing</b><p>\n\nIf you\'ve done all, you should be able to go. Do a\n<code>apachectl configtest</code> and if you don\'t see any error run a\n<code>apachectl restart</code> and you should be good to go. Point your\nbrowser to your CMS and you should see the login prompt.<p>\n\nThe default root user is \'root@mydomain.com\' with password \'password\'.<p>\n\nAs soon as you\'ve logged in, create a new \'root\' user with a <b>real</b>\npassword and remove the default one.<p>\n\nSecond thing to do is to drop me a mail.<p>\n\n<p><b>And if it doesn\'t work?</b></p>\n\n<p>See the <!--ref=troubleshooting-->Troubleshooting</a> chapter.</p>\n\n','no','no'),('helpsite',23,'80','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-19 19:08:58','2009-06-26 13:04:04','Download ed Installazione','Download ed Installazione','<p><b>Nota importantissima:</b></p>\n\n<p>Questa installazione si riferisce ad un sistema Linux generico.</p>\n\n<p><b>Requisiti di Sistema</b></p>\n\nPrima di installare il CMS e\' necessario verificare che tutte le librerie\ned i software di supporto siano installati.<p>\n\n<ol>\n<li><b>Apache</b><br>\nSuppongo che il Cms possa funzionare con altri web server, ma non ho mai provato, \nquindi se qualche cosa non funziona non domandate a me. Se pero\' ci provate e \nscoprite che funziona, per cortesia fatemelo sapere, cosi\' posso aggiornare la \ndocumentazione.<p>\n\n<li><b>Perl 5.8.8 o superiore</b><br>\nE tutta una serie di moduli aggiuntivi:<p>\n\n<ul>\n<li>DBI e DBI::mysql per il supporto database\n<li>CGI e CGI::Cookie per la gestione dei parametri ed il login\n<li>Shell per varie funzioni generali\n<li>Config::General per la configurazione\n<li>Mail::Sendmail per inviare la posta\n<li>Email::Valid per la verifica degli indirizi\n<li>Digest::MD5 per la criptatura delle password\n<li>Date::Format e Date::Parse\n<li>XML::RSS per la generazione dei feed\n<li>Mail::SpamAssassin per il controllo dei commenti\n</ul><p>\n\nMolto probabilmente molti di questi moduli richiedono a loro volta dei moduli\naggiuntivi, in particolare <b>Mail::Sendmail</b> e <b>Mail::Spamassassin</b>.\nIl mio consiglio e\' di andare di CPAN e verificare che siano installati ed \neventualmente installarli con le loro dipendenze.<p>\n\n<li><b>\n<a href=\'http://www.imagemagick.org/\'>ImageMagick</a></b><br>\nPer il ridimensionamento delle immagini (icone et similia). Se non e\' installato \ndovrete installarlo.<p>\n\n<li><b>File</b><br>\nL\'utility <code>file</code> e\' usata per il controllo dei file. Dovrebbe far\nparte di tutte le distribuzioni.<p>\n\n<li><b>MySQL con InnoDB</b><br>\nVi serve MySQL con supporto per InnoDB.<p>\n\n</ol>\n\n<b>Download</b><p>\n\nScaricate il codice da\n<a href=\'http://www.soft-land.org/archivio/cmsfdt40.tar.gz\'>\nhttp://www.soft-land.org/archivio/cmsfdt40.tar.gz</a>.<p>\n\n<b>Installazione</b><p>\n\nDecidete dove mettere il CMS. Di solito da qualche parte sotto /var/www,\n/var/httpd o /var/html, a seconda della vostra distribuzione e del vostro sistema.<p>\n\nTanto per fare le cose semplici, diciamo che abbiate deciso di installare\nil sistema in <b>/opt/cmsfdt4</b>.<p>\n\n<code><pre>\nmkdir -p /opt/cmsfdt4\nchmod 755 /opt /opt/cmsfdt4\ncd /opt/cmsfdt4\nwget http://www.soft-land.org/archivio/cmsfdt40.tar.gz\ntar xzvf cmsfdt40.tar.gz\n</pre></code>\n\nQuesto creera\' la struttura base del sito e copiera\' tutti i files necessari.<p>\n\n<b>Configurazione</b><p>\n\nPer la configurazione e\' possibile usare lo script di installazione\n<b>install.pl</b> che e\' nella directory del CMS stesso. Lo script e\' ragionevolmente\nsemplice ed esegue il 99% della configurazione ponendo delle semplici domande.\nMa non puo\' fare <u>tutto</u>. In particolare, non puo\' sapere dove avete la\nconfigurazione di Apache e come e\' fatta, quindi lui preparera\' una configurazione\n\"base\" e poi stara\' a voi l\'attivarla. Vedete piu\' sotto la parte ad Apache per\nulteriori informazioni.<p>\n\nSe non volete usare lo script di installazione o se volete sapere cosa\nlo script fa\', leggete oltre.<p>\n\n<b>Creazione del database</b><p>\n\nPer la creazione del database e\' possibile usare qualunque tool di interfaccia \ncon MySQL. La normale CLI di mysql va\' benissimo. Ovviamente, per creare il \ndatabase dovrete avere privilegi di root. Se non potete creare il database \ndovrete chiedere all\'amministratore del server di crearlo.<p>\n\nUna volta creato il databse \"vuoto\" ed assegnati i diritti ad un utente, e\'\npossibile creare la struttura dati ed importare i dati minimi per il funzionamento.\nA questo scopo c\'e\' uno script .sql nella directory <code>scripts</code> chiamato\ncms40.sql.<p>\n\n<b>Permessi, Diritti e Doveri</b><p>\n\nAssicuratevi che tutte le directory ed i file siano leggibili dal server web,\ncome minimo i files dovrebbero avere permessi 644 e le directory 755.<p>\n\nI files .pl nella directory <code>cgi-bin</code> devono essere eseguibili,\nun semplice <code>chmod 755 cgi-bin/*.pl</code> dovrebbe risolvere.<p>\nNota: cmsfdtcommon.pl non richiede permessi di esecuzione in quanto non e\'\nmai richiamato direttamente, ma avere permessi di esecuzione non dovrebbe\ndanneggiarlo.<p>\n\nLe directory <code>icons/avatars/custom</code>, <code>rss</code> e \n<code>img</code> devono essere scrivibili dal server web. Quindi o cambiate \nl\'owner della directory impostando lo stesso owner sotto cui gira Apache o \ndate alla directory i permessi di scrittura a tutti. Un\'altra directory in \ncui Apache scrive e\' una directory temporanea per l\'upload. Create una directory \n<code>/tmp/upload</code> e dategli i permessi di scrittura all\'utente\ndi Apache. <b>Queste sono le uniche directory in cui Apache scrive</b>.<p>\n\n<b>Configurazione del CMS</b><p>\n\nIl file di configurazione del CMS (cms.conf) e\' nella directory \n<code>cgi-bin</code>. Il file deve contenere i dati minimi per\nla connessione al database:<p>\n\n<pre><code>\ndbname          -the dbname-\ndbuser          -the dbuser-\ndbpass		-the dbpass-\ndbserv          localhost\ndbport          3306\n</code></pre><p>\n\nAlmeno i primi 3 parametri devono essere modificati con i <b>vostri</b>\nparametri: come si chiama il database che avete creato, quale e\' l\'utente con\ncui volete accedere e quale e\' la sua password. Il server ed il numero di porta\nsono da modificare solo se il vostro database e\' su un server diverso e/o usa\nuna porta diversa dalla standard.<p>\n\n<u>Non usate <i>root</i> per accedere al database</u>.<p>\n\n<b>Configurazione di Apache</b><p>\n\nPer la configurazione di Apache occorre creare un paio di Virtual Hosts.\nSe avete usato lo script di configurazione (install.pl), il file di\nconfigurazione \"giusto\" dovrebbe essere stato creato per voi in\nscripts/httpd-cms40.conf, altrimenti dovrete prendere quello di esempio\ne modificarlo per il vostro sistema.<p>\n\nPer prima cosa, tutte le indicazioni della Root dir (ROOTDIR) dovrebbero\nessere sostituite con la posizione dove avete installato il CMS (nel\nnostro esempio /opt/cmsfdt4), poi occorre specificare quale nome/alias\nsi vuole assegnare al BackOffice del CMS e rimpiazzare \'CMSHOST\' con tale\nnome/alias.<p>\n\nUna volta corretto il file occorre \"attaccarlo\" alla configurazione di\nApache. A seconda della vostra distribuzione dovrebbe essere sufficiente mettere il\nfile di configurazione in /etc/httpd/conf.d o /etc/httpd/extra. Altrimenti\ndovrete integrare questo file con quello gia\' esistente.<p>\n\n<b>Configurazione di SpamAssassin</b><p>\n\nNella directory <code>cgi-bin</code> c\'e\' un file di configurazione di\nSpamAssassin chiamato <b>user_prefs</b>. Questo e\' un file minimale che, nel\nmio caso, blocca il 99.9% dei commenti-spam. Potete comunque modificarlo come\nvi aggrada, leggete la documentazione di SpamAssassin.<p>\n\n<b>Testing</b><p>\n\nSe avete fatto tutto dovreste essere pronti al lavoro. Provate a fare un\n<code>apachectl configtest</code>, se non vedete errori di sorta dovreste\nessere in grado di dare un <code>apachectl restart</code> e poi puntare il\nvostro browser sull\'URL che avete deciso di dare al CMS e vedere il \nBackOffice del CMS.<p>\n\nA questo punto si tratta di fare login. Nel database standard c\'e\' un solo\nutente chiamato \"root@mydomain.com\" con password \"password\".<p>\n\nSe siete arrivati qui\', la cosa successiva da fare e\' crare un nuovo utente\n\"root\" ed eliminare quello esistente.<p>\n\nLa seconda cosa e\' mandarmi una mail.<p>\n\n<p><b>E se non funziona?</b></p>\n\n<p>Vedete il capitolo <!--ref=troubleshooting-->Risoluzione dei problemi</a>.</p>\n','no','no'),('helpsite',23,'85','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-25 18:42:14','2009-06-26 10:33:42','Maintenance procedures','Some automated maintenance procedure','<p>Managing a site (or more) is not just a matter of writing some HTML code\nand put it up on display. You also need to take care of other things, like\n<i>comments approval</i>, <i>backups</i> and <i>RSS feed generation</i> just to\nname a few.</p>\n\n<p>Luckily for you, I\'ve done that before, so I wrote a number of scripts and procedures\nthat can simply be dropped in crontab to do everything at once.</p>\n\n<p><b>Backup</b></p>\n\n<p>In the <code>scripts</code> directory there is a shell script named <i>backup.sh</i>,\nthis script allow a full backup of one site.</p>\n\n<pre><code>\nbackup.sh <b>destinationdir</b> <i>host</i>\n</code></pre>\n\n<p>The <i>host</i> parameter is optional, if not specified <b>all</b> the hosts will be\nbacked-up. If it is specified, only that specific host will be backedup.</p>\n\n<p>The script perform a dump of the database related to that specific host and then pack\nthe dump and everything related to the host in the <code>img</code> directory into a\nsingle <code>.tar.gz</code> file in the specified directory. The directory must exists.</p>\n\n<p>Please, note that the script <b>does not</b> backup the users or the configuration\nparameters since those are <b>not</b> host-specific.</p>\n\n<p><b>Restore</b></p>\n\n<p>With the backup file produced above is not too difficult to manage a restore.</p>\n\n<p>First of all cd into the \"root\" directory of the CMS, untar the backup file\nand regenerate the img directory, then run a mysql command to restore the database.</p>\n\n<p><b>Log rotation</b></p>\n\n<p>This is not a procedure that I can automate. Is just a note.</p>\n<p>With the default installation the log files are generated in the <code>logs</code>\nsubdirectory of the site, it is a good idea if you add this directory and the log files\nto your normal log rotation procedure.</p>\n\n<p><b>RSS Feed Generation</b></p>\n\n<p>Whenever your content change you should regenerate your RSS feed. However, if your content\ndoesn\'t change too often, maybe you can schedule an automatic generation.</p>\n\n<p>In the <code>scripts</code> directory there is a simple script genrss.pl that can be called\nfrom the command line or cron to generate <b>all</b> the feed of the system. You can also specify\none single feed name (id) on the command line to generate only that specific feed.</p>\n\n<p>The syntax is the following:</p>\n\n<pre><code>genrss.pl <i>hostid</i> <i>rssid</i></code></pre>\n\n<p>If no parameter is specified, <b>all the feed, for all the hosts</b> are generated, if you specify\none host, all the feed of that host will be generated. If you specify both the host and the feed, just that\nfeed will be generated.</p>\n\n<p><b>Autopublishing of documents</b></p>\n\n<p>Sometimes you want some documents to be automatic published at specific time.</p>\n<p>To do so, in the <code>scripts</code> directory there is a script called <code>autopub.pl</code>, this\nscript can be called with an hostid/groupid. It will pick the first non-published document and set it\nas published.</p>\n\n<pre><code>autpub.pl <i>hostid</i> <i>groupid</i></code></pre>\n\n<p>Note that both parameters are mandatory.</p>\n','no','no'),('helpsite',23,'85','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-25 18:42:39','2009-06-26 10:48:33','Procedure di manutenzione','Alcune procedure di manutenzione','<p>La gestione di un sito (o piu\' di uno) non e\' solo scrivere qualche documento e\nmetterlo in mostra. Occorre anche fare un po\' di manutenzione, per esempio <i>approvare\ni commenti</i>, <i>fare i backups</i> e <i>generare i feed RSS</i>, solo per menzionare\nle prime cose.</p>\n\n<p>Fortunatamente per voi, io ci sono gia\' passato ed ho messo insieme un certo numero\ndi script per fare il lavoro. Gli script dovrebbero poter essere agganciati a\n<code>crontab</code> senza troppi problemi.</p>\n\n<p><b>Backup</b></p>\n\n<p>Nella directory <code>scripts</code> c\'e\' un semplice shell-script chiamato\n<i>backup.sh</i>, questo consente il backup completo di un singolo host.</p>\n\n<pre><code>\nbackup.sh <b>destinationdir</b> <i>host</i>\n</code></pre>\n\n<p>Il parametro <i>host</i> e\' facoltativo. Se non specificato <b>tutti</b> gli host\nverranno backuppati ed i file .tar.gz generati nella directory specificata.</p>\n\n<p>Lo script effettua un dump del database relativo al solo host specificato e quindi\nmette il dump e tutto cio\' che e\' collegato a quell\'host in un solo tar.gz.\nLa directory di destinazione deve esistere.</p>\n\n<p>Prego notare che lo script <b>non fa\' il backup</b> di utenti e parametri di\nconfigurazione dato che non sono host-specific.</p>\n\n<p><b>Restore</b></p>\n\n<p>Per il restore non c\'e\' uno script specifico ma con il file creato dallo script\ndi backup non dovrebbe essere troppo difficile ripristinare un host.</p>\n\n<p>Creare una directory temporanea e un-tarrare il file, copiare o muovere la directory\ndelle immagini e quindi fare un restore del database.</p>\n\n<p><b>Rotazione dei Log</b></p>\n\n<p>Questa non e\' una procedura, e\' solo una annotazione.</p>\n<p>Con la configurazione di default i files di log per l\'applicazione sono nella directory\n<code>logs</code>, magari e\' una buona idea agganciare questi files alla normale rotazione\ndei log presente sul sitema.</p>\n\n<p><b>Generazioe Feed RSS</b></p>\n\n<p>Quando il contenuto del sito cambia i feed rss dovrebbero essere rigenerati. Tuttavia,\nse il contenuto non cambia troppo spesso o <b>se</b> cambia troppo spesso e\' possibile fare\nla generazione solo una volta ogni tanto.</p>\n\n<p>Nella solita directory <code>scripts</code> c\'e\' uno script che puo\' essere richiamato\nda cron o da linea di comando per la generazione dei feed RSS. Lo script accetta due\nparametri: hostid e feedid.</p>\n\n<pre><code>genrss.pl <i>hostid</i> <i>rssid</i></code></pre>\n\n<p>Se nessun parametro e\' specificato lo script rigenerera\' <b>tutti i feed</b>, se viene specificato\nun host, solo i feed di quell\'host saranno rigenerati. Se viene specificato un host ed un feed, solo\nquello specifico feed sara\' rigenerato.</p>\n\n<p><b>Publicazione automatica di documenti</b></p>\n\n<p>Qualche volta e\' utile il poter pubblicare dei documenti automaticamente.</p>\n<p>Nella directory <code>scripts</code> c\'e\' uno script chiamato \n<code>autopub.pl</code>, questo script ricevere come parametri un hostid e groupid, recuperare il\nprimo documento non pubblicato nel gruppo specificato e lo pubblica.</p>\n\n<pre><code>autpub.pl <i>hostid</i> <i>groupid</i></code></pre>\n\n<p>Entrambi i parametri sono obbligatori.</p>\n','no','no'),('helpsite',23,'90','en','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-23 14:44:54','2009-06-26 13:26:22','Troubleshooting','Common problems and solutions','<p>First of all, <b>this is not an helpdesk</b>. If you have a problem with\nthe CMS, you can post a comment, drop me a mail\nor use the\n<A href=\'https://sourceforge.net/forum/forum.php?forum_id=971143l\'>forum</a> on\nSourceForge, I\'ll try to look at it but, since I\'m here and you\'re there, I can\'t do much. You\'ll have to\n(mostly) figure things out by yourself. Sorry but you get what you pay\nfor.</p>\n\n<p>If you find and solve a problem with the CMS, feel free to drop me a\nmail detailing the problem and the solution, I\'ll include in the docs\nor fix the code.</p>\n\n<p>So, what you do if something doesn\'t work as expected?</p>\n\n<p>\n<ol>\n<li><b>Read the logs</b><br>\nThe default config put the error log in the <code>logs</code> directory,\nrun a <code>tail -f</code> on it and try again, check what error are\nlogged. Most of the time the error is self-explaining.</li>\n<li><b>Enable the Debug mode</b><br>\nIf you set the <i>debug</i> parameter in the database to \'1\', a\n<i>HUGE</i> amount of informations will be printed on the screen with the\nrest of the output, this will usually point to where the problem lies.\n</li>\n</ol></p>\n\n<p><b>Installation problems</b></p>\n\n<p>Be sure you have the required rights to install stuff.</p>\n\n<p><b>Apache can\'t restart</b></p>\n\n<p>Run an <code>apachectl configtest</code> and see if he complaints about something. Check\nyour configuration.</p>\n\n<p><b>Error \"proxy: DNS lookup failure for:...\" in the browser</b></p>\n<p>This happens if you\'re doing testing and you have the web server\'s IP address\nin your /etc/hosts file instead of a DNS entry. In this case you need to have the\nsame entry in the web server\'s /etc/hosts file!</p>\n','no','no'),('helpsite',23,'90','it','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','docowner@mydomain.com','2009-06-23 14:45:26','2009-06-26 13:22:25','Risoluzione dei problemi','Cause dei comuni problemi e soluzioni','<p><b>Nota importantissima:</b> questo non e\' un help-desk.</p>\n\n<p>Se avete dei problemi con il CMS siete liberi di mandarmi una mail, aggiungere un commento\no usare\n<A href=\'https://sourceforge.net/forum/forum.php?forum_id=971143l\'>il forum</a> su SourceForge,\nma non aspettatevi risposte istantanee.</p>\n<p>Inoltre, non aspettatevi soluzioni senza sbattimento. Dato che <b>voi</b> siete davanti al\ncomputer ed io no, nella maggioranza dei casi i problemi li dovete risolvere da voi. Sorry,\nma ottenete cio\' che pagate.</p>\n\n<p>Se avete avuto e risolto un problema, per cortesia mandatemi una mail, cosi\' potro\' \ncorreggere il codice o la documentazione.</p>\n\n<p>Quindi... che cosa si fa quando qualche cosa non funziona?</p>\n<p><ol>\n<li><b>Leggete i files di log</b><br>\nIl file di configurazione di default mette i logs nella directory <code>logs</code>, i logs\nsono una fonte di informazioni da non sottovalutare. Leggeteli.</li>\n<li><b>Attivate il debug</b><br>\nImpostando ad \'1\' il parametro \'debug\' nel database, il CMS scrive una montagna di informazioni\nrelative al suo funzionamento nel normale flusso di dati. Questo e\' un ausilio notevole nel\ncapire che cosa non funziona.</li>\n</ol></p>\n\n<p><b>Problemi di installazione</b></p>\n\n<p>Assicuratevi per prima cosa di avere i diritti di scrittura sulle directory che cercate\ndi scrivere.</p>\n\n<p><b>Apache non riparte</b></p>\n\n<p>Usate <code>apachectl configtest</code> e vedete se si lamenta di qualche cosa, verificate\nla configurazione.</p>\n\n<p><b>Errore \"proxy: DNS lookup failure for:...\" nel browser</b></p>\n<p>Se state facendo dei test ed avete messo l\'indirizzo IP del server web nel vostro /etc/hosts\nfile (o equivalente sotto windows), assicuratevi di avere lo stesso IP/Host nel file\n/etc/hosts del server web!</p>\n','no','no'),('helpsite',24,'1','en','fancy','default.css','c61238247b8d3038375c43909914ecbb.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 19:05:11','2009-06-26 13:56:10','Frequent questions','and answers (I hope)','<p>These are the most frequently asked questions, with answers.</p>\n\n<p><b>What kind of license does it have?</b><br>\nGPL. You\'re free to do what you want with it, as long as you don\'t came nagging\nme.</p>\n\n<p><b>The built-in editor is really minimal..</b><br>\nI know. I\'ve added it just for convenience.</p>\n\n<p><b>I\'ve made a bunch of .CSS and templates!</b><br>\nDrop me a mail.</p>\n\n<p><b>I like it, but I need some modifications...</b><br>\nHow much do you pay?</p>\n\n<p><b>I think I\'ve found a bug...</b><br>\nIf you\'ve found a bug, drop me a mail or add a note, if  you\'ve found the\nsolutions also, report that too so I\'ll be able to adjust the code or the\ndocumentation.</p>','no','no'),('helpsite',24,'1','it','fancy','default.css','c61238247b8d3038375c43909914ecbb.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 18:51:33','2009-06-26 13:44:57','Domande frequenti','e risposte (spero)','<p>Di seguito sono raccolte le domande piu\' frequenti, con corrisponenti risposte.</p>\n\n<p><b>Con che licenza e\' distribuito?</b><br>\nGPL. Siete liberi di farci quello che volete, basta che poi non mi venite a rompere\ni marroni a me.</p>\n\n<p><b>L\'editor per i documenti e\' veramente minimo...</b><br>\nLo so, l\'ho messo solo per convenienza.</p>\n\n<p><b>Ho una carriolata di CSS e Template da mandarti!</b><br>\nMandameli via mail.</p>\n\n<p><b>Mi piace il prodotto ma mi servirebbero alcune modifiche...</b><br>\nQuanto paghi?</p>\n\n<p><b>Mi sa che ho trovato un bug...</b><br>\nSe hai trovato un bug mandami una mail spiegando il bug ed eventualmente la soluzione\n(se l\'hai), vedro\' che posso farci o aggiungero la patch alla documentezione.</p>','no','no'),('helpsite',24,'2','en','fancy','default.css','c61238247b8d3038375c43909914ecbb.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 19:05:49','2009-07-01 11:33:16','New features and wishes','Which new functions will be in the next version?','<p>This is a short list of new features that I\'m thinking about including in the\nnext version of the CMS. You\'re free to chip in with your ideas, I\'ll check\nthem out and, if they do make sense and are interesting enough, I\'ll add them\nto the list.</p>\n\n<p>\n<ol>\n<li>\"Automoderation\"<br>\nAdd a flag on the user to allow his/her post to be published without the\nmoderation.</li>\n<li>Review the import-document function<br>\nRight now there is no control in what is imported, it could be any sort of\njunk.</li>\n<li>The template should be pure .html<br>\nThe CMS now is handling the headers of the generated document, everything from\nthe &lt;html&gt; tag to the whole \'head\' section. It would be nice if the template\ncould overwrite this stuff.</li>\n<li>CSS management<br>\n<li>Configuration window<br>\nTo manage the various parameters.</li>\n<li>Logging<br>\nI love logging! When you\'ve a problem is the first place where to look!\nRight now the system doesn\'t log anything, if there is an error it goes\nin the normal Apache logs. I\'d like to add a personalized log file to track\nuser\'s activities as well as problems and internal stuff.</li>\n</ol>\n</p>\n\n','no','no'),('helpsite',24,'2','it','fancy','default.css','c61238247b8d3038375c43909914ecbb.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 18:52:36','2009-07-01 11:25:24','Nuove funzioni e commenti','Quali nuove funzioni dovrebbero essere nella prossima versione','<p>Questo e\' un elenco delle nuove funzionalita\' che sono in programma per la nuova\nversione del CMS. Siete liberi di aggiungere le vostre opinioni, queste saranno\nvagliate e, se hanno un senso o se sono abbastanza interessanti, le aggiungero\'\nall\'elenco.</p>\n\n<p>\n<ol>\n<li>\"Automoderazione\" degli utenti<br>\nUn flag sull\'utente che consente ai post effettuati di evitare la\nmoderazione manuale.</li>\n<li>Rivedere la funzione di importazione per i documenti<br>\nAl momento attuale non c\'e\' nessun controllo sul \"documento\" da uploadare,\ne\' possibile inserire qualunque schifezza.</li>\n<li>Il template dovrebbe poter essere un file .html puro<br>\nLe parti iniziali del documento generato sono \'hardwired\' nel codice del\nCMS. I tag &lt;html&gt; e l\'intera sezione \'head\' sono aggiunte automaticamente.\nSarebbe opportuno che il template potesse sovrascrivere questa roba.</li>\n<li>Gestione dei CSS<br>\n<li>Maschera di configurazione<br>\nPer la gestione dei vari parametri.</li>\n<li>Logging<br>\nIo adoro il logging! Quando ci sono dei problemi e\' il primo posto in cui\nguardare. Al momento attuale il CMS non logga nulla, se si verificano degli\nerrori vengono scritti nel log di Apache. Io voglio aggiungere un log\n\"privato\" in cui il sistema scrive cio\' che succede, in questo modo e\'\npossibile risalire a chi e\' che ha aggiunto/modificato il documento\ntal-de-tali.</li>\n</ol>\n</p>\n\n','no','no'),('helpsite',25,'000','en','fancy','default.css','253b1793d76eb75a44aa02961831b694.png','none','no','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 18:05:07','2009-07-01 08:30:26','Introduction','Welcome to the CMS FDT','Welcome to the CMS Fdt v. 4.0 (and counting).<p>\n\nWhy did I decide to roll out my own CMS? I mean, there are a lot of them\naround. Well, yes. But none of them was what I was looking for.<p>\n\nLong time ago, I began my site writing down raw html directly my \nbeloved editor (vim). But after a while it became clear that I needed\nsomething a little more structured to avoid repeating over and over the\nsame thing. I needed a CMS.<p>\n\nI started looking around, but couldn\'t find anything I liked. Most of\nthe CMS that were free were designed mostly for a standard \'blog\',\nall of them were made in PHP and none had what I wanted.<p>\n\nSo what is it that I wanted?<p>\n\nI want to be able to have one <i>template</i> or <i>layout</i> for each\npage (eventually), in order to be able to display each page as I\nlike.<p>\n\nI want to be able to manage the documents in <i>groups</i> (that are\nthe equivalent to directories), so I can refer to a document like\n/something/document or /something/somethingelse/document.<p>\n\nI don\'t mind an editor, but I want to be able to write the documents on\nmy PC, using my favourite editor and then upload them on the system.<p>\n\nI want the ability to easily incorporate <i>blocks</i> of html into\neither the <i>template</i> or the <i>document</i>, and then display the\nwhole thing as one.<p>\n\nIn the end, I sat down and wrote my own CMS. This is the 4th version,\nthe first one didn\'t really existed and the second one was only for internal\nuse. <p>\n\n<b>Basic carachteristics:</b><p>\n\n<ol>\n<li>Fully <i>multi-host</i><br>\nYou can create a new <i>host</i> on the fly, without any changes in the\nconfiguration of Apache.<p>\n<li>Support <i>multiple languages</i><br>\nEach document can be in many languages, the system try to pick the\nright one depending on the user\'s browser configuration.<p>\n<li>Mutlilinks<br>\nEach document can be associated with \'n\' <i>links</i> (URL).<p>\n<li>Fully <i>multiuser</i><br>\nEach <i>user</i> can have different permissions and authority to do\ndifferent stuff.<p>\n<li>Wholly <i>configurable</i><br>\nI\'ve tried to put all the possible parameters into a database, so to allow\neach and any aspect of the system to be configured without the need for\naccessing the server directly.<p>\n</ol><p>\n\n<hr>\n<b>Technical informations</b><p>\n\n<!--list=tecnica:fancylist-->\n<hr>\n<!--list=faq:fancylist-->\n','yes','yes'),('helpsite',25,'000','it','fancy','default.css','253b1793d76eb75a44aa02961831b694.png','none','no','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 18:07:22','2009-07-01 08:29:24','Introduzione','Benvenuti al CMS Fdt v. 4.0','Benvenuti nel CMS Fdt v. 4.0 (e continua).<p>\n\nPerche\' ho deciso di scrivermi il mio CMS invece di usarne uno gia\' fatto?\nPrima di tutto, perche\' a me piacciono le cose fatte come le voglio io,\nsecondo perche\' non riuscivo a trovarne uno che facesse quello che volevo\nio.<p>\n\nIl 99% dei Cms in circolazione sono in genere \"tarati\" per un blog.\nCioe\' una sequenza di post consecutivi.<p>\n\nIo voglio la possibilita\' di avere diverse \'pagine\', ognuna delle quali\n(ipoteticamente) potrebbe avere uno stile diverso. Volevo avere delle\n<i>sezioni</i>, che sono poi praticamente l\'equivalente delle directory. \nQuindi voglio potermi riferire ad un documento come /documenti/qualcosa o\n/storie/08/story1 e via cosi\'. Questo mi permette di organizzare\nle cose in modo piu\' logico e mi consente di creare in modo facile\nelenchi di documenti da presentare sul sito.<p>\n\nVoglio poter creare dei <i>blocchi</i> standard di codice html da\nincorporare dove voglio in base ad un <i>template</i> che definisce\ndove mettere le cose.<p>\n\nDulcis in fundo, io voglio poter creare i testi sul mio pc, con il\nmio editor preferito (vim) e poi uploadare il tutto sul sito.<p>\n\nIl risultato e\' stato che mi sono messo li\' ed ho <b>scritto</b> il mio\nCMS FDT (Fai Da Te).<p>\n\nIl Cms e\' iniziato molto semplice, si e\' evoluto progressivamente fino\nallo stato attuale.<p>\n\n<b>Caratteristiche di base:</b><p>\n\n<ol>\n<li>Completamente <i>multi-host</i><br>\nE\' possibile aggiungere un nuovo sito direttamente dall\'interfaccia\nsenza fare nulla di particolare.<p>\n<li>Completamente <i>multilingua</i><br>\nOgni documento puo\' essere inserito in molteplici lingue, il sistema cerca\nil documento nella lingua corretta basandosi sulle lingua impostate nel\nbrowser dell\'utente.<p>\n<li>Multilink<br>\nOgni documento puo\' avere \'n\' <i>links</i> (URL) associati.<p>\n<li><i>Multiutente</i><br>\nE\' possibile definire <b>host-owner</b> che gestiscono l\'intero\nhosts, <b>group-owner</b> che possono aggiungere o modificare\ninteri <i>gruppi</i> di documenti e cosi\' via.<p>\n<li>Completamente configurabile<br>\nHo cercato di mettere tutti i parametri nel database, in modo che\nnon ci sia niente di hard-wired nel codice.\n</ol><p>\n\n<hr>\n<b>Informazioni tecniche</b><p>\n\n<!--list=tecnica:fancylist-->\n<hr>\n<!--list=faq:fancylist-->\n','yes','yes'),('helpsite',26,'1','en','fancy','default.css','c98ef2e6c42bd926695f85ff0af80822.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 19:06:19','2009-07-01 12:00:39','Database structure','What\'s in the database and why','<p>The database structure has gone through several redesign during the development process,\nI still consider it a \"work in progress\". Most of the thing that I want to do are there.\nSome things could be certainly improved.</p>\n\n<p>You can see the whole structure by looking at the\n<a href=\'/img/helpsite/cms40.sql\' target=\'__blank\'>cms40.sql</a>\nsql script file.</p>\n\n<p>The database is based on 2 \"class\" of tables: host/document-related and support. The \"support\"\ntable are NOT connected with any specific host or document. These kind of tables are\nmainly: <i>users</i> and <i>configuration</i>.</p>\n\n<p>Host or document related tables are host or document related. These tables are:\n<i>hosts</i> (duh!), <i>images</i>, <i>fragments</i>, <i>deftexts</i>, <i>templates</i>,\n<i>groups</i>, <i>documents</i>, <i>links</i> and <i>comments</i>.</p>\n\n<h4>Support tables</h4>\n\n<p><b>Configuration</b><br>\nContains the configuration parameters that are used by the whoe system. Both the backoffice\nand the frontoffice uses the same configuration parameters.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>paramid</td><td>varchar(255)</td><td>none</td><td>not</td><td>yes</td><td></td></tr>\n<tr><td>value</td><td>varchar(255)</td><td>\'\'</td><td>not</td><td></td><td></td></tr>\n<tr><td>updated</td><td>timestamp</td><td>curtime</td><td>NOT</td><td></td><td></td></tr>\n<tr><td>description</td><td>varchar(255)</td><td>\'\'</td><td>not</td><td></td><td></td></tr>\n</table>\n</p>\n\n<p><b>Notes:</b> \"curtime\" is the current timestamp. The field is updated every time the paramter is\nupdated. As you can see, most of the field have a \'not null\' constraint, since I think that if\na field can be null, it shouldn\'t be there at all. The <i>description</i> field is used to make\nclear what the parameter is. Mostly.</p>\n\n<p><b>Users</b><br>\nContains the system\'s users. Each user can have multiple \"descriptions\", that are stored in the\nrelated table <b>userdescs</b>, the descriptions are actually only used for <i>authors</i>, that\nis, users that have documents.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n\n<tr><td>email</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>icon</td><td>varchar(255)</td><td>\'\'</td><td>not</td><td></td><td></td></tr>\n<tr><td>name</td><td>varchar(255)</td><td>\'\'</td><td>not</td><td></td><td></td></tr>\n<tr><td>registered</td><td>timestamp</td><td>curtime</td><td>not</td><td></td><td></td></tr>\n<tr><td>lastseen</td><td>datetime</td><td>none</td><td>yes</td><td></td><td></td></tr>\n<tr><td>password</td><td>varchar(255)</td><td>nopass</td><td>not</td><td></td><td></td></tr>\n<tr><td>random</td><td>varchar(255)</td><td>none</td><td>yes</td><td></td><td></td></tr>\n<tr><td>isroot</td><td>enum(\'yes\',\'no\')</td><td>no</td><td>not</td><td></td><td></td></tr>\n<tr><td>signature</td><td>varchar(255)</td><td>\'\'</td><td>not</td><td></td><td></td></tr>\n<tr><td>userchk</td><td>varchar(255)</td><td>none</td><td>yes</td><td></td><td></td></tr>\n\n</table></p>\n\n<p><b>Notes:</b> Nothing much to say here, the <b>lastseen</b> field is filled in by the\nlogin procedure. The <b>random</b> and <b>userchk</b> fields are also used by the\nauthentication procedure to ensure that one user can only log in ONCE.</p>\n\n<p><b>Userdesc</b><br>\nContains the descriptions for the users.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>userid</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td>users(email)</td></tr>\n<tr><td>language</td><td>varchar(2)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>content</td><td>text</td><td>none</td><td>yes</td><td></td><td></td></tr>\n</table></p>\n<p><b>Notes:</b> the <i>userid</i> field is used to connect the description with his user.</p>\n\n<h4>Hosts related tables</h4>\n\n<p><b>Hosts</b><br>\nThis table stores the hosts (sites) that are managed by the system. Only the <i>superuser</i>\n(root) can create a new host. Once created the host can be \"assigned\" to another user that becomes\nthe <i>host administrator</i> and can then alter the hosts and create/manage any other entity\nthat is under that host.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>localhost</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>created</td><td>timestamp</td><td>curtime</td><td>no</td><td></td><td></td></tr>\n<tr><td>aliases</td><td>varchar(255)</td><td>localhost</td><td>no</td><td></td><td></td></tr>\n<tr><td>css</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>deflang</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>owner</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n</table></p>\n\n<p><b>Notes</b> not much to say here.</p>\n\n<p><b>Templates</b><br>\nStores the templates that are used for an host.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>not</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>templateid</td><td>varchar(255)</td><td>none</td><td>not</td><td>yes</td><td></td></tr>\n<tr><td>title</td><td>varchar(255)</td><td>none</td><td>not</td><td></td><td></td></tr>\n<tr><td>content</td><td>text</td><td>none</td><td>not</td><td></td><td></td></tr>\n<tr><td>updated</td><td>timestamp</td><td>curtime</td><td>not</td><td></td><td></td></tr>\n<tr><td>isdefault</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>not</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Notes:</b> the templateid is used to refer to the template in the system, while the <i>title</i> is\njust to show the user. In fact, the <i>templateid</i> is the really important bit, the only reason why\nis shown in the system is because a template can be referred inside a document, so is important the\nuser knows about it. The <i>isdefault</i> bit is used to identify the \"default\" template. In case the\ntemplate that is referred by a document isn\'t found (strange, but always possible), the \"default\" one\nis used.</p>\n\n<p><b>Fragments</b><br>\nA fragment is a small piece of html code that is displayed inside a document or inside a template.\nIt doesn\'t have a template like a document, it doesn\'t have an owner and can\'t have comments or the\nlike. It has a language. For the rest, is treated almost like a document.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td>hosts(hostid)</td></tr>\n<tr><td>fragid</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>language</td><td>varchar(2)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>content</td><td>text</td><td>none</td><td>not</td><td></td><td></td></tr>\n<tr><td>name</td><td>varchar(255)</td><td>none</td><td>not</td><td></td><td></td></tr>\n<tr><td>created</td><td>timestamp</td><td>curdate</td><td>not</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Notes:</b> not much to say here.</p>\n\n<p><b>Deftexts</b><br>\nThe <i>deftexts</i> table contains <i>default texts</i>, those are small piece of text that are\nused to have simple text translations. They are not like <i>fragmenst</i>, these are much smaller\nand are <b>not</b> processed (there is no <i>metatag</i> translation.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td>hosts(hostid)</td></tr>\n<tr><td>textid</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>language</td><td>varchar(2)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>content</td><td>varchar(255)</td><td>none</td><td>not</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Images</b><br>\nIs used to organize and upload the pictures used in a site.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>imgid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>created</td><td>timestamp</td><td>curtime</td><td>no</td><td></td><td></td></tr>\n<tr><td>filename</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>author</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n</table></p>\n\n<p><b>Notes:</b> images are not strictly required for an host and nothing stops the user to use\nnormal &lt;img src=... &gt; link to \"attach\" images without storing the here. The picture are,\nin fact, <b>not</b> stored in the database. This is mostly used as a reminder of which pictures\nare available in the system and as a quick-option to link them using metatags.</p>\n\n<p><b>Rssfeeds</b><br>\nUsed to organize the rss feeds.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>rssid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>filename</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>title</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>description</td><td>text</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>link</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>language</td><td>varchar(5)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>author</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>copyright</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>subject</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>taxo</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>lastdone</td><td>datetime</td><td>none</td><td>yes</td><td></td><td></td></tr>\n</table></p>\n\n<h4>Documents related tables</h4>\n\n<p><b>Groups</b><br>\nGroups are the equivalent of <i>directories</i> in my head. The structure is hyerarchical\nwith the field <i>parentid</i> that allow groups to have sub-groups.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>groupid</td><td>int(11)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>parentid</td><td>int(11)</td><td>none</td><td>no</td><td>no</td><td></td></tr>\n<tr><td>name</td><td>varchar(255)</td><td>none</td><td>no</td><td>no</td><td></td></tr>\n<tr><td>template</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>templates(hostid,templateid)</td></tr>\n<tr><td>css</td><td>varchar(255)</td><td>\'\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>icon</td><td>varchar(255)</td><td>\'\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>rssid</td><td>varchar(255)</td><td>\'\'</td><td>yes</td><td></td><td></td></tr>\n<tr><td>comments</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>moderated</td><td>enum(\'yes\',\'no\')</td><td>\'yes\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>moderator</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>author</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>owner</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>isdefault</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Notes:</b> most of the parameters here are used as default in the documents beloging to\nthat group. Somebody could wonder why the <i>rssid</i> field doesn\'t have an fk pointing to \nthe <b>rssfeeds</b>. Simple: in that case all the documents should have an rss feed or belong \nto a \"fake\" one that never gets generated if you don\'t want a feed for some documents.\nNote also that the <i>parentid</i> <u>does not</u> have an fk pointing to the same table.\n</p>\n\n<p><b>Documents</b><br>\nNow we are getting into it. The documents are the \"core\" of the system.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>groupid</td><td>int(11)</td><td>none</td><td>no</td><td>yes</td><td>groups(hostid,groupid)</td></tr>\n<tr><td>documentid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>language</td><td>varchar(2)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>template</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>templates(hostid,templateid)</td></tr>\n<tr><td>css</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>icon</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>rssid</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>display</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>approved</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>comments</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>status</td><td>enum(\'close\',\'open\')</td><td>\'open\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>moderated</td><td>enum(\'yes\',\'no\')</td><td>\'yes\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>moderator</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>author</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>created</td><td>timestamp</td><td>curtime</td><td>no</td><td></td><td></td></tr>\n<tr><td>updated</td><td>datetime</td><td>curtime</td><td>no</td><td></td><td></td></tr>\n<tr><td>title</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>excerpt</td><td>text</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>content</td><td>text</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>isdefault</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>is404</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Notes:</b> oh the agony! I can already hear the screaming and the gritting of\nteeth... \"why did you put the content and the language in there??\". Well, let\'s face\nit, each document can have a moderator and an author. There is no rule that say that\nthe same document in two different language have to have the same author and moderator.\n<p>Or the same template and CSS for that matter. And they could belongs to different\n<p>RSS feeds too.\n<p>In fact, is very possible that two different author and moderator are handling the\ndocuments for different languages and be in different feeds.\n<p>So, exactly, what fields are \"common\" to a document regardless of the language?\n<p>Not many. So few that doesn\'t really make any sense to split the table in two.\n<p>Somebody else could ask why the RSSid doesn\'t have a fk pointing to the RSS. Well,\nthat\'s beceause in that case each document have to be in some RSS feed, even if you\ndon\'t want to generate a feed of such document. Or use a fake RSS that doesn\'t get\ngenerate ever.</p>\n\n<p><b>Links</b><br>\nAfter some testing, I decided that is a good thing to be able to have the same document\n\"appearing\" in two different places. With a normal filesystem, you just make a link.\nSo I added the \"links\" that are actually all the different URL that a document can have.\nA document can have at least ONE link.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>no</td><td>hosts(hostid)</td></tr>\n<tr><td>groupid</td><td>int(11)</td><td>none</td><td>no</td><td>no</td><td>groups(hostid,groupid)</td></tr>\n<tr><td>documentid</td><td>varchar(255)</td><td>none</td><td>no</td><td>no</td><td>documents(hostid,groupid,documentid)</td></tr>\n<tr><td>link</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n</table></p>\n\n<p><b>Note:</b> Links have no languages.</p>\n\n<p><b>Comments</b><br>\n<p>This table is used to store the comments for a specific document. Note that the comments\n<p><b>do not have language</b>. That\'s right. All the comments are in the same cauldron, \nregardless of the language.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>groupid</td><td>int(11)</td><td>none</td><td>no</td><td>yes</td><td>groups(hostid,groupid)</td></tr>\n<tr><td>documentid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>documents(hostid,groupid,documentid)</td></tr>\n<tr><td>commentid</td><td>int(11)</td><td>0</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>parentid</td><td>int(11)</td><td>0</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>userid</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>username</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>clientip</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>created</td><td>timestamp</td><td>curtime</td><td>no</td><td></td><td></td></tr>\n<tr><td>approved</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>title</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>comment</td><td>text</td><td>none</td><td>no</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Notes:</b> you can see that the userid references the users, this means that if I want to\nallow \'anonymous\' posts, I need to have a \'fake\' user to attribute posts to. I know,\nthat\'s kinda ugly, but I couldn\'t think a better way. This is the reason why the <b>name</b>\nfield is present in the comments too. So anonymous users can type their names.</p>\n','no','no'),('helpsite',26,'1','it','fancy','default.css','c98ef2e6c42bd926695f85ff0af80822.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 18:47:43','2009-07-01 11:53:00','Struttura del database','Cosa c\'e\' nel database e perche\'','<p>La struttura del database e\' passata attraverso parecchie revisioni durante il processo\ndi sviluppo, io la considero tutt\'ora \"in corso di lavorazione\". Parecche delle cose che\nsono qui\' sono come le voglio io, molte cose potrebbero essere migliorate.</p>\n\n<p>Lo script per generare l\'intera struttura dati e\'\n<a href=\'/img/helpsite/cms40.sql\' target=\'__blank\'>cms40.sql</a>.</p>\n\n<p>Il database e\' fondamentalmente basato su due \"classi\" di tabelle: relative all\'host/documento\no \"di supporto\". Queste ultime non sono attaccate a nessun host o documento e sono\nfondamentalmente solo due: <i>users</i> per gli utenti e <i>configuration</i> per i\nparametri di configurazione.</p>\n\n<p>Le tabelle relative agli Host ed ai Documenti sono:\n<i>hosts</i> (duh!), <i>images</i>, <i>fragments</i>, <i>deftexts</i>, <i>templates</i>,\n<i>groups</i>, <i>documents</i>, <i>links</i> e per ultimo <i>comments</i>.</p>\n\n<p>Come si puo\' vedere dalle varie strutture, la maggioranza dei campi hanno delle\nconstraint di NOT NULL. Questo perche\' io penso che se un campo puo\' essere null non\ndovrebbe esserci e basta.</p>\n\n<h4>Tabelle di supporto</h4>\n\n<p><b>Configuration</b><br>\nContiene i parametri di configurazione del sistema. Sia il backoffice che il front-office\nusano gli stessi parametri di configurazione.</p>\n\n<p>\n<table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>paramid</td><td>varchar(255)</td><td>none</td><td>not</td><td>yes</td><td></td></tr>\n<tr><td>value</td><td>varchar(255)</td><td>\'\'</td><td>not</td><td></td><td></td></tr>\n<tr><td>updated</td><td>timestamp</td><td>curtime</td><td>NOT</td><td></td><td></td></tr>\n<tr><td>description</td><td>varchar(255)</td><td>\'\'</td><td>not</td><td></td><td></td></tr>\n</table>\n</p>\n\n<p><b>Note:</b> \"curtime\" e\' la data/ora corrente. Il campo e\' aggiornato dal backoffice ogni\nvolta che il parametro e\' aggiornato. Il campo descrizione mi serve per visualizzare una\ndescrizione del parametro.</p>\n\n<p><b>Users</b><br>\nContiene gli utenti del sistema. Ogni utente puo\' avere molteplici \"descrizioni\", queste sono\nmemorizzate in una tabella accessoria <b>userdescs</b>. Le descrizioni sono usate solo per\ngli <i>autori</i>, cioe\' utenti che hanno dei documenti.</p>\n\n<p>\n<table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>email</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>icon</td><td>varchar(255)</td><td>\'\'</td><td>not</td><td></td><td></td></tr>\n<tr><td>name</td><td>varchar(255)</td><td>\'\'</td><td>not</td><td></td><td></td></tr>\n<tr><td>registered</td><td>timestamp</td><td>curtime</td><td>not</td><td></td><td></td></tr>\n<tr><td>lastseen</td><td>datetime</td><td>none</td><td>yes</td><td></td><td></td></tr>\n<tr><td>password</td><td>varchar(255)</td><td>nopass</td><td>not</td><td></td><td></td></tr>\n<tr><td>random</td><td>varchar(255)</td><td>none</td><td>yes</td><td></td><td></td></tr>\n<tr><td>isroot</td><td>enum(\'yes\',\'no\')</td><td>no</td><td>not</td><td></td><td></td></tr>\n<tr><td>signature</td><td>varchar(255)</td><td>\'\'</td><td>not</td><td></td><td></td></tr>\n<tr><td>userchk</td><td>varchar(255)</td><td>none</td><td>yes</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Note:</b> Non molto da dire qui. Il parametro <i>lastseen</i> e\' riempito con\nl\'ultimo login effettuato. I parametri <i>random</i> ed <i>userchk</i> sono usati dalla\nprocedura di autenticazione per evitare che qualcuno si finga qualcun\'altro.</p>\n\n<p><b>Userdesc</b><br>\nContiene le descrizioni in lingua per gli utenti.</p>\n\n<p>\n<table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>userid</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td>users(email)</td></tr>\n<tr><td>language</td><td>varchar(2)</td><td>en</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>content</td><td>text</td><td>none</td><td>yes</td><td></td><td></td></tr>\n</table></p>\n\n<h4>Tabelle relative agli Hosts</h4>\n\n<p><b>Hosts</b><br>\nQuesta tabella contiene gli <i>hosts</i> (siti) che sono gestiti dal sistema. Solo il\n<i>superutente</i> (root) e\' in grado di aggiungere o rimuovere un host. Una volta creato,\nun host puo\' essere <i>assegnato</i> ad un utente del sistema che diviene <i>host owner</i>\ned e\' in grado di gestirlo.</p>\n\n<p>\n<table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>created</td><td>timestamp</td><td>curtime</td><td>no</td><td></td><td></td></tr>\n<tr><td>aliases</td><td>varchar(255)</td><td>localhost</td><td>no</td><td></td><td></td></tr>\n<tr><td>css</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>deflang</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>owner</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n</table></p>\n\n<p><b>Templates</b><br>\nContiene i templates usati dai documenti di quell\'host.</p>\n\n<p>\n<table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>not</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>templateid</td><td>varchar(255)</td><td>none</td><td>not</td><td>yes</td><td></td></tr>\n<tr><td>title</td><td>varchar(255)</td><td>none</td><td>not</td><td></td><td></td></tr>\n<tr><td>content</td><td>text</td><td>none</td><td>not</td><td></td><td></td></tr>\n<tr><td>updated</td><td>timestamp</td><td>curtime</td><td>not</td><td></td><td></td></tr>\n<tr><td>isdefault</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>not</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Note:</b> il <i>templateid</i> e\' usato per identificare il template nel sistema, mentre il\n<i>title</i> e\' solo per visualizzazione. Ci si potrebbe domandare a che accidenti serve un id\ned un titolo che <b>devono essere entrambi univoci</b>, il motivo e\' che il titolo funziona piu\'\ncome una <i>descrizione</i> che come id. Ma l\'id mi serve perche\' il template potrebbe essere\nusato all\'interno di un documento e non tramite l\'interfaccia di gestione. Il parametro\n<i>isdefault</i> e\' usato per identificare un template di default nel caso in cui il documento\nsi riferisca ad un template inesistente (difficile, ma non impossibile).</p>\n\n<p><b>Fragments</b><br>\nUn <i>fragment</i> e\' un piccolo pezzo di codice html che viene visualizzato all\'interno di un\ndocumento o di un template. Il frammento non ha un suo template, non ha un autore e non ha\ncommenti, per il resto, e\' praticamente un documento.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td>hosts(hostid)</td></tr>\n<tr><td>fragid</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>language</td><td>varchar(2)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>content</td><td>text</td><td>none</td><td>not</td><td></td><td></td></tr>\n<tr><td>name</td><td>varchar(255)</td><td>none</td><td>not</td><td></td><td></td></tr>\n<tr><td>created</td><td>timestamp</td><td>curdate</td><td>not</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Note:</b> \"curdate\' e\' la data di sistema.</p>\n\n<p><b>Deftexts</b><br>\nI \"testi di default\" sono dei semplici testi (molto spesso una o due parole) che sono usate\nper tradurre piccoli frammenti di testo. Un deftext e\' quasi come un frammento, solo che non\nviene gestito nello stesso modo (non possono contenere <i>metatag</i> per esempio).</p>\n\n<p>\n<table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td>hosts(hostid)</td></tr>\n<tr><td>textid</td><td>varchar(255)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>language</td><td>varchar(2)</td><td>none</td><td>not</td><td>pk</td><td></td></tr>\n<tr><td>content</td><td>varchar(255)</td><td>none</td><td>not</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Images</b><br>\nQuesta tabella e\' usata per organizzare e gestire le immagini usate da un host. E\' perfettamente\npossibile includere un\'immagine usando un normale tag &lt;img src=..&gt; nel testo del documento,\nma avere le immagini referenziate nel db consente di avere una lista delle immagini usate ed\neventualmente ri-utilizzarle ed utilizzare dei metatag per gestirle.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>imgid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>created</td><td>timestamp</td><td>curtime</td><td>no</td><td></td><td></td></tr>\n<tr><td>filename</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>author</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n</table></p>\n\n<p><b>Rssfeeds</b><br>\nContiene i feed RSS per l\'host.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>curhost</td><td>no</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>rssid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>filename</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>title</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>description</td><td>text</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>link</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>language</td><td>varchar(5)</td><td>deflang</td><td>no</td><td></td><td></td></tr>\n<tr><td>author</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>copyright</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>subject</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>taxo</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>lastdone</td><td>datetime</td><td>none</td><td>yes</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Note:</b> niente di speciale qui.</p>\n\n<h4>Tabelle relative ai documenti</h4>\n\n<p><b>Groups</b><br>\nI gruppi sono, nella mia testa, l\'equivalente delle directory. La struttura e\' di tipo\ngerarchico, con il campo <i>parentid</i> che consente di \"attaccare\" i gruppi uno\nall\'altro come directory.</p>\n\n<p>\n<table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>groupid</td><td>int(11)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>parentid</td><td>int(11)</td><td>none</td><td>no</td><td>no</td><td></td></tr>\n<tr><td>name</td><td>varchar(255)</td><td>none</td><td>no</td><td>no</td><td></td></tr>\n<tr><td>template</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>templates(hostid,templateid)</td></tr>\n<tr><td>css</td><td>varchar(255)</td><td>\'\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>icon</td><td>varchar(255)</td><td>\'\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>rssid</td><td>varchar(255)</td><td>\'\'</td><td>yes</td><td></td><td></td></tr>\n<tr><td>comments</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>moderated</td><td>enum(\'yes\',\'no\')</td><td>\'yes\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>moderator</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>author</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>owner</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>isdefault</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Note:</b> parecchi dei parametri in questa tabella sono usati come default nei\nrispettivi documenti. Da notare che <i>parentid</i> <b>non ha</b> una foreign key\nche si riferisce alla stessa tabella.</p>\n\n<p><b>Documents</b><br>\nAdesso cominciamo a ragionare. I documenti sono il \"cuore\" del sistema.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>groupid</td><td>int(11)</td><td>none</td><td>no</td><td>yes</td><td>groups(hostid,groupid)</td></tr>\n<tr><td>documentid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>language</td><td>varchar(2)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>template</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>templates(hostid,templateid)</td></tr>\n<tr><td>css</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>icon</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>rssid</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>display</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>approved</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>comments</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>status</td><td>enum(\'close\',\'open\')</td><td>\'open\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>moderated</td><td>enum(\'yes\',\'no\')</td><td>\'yes\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>moderator</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>author</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>created</td><td>timestamp</td><td>curtime</td><td>no</td><td></td><td></td></tr>\n<tr><td>updated</td><td>datetime</td><td>curtime</td><td>no</td><td></td><td></td></tr>\n<tr><td>title</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>excerpt</td><td>text</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>content</td><td>text</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>isdefault</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>is404</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Note:</b> oh che orrore! Sento gia\' le urla e il dirignare di denti.. \"ma perche\' hai messo\nla lingua ed il contenuto li\' dentro??\". Be\', siamo seri, ogni documento puo\' avere un diverso\nautore e moderatore. Non c\'e\' nessuna regola che dice che lo stesso documento in due lingue\ndiverse sia dello stesso autore e sia moderato dalla stessa persona. In effetti, potrebbe anche\navere un diverso template, css ed appartenere ad un diverso feed RSS! Quindi, quali sono i\ncampi che sono effettivamente \"univoci\" indipendentemente dalla lingua? Mica tanti. Anzi,\nproprio pochi. Talmente pochi che non ha molto senso spezzare in due la tabella. Qualcuno\npotrebbe anche domandarsi come mai il campo <i>rssid</i> non ha una fk verso la tabella dei\nfeed. Perche\' che succede se non si vuole mettere un documento in nessun feed? Bisognerebbe\navere un feed \"fasullo\" a cui assegnare tutti i documenti.</p>\n\n<p><b>Links</b><br>\nDopo un po\' che ravanavo mi sono ritrovato nella situazione di dover avere lo stesso\ndocumento in due posti diversi. Solo che con una struttura in questo modo non e\' possibile\nsenza avere una copia del documento. Come si fa\' in un filesystem? Si crea un link. E cosi\'\nho fatto. I <i>links</i> sono gli URL che contraddistinguono un documento. Un documento\npuo\' avere uno o piu\' link (ma almeno uno). In questo modo lo stesso documento puo\'\n\"apparire\" in due posti diversi.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>no</td><td>hosts(hostid)</td></tr>\n<tr><td>groupid</td><td>int(11)</td><td>none</td><td>no</td><td>no</td><td>groups(hostid,groupid)</td></tr>\n<tr><td>documentid</td><td>varchar(255)</td><td>none</td><td>no</td><td>no</td><td>documents(hostid,groupid,documentid)</td></tr>\n<tr><td>link</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td></td></tr>\n</table></p>\n\n<p><b>Note:</b> I link <u>non hanno lingua</u>. Un link si riferisce ad un \"documento\", non ad\nuna specifica versione.</p>\n\n<p><b>Comments</b><br>\n<p>Questa tabella contiene i commenti per i documenti. E\' da notare che i documenti\n<b>non hanno linuga</b>. Esatto. Tutti i commenti sono nello stesso calderone,\nindipendentemente dalla lingua.</p>\n\n<p><table width=\'100%\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\' bgcolor=\'lightblue\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>field</b></font></td>\n<td><font color=\'white\'><b>type</b></font></td>\n<td><font color=\'white\'><b>default</b></font></td>\n<td><font color=\'white\'><b>null</b></font></td>\n<td><font color=\'white\'><b>pk</b></font></td>\n<td><font color=\'white\'><b>fk</b></font></td>\n</tr>\n<tr><td>hostid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>hosts(hostid)</td></tr>\n<tr><td>groupid</td><td>int(11)</td><td>none</td><td>no</td><td>yes</td><td>groups(hostid,groupid)</td></tr>\n<tr><td>documentid</td><td>varchar(255)</td><td>none</td><td>no</td><td>yes</td><td>documents(hostid,groupid,documentid)</td></tr>\n<tr><td>commentid</td><td>int(11)</td><td>0</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>parentid</td><td>int(11)</td><td>0</td><td>no</td><td>yes</td><td></td></tr>\n<tr><td>userid</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td>users(email)</td></tr>\n<tr><td>username</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>clientip</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>created</td><td>timestamp</td><td>curtime</td><td>no</td><td></td><td></td></tr>\n<tr><td>approved</td><td>enum(\'yes\',\'no\')</td><td>\'no\'</td><td>no</td><td></td><td></td></tr>\n<tr><td>title</td><td>varchar(255)</td><td>none</td><td>no</td><td></td><td></td></tr>\n<tr><td>comment</td><td>text</td><td>none</td><td>no</td><td></td><td></td></tr>\n</table></p>\n\n<p><b>Note:</b> come si puo vedere lo userid in questo caso ha una fk verso la tabella utenti,\nil che significa che se vogliamo gestire commenti \"anonimi\" dovremmo avere un utente\n\"anonymous\" da usare allo scopo. Per questo motivo c\'e\' anche il campo <i>name</i>, perche\'\ncosi\' gli utenti che non vogliono registrarsi possono scrivere il loro nome.</p>\n','no','no'),('helpsite',26,'2','en','fancy','default.css','c98ef2e6c42bd926695f85ff0af80822.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 19:06:46','2009-06-24 17:04:19','Configuration parameters','Configuration parameters','The configuration parameters are used by both the front and the backoffice, this\nway, changing one parameter affect both side in the same way.<p>\n\nIn the beginning, all the parameters were in the configuration file. But that\nmeant that the config file was getting huge and manual modifications required\ndirect access to the file. So I decided to change that and move <b>all</b> the\nparameters into the database, leaving in the config file just the bits \nrequired to access the database.<p>\n\nThese are the configuration parameter of the system:<p>\n\n<table width=\'100%\' bgcolor\'lightblue\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>parametro</b></td>\n<td><font color=\'white\'><b>descrizione</b></td>\n</tr>\n<tr><td>404icon </td><td>icon used for the 404 document </td></tr>\n<tr><td>accepticon</td><td>confirm/accept icon</td></tr>\n<tr><td>addbutton </td><td>add button icon</td></tr>\n<tr><td>addicon </td><td>add icon </td></tr>\n<tr><td>articles</td><td>articles icon</td></tr>\n<tr><td>avatardir </td><td>subdir where the avatars icons are placed</td></tr>\n<tr><td>base</td><td>base directory </td></tr>\n<tr><td>buttondir </td><td>directory for the buttons</td></tr>\n<tr><td>closeicon </td><td>icon used in the close command </td></tr>\n<tr><td>commaddicon </td><td>icon used in the enable comments command </td></tr>\n<tr><td>commdelicon </td><td>icon used in the disable comments command</td></tr>\n<tr><td>commedit-fh </td><td>height for the edit comment wnd</td></tr>\n<tr><td>commedit-fw </td><td>width for the edit comment wnd </td></tr>\n<tr><td>comments-fh </td><td>height for the edit comment window </td></tr>\n<tr><td>comments-fw </td><td>width for the edit comment window</td></tr>\n<tr><td>commentsicon</td><td>comments icon</td></tr>\n<tr><td>config-fh </td><td>height for the edit configuration parameters wnd </td></tr>\n<tr><td>config-fw </td><td>width for the edit configuration parameters wnd</td></tr>\n<tr><td>configicon</td><td>config params icon </td></tr>\n<tr><td>cookiehost</td><td>identification cookie</td></tr>\n<tr><td>copybutton</td><td>icon used in the copy command</td></tr>\n<tr><td>copyicon</td><td>icon used in the copy button </td></tr>\n<tr><td>css </td><td>default CSS</td></tr>\n<tr><td>debug </td><td>enable/disable debugging </td></tr>\n<tr><td>defavatar </td><td>default avatar icons </td></tr>\n<tr><td>defdocicon</td><td>default document\'s icon</td></tr>\n<tr><td>deflang </td><td>default language </td></tr>\n<tr><td>delicon </td><td>icon used in the delete or remove command</td></tr>\n<tr><td>disableicon </td><td>icon used in the disable display command </td></tr>\n<tr><td>dociconsdir </td><td>documents icon directory </td></tr>\n<tr><td>documents-fh</td><td>height for the edit document window</td></tr>\n<tr><td>documents-fw</td><td>width for the edit document window </td></tr>\n<tr><td>documentsicon </td><td>document icon</td></tr>\n<tr><td>downicon</td><td>Demote to user icon</td></tr>\n<tr><td>editicon</td><td>icon used in the edit comments command </td></tr>\n<tr><td>edituserheight</td><td>height for the edit user window</td></tr>\n<tr><td>edituserwidth </td><td>width for the edit user window </td></tr>\n<tr><td>emocode </td><td>Code for the emoticons </td></tr>\n<tr><td>emodecode </td><td>Decode for the emoticons </td></tr>\n<tr><td>emoticonsdir</td><td>subdir where the emoticons icons are placed</td></tr>\n<tr><td>enableicon</td><td>icon used in the enable display command</td></tr>\n<tr><td>feed-fh </td><td>height for the edit RSS feed window</td></tr>\n<tr><td>feed-fw </td><td>width for the edit RSS feed window </td></tr>\n<tr><td>fragments-fh</td><td>height for the edit fragments window </td></tr>\n<tr><td>fragments-fw</td><td>width for the edit fragments windows </td></tr>\n<tr><td>fragmentsicon </td><td>fragment icon</td></tr>\n<tr><td>genrssicon</td><td>rss feed icon</td></tr>\n<tr><td>groups-fh </td><td>height for the edit group window </td></tr>\n<tr><td>groups-fw </td><td>width for the edit group window</td></tr>\n<tr><td>groupsicon</td><td>icon for the groups</td></tr>\n<tr><td>helpicon</td><td>icon for the help function </td></tr>\n<tr><td>helplink</td><td>where is the help? </td></tr>\n<tr><td>hosts-fh</td><td>height for the edit host window</td></tr>\n<tr><td>hosts-fw</td><td>width for the edit host window </td></tr>\n<tr><td>hostsicon </td><td>hosts icon </td></tr>\n<tr><td>htmlcode</td><td>Code for the char replacement in comments</td></tr>\n<tr><td>htmldecode</td><td>Char for the char replacement in comments</td></tr>\n<tr><td>iconsdir</td><td>icons</td></tr>\n<tr><td>images-fh </td><td>height for the edit image wnd</td></tr>\n<tr><td>images-fw </td><td>width for the edit image wnd </td></tr>\n<tr><td>imgdir</td><td>base directory for images</td></tr>\n<tr><td>imgicon </td><td>icon for the Images function </td></tr>\n<tr><td>imgmaxsize</td><td>maximum size (in kbyte) o picture to upload</td></tr>\n<tr><td>ips </td><td>list of IPs with no viewing restrictions </td></tr>\n<tr><td>js</td><td>default javascript name</td></tr>\n<tr><td>languages </td><td>supported languages</td></tr>\n<tr><td>limit </td><td>max document to list </td></tr>\n<tr><td>lockicon</td><td>lock closed icon </td></tr>\n<tr><td>login </td><td>login script to use</td></tr>\n<tr><td>logindefault</td><td>default options for the login screen </td></tr>\n<tr><td>loginicon </td><td>login icon </td></tr>\n<tr><td>logout</td><td>logout user script to use</td></tr>\n<tr><td>logouticon</td><td>logout icon</td></tr>\n<tr><td>maxsizeicon </td><td>Maximum size of a user icon (in Kb)</td></tr>\n<tr><td>mkthumb </td><td>instruction used to resize and create thumbnails </td></tr>\n<tr><td>postnew </td><td>postnew script to use</td></tr>\n<tr><td>preview </td><td>preview script to use</td></tr>\n<tr><td>previewicon </td><td>preview icon (document edit form)</td></tr>\n<tr><td>publishicon </td><td>icon used in the publish command </td></tr>\n<tr><td>pviewicon </td><td>icon used for the preview (small)</td></tr>\n<tr><td>replyicon </td><td>icon used in the reply comments command</td></tr>\n<tr><td>resetpwd</td><td>reset password icon</td></tr>\n<tr><td>rssfeeddir</td><td>directory for RSS feed (relative to the base dir)</td></tr>\n<tr><td>rssicon </td><td>rss feed icon</td></tr>\n<tr><td>selecticon</td><td>icon used for the select command </td></tr>\n<tr><td>templates-fh</td><td>height for the edit template window</td></tr>\n<tr><td>templates-fw</td><td>width for the edit template window </td></tr>\n<tr><td>templatesicon </td><td>template icon</td></tr>\n<tr><td>texts-fh</td><td>height for the edit text window</td></tr>\n<tr><td>texts-fw</td><td>width for the edit text window </td></tr>\n<tr><td>textsicon </td><td>texts icon </td></tr>\n<tr><td>thumbdir</td><td>subdir of the image/host dir where the thumbs are</td></tr>\n<tr><td>title </td><td>main title of the web site </td></tr>\n<tr><td>topics</td><td>document icon</td></tr>\n<tr><td>unlockicon</td><td>lock open icon </td></tr>\n<tr><td>unpublishicon </td><td>icon used in the un-publish command</td></tr>\n<tr><td>upicon</td><td>Promote to root icon </td></tr>\n<tr><td>uploaddir </td><td>temporary directory for uploading</td></tr>\n<tr><td>userdefault </td><td>default options for the user edit screen </td></tr>\n<tr><td>userremoveicon</td><td>user remove icon </td></tr>\n<tr><td>users-fh</td><td>height fo the edit user window </td></tr>\n<tr><td>users-fw</td><td>width for the edit user window </td></tr>\n<tr><td>usersicon </td><td>users icon </td></tr>\n</table><p>\n\n<b>Note:</b> if the parameters aren\'t in the db, things will start not-working.<p>\n','no','no'),('helpsite',26,'2','it','fancy','default.css','c98ef2e6c42bd926695f85ff0af80822.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 18:48:35','2009-06-24 17:04:09','Parametri di configurazione','Elenco dei parametri di configurazione','I parametri di configurazione sono usati sia dal backoffice che dal frontoffice. In\nquesto modo, modificando un solo parametro si agisce su entrambi i fronti in un\ncolpo solo.<p>\n\nAll\'inizio, tutti i parametri erano nel file di configurazione. Il che significava\npero\' che il file era mastodontico e richiedeva modifiche manuali troppo laboriose.\nPer questo motivo ho deciso di spostare <b>tutti</b> i parametri di configurazione\nnel database e lasciare nel file solo i parametri necessari per l\'accesso al\ndatabase.<p>\n\nDi seguito e\' fornito un elenco dei parametri di configurazione usati dal sistema.<p>\n\n<table width=\'100%\' bgcolor\'lightblue\' border=\'1\' cellspacing=\'1\' cellpadding=\'1\'>\n<tr bgcolor=\'darkblue\'>\n<td><font color=\'white\'><b>parametro</b></td>\n<td><font color=\'white\'><b>descrizione</b></td>\n</tr>\n<tr><td>404icon </td><td>icon used for the 404 document </td></tr>\n<tr><td>accepticon</td><td>confirm/accept icon</td></tr>\n<tr><td>addbutton </td><td>add button icon</td></tr>\n<tr><td>addicon </td><td>add icon </td></tr>\n<tr><td>articles</td><td>articles icon</td></tr>\n<tr><td>avatardir </td><td>subdir where the avatars icons are placed</td></tr>\n<tr><td>base</td><td>base directory </td></tr>\n<tr><td>buttondir </td><td>directory for the buttons</td></tr>\n<tr><td>closeicon </td><td>icon used in the close command </td></tr>\n<tr><td>commaddicon </td><td>icon used in the enable comments command </td></tr>\n<tr><td>commdelicon </td><td>icon used in the disable comments command</td></tr>\n<tr><td>commedit-fh </td><td>height for the edit comment wnd</td></tr>\n<tr><td>commedit-fw </td><td>width for the edit comment wnd </td></tr>\n<tr><td>comments-fh </td><td>height for the edit comment window </td></tr>\n<tr><td>comments-fw </td><td>width for the edit comment window</td></tr>\n<tr><td>commentsicon</td><td>comments icon</td></tr>\n<tr><td>config-fh </td><td>height for the edit configuration parameters wnd </td></tr>\n<tr><td>config-fw </td><td>width for the edit configuration parameters wnd</td></tr>\n<tr><td>configicon</td><td>config params icon </td></tr>\n<tr><td>cookiehost</td><td>identification cookie</td></tr>\n<tr><td>copybutton</td><td>icon used in the copy command</td></tr>\n<tr><td>copyicon</td><td>icon used in the copy button </td></tr>\n<tr><td>css </td><td>default CSS</td></tr>\n<tr><td>debug </td><td>enable/disable debugging </td></tr>\n<tr><td>defavatar </td><td>default avatar icons </td></tr>\n<tr><td>defdocicon</td><td>default document\'s icon</td></tr>\n<tr><td>deflang </td><td>default language </td></tr>\n<tr><td>delicon </td><td>icon used in the delete or remove command</td></tr>\n<tr><td>disableicon </td><td>icon used in the disable display command </td></tr>\n<tr><td>dociconsdir </td><td>documents icon directory </td></tr>\n<tr><td>documents-fh</td><td>height for the edit document window</td></tr>\n<tr><td>documents-fw</td><td>width for the edit document window </td></tr>\n<tr><td>documentsicon </td><td>document icon</td></tr>\n<tr><td>downicon</td><td>Demote to user icon</td></tr>\n<tr><td>editicon</td><td>icon used in the edit comments command </td></tr>\n<tr><td>edituserheight</td><td>height for the edit user window</td></tr>\n<tr><td>edituserwidth </td><td>width for the edit user window </td></tr>\n<tr><td>emocode </td><td>Code for the emoticons </td></tr>\n<tr><td>emodecode </td><td>Decode for the emoticons </td></tr>\n<tr><td>emoticonsdir</td><td>subdir where the emoticons icons are placed</td></tr>\n<tr><td>enableicon</td><td>icon used in the enable display command</td></tr>\n<tr><td>feed-fh </td><td>height for the edit RSS feed window</td></tr>\n<tr><td>feed-fw </td><td>width for the edit RSS feed window </td></tr>\n<tr><td>fragments-fh</td><td>height for the edit fragments window </td></tr>\n<tr><td>fragments-fw</td><td>width for the edit fragments windows </td></tr>\n<tr><td>fragmentsicon </td><td>fragment icon</td></tr>\n<tr><td>genrssicon</td><td>rss feed icon</td></tr>\n<tr><td>groups-fh </td><td>height for the edit group window </td></tr>\n<tr><td>groups-fw </td><td>width for the edit group window</td></tr>\n<tr><td>groupsicon</td><td>icon for the groups</td></tr>\n<tr><td>helpicon</td><td>icon for the help function </td></tr>\n<tr><td>helplink</td><td>where is the help? </td></tr>\n<tr><td>hosts-fh</td><td>height for the edit host window</td></tr>\n<tr><td>hosts-fw</td><td>width for the edit host window </td></tr>\n<tr><td>hostsicon </td><td>hosts icon </td></tr>\n<tr><td>htmlcode</td><td>Code for the char replacement in comments</td></tr>\n<tr><td>htmldecode</td><td>Char for the char replacement in comments</td></tr>\n<tr><td>iconsdir</td><td>icons</td></tr>\n<tr><td>images-fh </td><td>height for the edit image wnd</td></tr>\n<tr><td>images-fw </td><td>width for the edit image wnd </td></tr>\n<tr><td>imgdir</td><td>base directory for images</td></tr>\n<tr><td>imgicon </td><td>icon for the Images function </td></tr>\n<tr><td>imgmaxsize</td><td>maximum size (in kbyte) o picture to upload</td></tr>\n<tr><td>ips </td><td>list of IPs with no viewing restrictions </td></tr>\n<tr><td>js</td><td>default javascript name</td></tr>\n<tr><td>languages </td><td>supported languages</td></tr>\n<tr><td>limit </td><td>max document to list </td></tr>\n<tr><td>lockicon</td><td>lock closed icon </td></tr>\n<tr><td>login </td><td>login script to use</td></tr>\n<tr><td>logindefault</td><td>default options for the login screen </td></tr>\n<tr><td>loginicon </td><td>login icon </td></tr>\n<tr><td>logout</td><td>logout user script to use</td></tr>\n<tr><td>logouticon</td><td>logout icon</td></tr>\n<tr><td>maxsizeicon </td><td>Maximum size of a user icon (in Kb)</td></tr>\n<tr><td>mkthumb </td><td>instruction used to resize and create thumbnails </td></tr>\n<tr><td>postnew </td><td>postnew script to use</td></tr>\n<tr><td>preview </td><td>preview script to use</td></tr>\n<tr><td>previewicon </td><td>preview icon (document edit form)</td></tr>\n<tr><td>publishicon </td><td>icon used in the publish command </td></tr>\n<tr><td>pviewicon </td><td>icon used for the preview (small)</td></tr>\n<tr><td>replyicon </td><td>icon used in the reply comments command</td></tr>\n<tr><td>resetpwd</td><td>reset password icon</td></tr>\n<tr><td>rssfeeddir</td><td>directory for RSS feed (relative to the base dir)</td></tr>\n<tr><td>rssicon </td><td>rss feed icon</td></tr>\n<tr><td>selecticon</td><td>icon used for the select command </td></tr>\n<tr><td>templates-fh</td><td>height for the edit template window</td></tr>\n<tr><td>templates-fw</td><td>width for the edit template window </td></tr>\n<tr><td>templatesicon </td><td>template icon</td></tr>\n<tr><td>texts-fh</td><td>height for the edit text window</td></tr>\n<tr><td>texts-fw</td><td>width for the edit text window </td></tr>\n<tr><td>textsicon </td><td>texts icon </td></tr>\n<tr><td>thumbdir</td><td>subdir of the image/host dir where the thumbs are</td></tr>\n<tr><td>title </td><td>main title of the web site </td></tr>\n<tr><td>topics</td><td>document icon</td></tr>\n<tr><td>unlockicon</td><td>lock open icon </td></tr>\n<tr><td>unpublishicon </td><td>icon used in the un-publish command</td></tr>\n<tr><td>upicon</td><td>Promote to root icon </td></tr>\n<tr><td>uploaddir </td><td>temporary directory for uploading</td></tr>\n<tr><td>userdefault </td><td>default options for the user edit screen </td></tr>\n<tr><td>userremoveicon</td><td>user remove icon </td></tr>\n<tr><td>users-fh</td><td>height fo the edit user window </td></tr>\n<tr><td>users-fw</td><td>width for the edit user window </td></tr>\n<tr><td>usersicon </td><td>users icon </td></tr>\n</table><p>\n\n<b>Nota:</b> i parametri devono esserci, altrimenti le cose cominciano a funzionare poco bene.\nIl database di default contiene valori relativamente giusti per una installazione di default.<p>\n','no','no'),('helpsite',26,'3','en','fancy','default.css','c98ef2e6c42bd926695f85ff0af80822.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 19:07:14','2009-06-20 17:27:01','How the front-end works','From the URL to the page.','The front-end is the bit responsible to grab wathever the user type on the \naddress bar, recover the corresponding document, the template and all the\nrequired bits and pieces, piece them together and send the whole shebang to\nthe user\'s browser so it looks like a web page.<p>\n\nIf it sound easy to you, you\'ve got no clue.<p>\n\nFirst of all, the URL is processed by Apache using some clever <i>Rewrite rule</i>\nto turn something like <font color=\'blue\'><code>http://hostname/dir/doc.html</code>\n</font> into something like\n<font color=\'blue\'><code>http://hostname/cgi-bin/doc.pl?doc=dir/doc</code></font>\nthe ball is then sent to the front-end.<p>\n\nThe front ene read the whole URL and try to figure out which <b>host</b> is the\nright one. To do so, it try to match the <i>hostname</i> in the URL with all the\npossible <i>aliases</i> defined for each <i>host</i> in the db.<p>\n\nIf no host matches, a default \"not found\" page is returned.<p>\n\nLet\'s suppose the right host is found. All the default parameters (language, css) are\nmemorized, and the front-end move to look up the document.<p>\n\nThe <i>document</i> can be requested in different ways, for example, the user could\nsimply type the hostname, or add a /something to intend either a document or a\ndirectory.<p>\n\nThe system try to split the document in two parts: the <i>group</i> and the\nactual <i>document</i>. If the group does not exists, then what is the \'document\'\ncould be a group or a document. Let\'s suppose the user type something like\n<code><font color=\'blue\'>http://hostname/document</font></code>, this could mean\nthat either we have a group as \'document\' and no document or a document as\n\'document\' and no group.<p>\n\nFor start the system try to locate a group with that name. If the group does not\nexists, then the default group is selected and a document of that name is looked\nup in that group.<p>\n\nIf the group exists, then the default document for that group is selected.<p>\n\nOnce we have a document, the system try to locate a version in the correct language,\nto do so, it search all the available languages if one matches one of the languages\nindicated by the user\'s browser. If it is found, is used, otherwise the default\nlanguage for the host is used.<p>\n\nIf there is no document (group not found, document not found and so on), a\n<i>default</i> document for the group is selected, or a <i>not found</i> document.\nIf none exists, a standard \"not found\" document is generated by the system.<p>\n\nIn the end, we have a document to display. At this point, the system try to load\na template for the document.<p>\n\nThe template is read and processed, one line at a time. Each line is analyzed\nto see if it contains <i>metatags</i>. Substitutions metatags are processed\nfirst, then processing metatags.<p>\n\nA <i>substitution</i> metatag is a metatag that is replaced with a value that can\nbe defined in the database or by another tag or by a parameter in the query\nstring. A <i>processing</i> metatag is a tag that perform some kind of processing\nand in turn have informations printed on the screen.<p>\n\nIs very important to note the order of processing. This means that something like:\n\n<pre><code>\n&lt;!--include=documentyear&lt;!--year--&gt;--&gt;\n</code></pre><p>\n\nfirst, the tag <code>&lt;!--year--&gt;</code> will be replaced by the current year, then\nthe remaining tag will be analyzed and the fragment with id \"documentyearX\" where \'X\'\nwill be the current year will be included.<p>\n\nIf the tag require the inclusion of a fragment or text, the fragment or text is searched\nin the same way, eventually the fragment in the right language, or in the default\nlanguage, will be processed.<p>\n\nIf a fragment or text can\'t be found, it will be ignored.<p>\n\nNote that the document specify the template, but is the template that need to,\nsomehow, include the document, otherwise the document will never be printed.<p>\n\nThe resulting HTML page will be sent to the browser for display.<p>\n\n','no','no'),('helpsite',26,'3','it','fancy','default.css','c98ef2e6c42bd926695f85ff0af80822.png','none','yes','yes','yes','open','yes','moderator@mydomain.com','hostowner@mydomain.com','2009-06-19 18:50:39','2009-06-20 15:40:07','Come funziona il front-end','Dal URL alla pagina','Il front-end e\' la parte responsabile di acchiappare quello che l\'utente scrive\nsulla barra degli indirizzi, recuperare il documento corrispondente, il template\nassociato e tutto il resto, mettere tutto insieme e spedirlo al browser in modo\ndecente.<p>\n\nSe questo vi sembra semplice, non avete idea di cosa succede \"sotto il coperchio\".<p>\n\nAndiamo con ordine.<p>\n\nPer prima cosa l\'url viene processato da Apache, grazie ad alcune <i>rewrite rule</i>\nad hoc, un url del tipo: <font color=\'blue\'><code>http://hostname/dir/doc.html</code>\n</font>\nviene tradotto in una chiamata al frontend come:\n<font color=\'blue\'><code>http://hostname/cgi-bin/doc.pl?doc=dir/doc</code></font>\nLa palla passa, a questo punto, al front-end vero e proprio.<p>\n\nIl front-end per prima cosa legge tutto l\'elenco dei parametri e cerca di capire quale\n<i>host</i> e\' stato richiesto. Per fare cio\', la parte <i>hostname</i> dell\'Url viene\nconfrontato con tutti gli <i>alias</i> di tutti gli <i>hosts</i> definiti nel database.<p>\n\nSe nessun host corrisponde, una \"pagina non trovata\" di default viene rilasciata.<p>\n\nTrovato l\'host \"giusto\", i parametri di default (lingua, css) vengono memorizzati, quindi\nsi procede a verificare il documento richiesto.<p>\n\nIl <i>documento</i> puo\' essere richiesto in parecchi modi, per esempio si potrebbe\nrichiedere solo il <i>gruppo</i> relativo. O il \"gruppo\" (directory) potrebbe non\nesserci.<p>\n\nIl documento richiesto viene spezzato in due parti: <b>gruppo</b> e <b>documento</b>,\nse le due parti sono uguali (es: e\' stato richiesto qualche cosa come \n<code><font color=\'blue\'>http://hostname/documento</font></code>), significa che\nil gruppo e\' nullo. Il gruppo considerato di <i>default</i> in questo caso viene\nusato.<p>\n\nIl corrispondente <i>host + gruppo + documento</i> viene cercato nel database,\nnotare che in questo caso, non viene guardata la lingua. Se un documento, in\nqualunque lingua, viene trovato, si procede a cercarne uno con una lingua che\ncorrisponde una delle lingue che il browser dell\'utente ha richiesto. Se nessuna\ndelle lingua presenti corrisponde, la lingua di default dell\'host viene prescelta.<p>\n\nSe il documento non viene trovato, si cerca un documento definito come <i>default</i>\nper il gruppo. Se non viene trovato si procede a cercare un documento di <i>non trovato</i>\n(404) per l\'intero host (senza gruppo). Se nemmeno quello viene trovato, una pagina di\nerrore di default viene generata.<p>\n\nAl termine dell\'operazione, comunque vada, abbiamo un documento da visualizzare. A questo\npunto si tratta di leggere e processare il <i>template</i>.<p>\n\nIl template viene letto una linea alla volta, ogni linea viene analizzata per \n<i>metatag</i>. Se il tag e\' di <i>sostituzione</i>, cioe\' consiste in un segnaposto\nper un valore che risiede nel database o viene specificato da un tag precedente,\nil tag viene sostituito nella linea e poi si procede oltre, se il tag e\' di tipo\n<i>contenuto</i> viene elaborato.<p>\n\nE\' importante notare che il tag di sostituzione sono processati PRIMA dei tag di\ncontenuto. Che vuol dire? Vuole dire che un tag come:\n\n<pre><code>\n&lt;!--include=documentianno&lt;!--year--&gt;--&gt;\n</code></pre><p>\n\nla parte <code>&lt;!--year--&gt;</code> verra\' sostituita con l\'anno corrente PRIMA di\nelaborare la \"include\". Quindi il frammento identificato da \"documentiannoX\" dove \'X\'\ne\' l\'anno corrente verra\' elaborato.<p>\n\nSe il tag richiede l\'inclusione di un frammento, il frammento viene cercato, quello nella\nlingua \"giusta\" viene recuperato (o la lingua di default dell\'host se inesistente) ed il\nframmento viene processato nello stesso modo del template.<p>\n\nSe il frammento non viene trovato, viene semplicemente ignorato.<p>\n\nNotare che, il documento specifica il template, ma e\' il template che deve, in qualche\nmodo, <b>includere</b> il documento, altrimenti il documento stesso non viene mai\nvisualizzato.<p>\n\nLa pagina HTML risultante viene inviata al browser dell\'utente che ha richiesto il\ndocumento ed il sistema si predispone per la successiva.<p>\n\n','no','no');
/*!40000 ALTER TABLE `documents` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fragments`
--

DROP TABLE IF EXISTS `fragments`;
CREATE TABLE `fragments` (
  `hostid` varchar(255) NOT NULL default 'localhost',
  `fragid` varchar(255) NOT NULL default 'default',
  `language` varchar(2) NOT NULL default 'en',
  `content` text,
  `name` varchar(255) NOT NULL default 'default frag',
  `created` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`hostid`,`fragid`,`language`),
  CONSTRAINT `fragments_ibfk_1` FOREIGN KEY (`hostid`) REFERENCES `hosts` (`hostid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `fragments`
--

LOCK TABLES `fragments` WRITE;
/*!40000 ALTER TABLE `fragments` DISABLE KEYS */;
INSERT INTO `fragments` VALUES ('helpsite','content','en','<p><b>Documentation:</b>\n<!--list=content-->\n</p>\n<hr>\n','content','2009-06-26 12:01:00'),('helpsite','content','it','<b>Documentazione:</b><p>\r\n<!--list=content-->\r\n<hr>\r\n','content','2009-06-19 18:41:00'),('helpsite','title','en','<div class=\'title\'>CMS FdT Help!</div>\r\n','title','2009-06-19 14:50:00');
/*!40000 ALTER TABLE `fragments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `groups`
--

DROP TABLE IF EXISTS `groups`;
CREATE TABLE `groups` (
  `hostid` varchar(255) NOT NULL,
  `groupid` int(11) NOT NULL,
  `parentid` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `template` varchar(255) NOT NULL,
  `css` varchar(255) NOT NULL,
  `icon` varchar(255) NOT NULL,
  `rssid` varchar(255) NOT NULL,
  `comments` enum('yes','no') NOT NULL default 'no',
  `moderated` enum('yes','no') NOT NULL default 'yes',
  `moderator` varchar(255) NOT NULL,
  `author` varchar(255) NOT NULL,
  `owner` varchar(255) NOT NULL,
  `isdefault` enum('yes','no') NOT NULL default 'no',
  `tname` varchar(255) default NULL,
  PRIMARY KEY  (`hostid`,`groupid`),
  KEY `hostid` (`hostid`,`parentid`),
  KEY `hostid_2` (`hostid`,`template`),
  KEY `moderator` (`moderator`),
  KEY `author` (`author`),
  KEY `owner` (`owner`),
  CONSTRAINT `groups_ibfk_1` FOREIGN KEY (`hostid`) REFERENCES `hosts` (`hostid`),
  CONSTRAINT `groups_ibfk_2` FOREIGN KEY (`hostid`, `template`) REFERENCES `templates` (`hostid`, `templateid`),
  CONSTRAINT `groups_ibfk_3` FOREIGN KEY (`moderator`) REFERENCES `users` (`email`),
  CONSTRAINT `groups_ibfk_4` FOREIGN KEY (`author`) REFERENCES `users` (`email`),
  CONSTRAINT `groups_ibfk_5` FOREIGN KEY (`owner`) REFERENCES `users` (`email`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `groups`
--

LOCK TABLES `groups` WRITE;
/*!40000 ALTER TABLE `groups` DISABLE KEYS */;
INSERT INTO `groups` VALUES ('helpsite',23,25,'content','fancy','default.css','dd0966e0499a9416c9c60f1b30646b14.png','none','yes','yes','moderator@mydomain.com','docowner@mydomain.com','groupowner@mydomain.com','no','content'),('helpsite',24,25,'faq','fancy','default.css','c61238247b8d3038375c43909914ecbb.png','none','yes','yes','moderator@mydomain.com','hostowner@mydomain.com','groupowner@mydomain.com','no','faq'),('helpsite',25,-1,'root','fancy','default.css','253b1793d76eb75a44aa02961831b694.png','none','yes','yes','moderator@mydomain.com','hostowner@mydomain.com','groupowner@mydomain.com','yes','root'),('helpsite',26,25,'tecnica','fancy','default.css','c98ef2e6c42bd926695f85ff0af80822.png','none','yes','yes','moderator@mydomain.com','hostowner@mydomain.com','groupowner@mydomain.com','no','tecnica');
/*!40000 ALTER TABLE `groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hosts`
--

DROP TABLE IF EXISTS `hosts`;
CREATE TABLE `hosts` (
  `hostid` varchar(255) NOT NULL default 'localhost',
  `created` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `aliases` varchar(255) NOT NULL default 'localhost',
  `css` varchar(255) NOT NULL default 'none',
  `deflang` varchar(255) NOT NULL default 'en',
  `owner` varchar(255) NOT NULL default 'anonymous@localhost',
  PRIMARY KEY  (`hostid`),
  KEY `owner` (`owner`),
  CONSTRAINT `hosts_ibfk_1` FOREIGN KEY (`owner`) REFERENCES `users` (`email`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `hosts`
--

LOCK TABLES `hosts` WRITE;
/*!40000 ALTER TABLE `hosts` DISABLE KEYS */;
INSERT INTO `hosts` VALUES ('helpsite','2009-06-19 14:50:08','help,helpcms.onlyforfun.net','default.css','en','hostowner@mydomain.com');
/*!40000 ALTER TABLE `hosts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `images`
--

DROP TABLE IF EXISTS `images`;
CREATE TABLE `images` (
  `hostid` varchar(255) NOT NULL default 'localhost',
  `imgid` varchar(255) NOT NULL default 'image',
  `created` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `filename` varchar(255) NOT NULL default '',
  `author` varchar(255) NOT NULL default 'anonymous@localhost',
  PRIMARY KEY  (`hostid`,`imgid`),
  KEY `author` (`author`),
  CONSTRAINT `images_ibfk_1` FOREIGN KEY (`author`) REFERENCES `users` (`email`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `images`
--

LOCK TABLES `images` WRITE;
/*!40000 ALTER TABLE `images` DISABLE KEYS */;
INSERT INTO `images` VALUES ('helpsite','addgroup','2009-06-20 06:52:00','helpsite-addgroup.jpg','root@mydomain.com'),('helpsite','bo_interface','2009-06-21 05:22:00','helpsite-bo_interface.jpg','root@mydomain.com'),('helpsite','bo_justlogin','2009-06-21 05:22:00','helpsite-bo_justlogin.jpg','root@mydomain.com'),('helpsite','comments','2009-06-21 17:57:00','helpsite-comments.jpg','root@mydomain.com'),('helpsite','deftexts','2009-06-21 10:30:00','helpsite-deftexts.jpg','root@mydomain.com'),('helpsite','documents','2009-06-30 19:26:00','helpsite-documents.jpg','root@mydomain.com'),('helpsite','editcomment','2009-06-21 17:57:00','helpsite-editcomment.jpg','root@mydomain.com'),('helpsite','editdocument','2009-07-01 08:20:00','helpsite-editdocument.jpg','root@mydomain.com'),('helpsite','editfrag','2009-06-21 10:45:00','helpsite-editfrag.jpg','root@mydomain.com'),('helpsite','editgroup','2009-06-21 17:44:00','helpsite-editgroup.jpg','root@mydomain.com'),('helpsite','edithost','2009-06-20 06:53:00','helpsite-edithost.jpg','root@mydomain.com'),('helpsite','editimage','2009-06-21 13:24:00','helpsite-editimage.jpg','root@mydomain.com'),('helpsite','editrss','2009-06-21 11:54:00','helpsite-editrss.jpg','root@mydomain.com'),('helpsite','edittext','2009-06-21 10:27:00','helpsite-edittext.jpg','root@mydomain.com'),('helpsite','edittpl','2009-06-21 12:14:00','helpsite-edittpl.jpg','root@mydomain.com'),('helpsite','edituser','2009-06-20 21:23:00','helpsite-edituser.jpg','root@mydomain.com'),('helpsite','fragments','2009-06-21 10:44:00','helpsite-fragments.jpg','root@mydomain.com'),('helpsite','groups','2009-06-21 17:44:00','helpsite-groups.jpg','root@mydomain.com'),('helpsite','hosts','2009-06-21 07:16:00','helpsite-hosts.jpg','root@mydomain.com'),('helpsite','images','2009-06-21 13:23:00','helpsite-images.jpg','root@mydomain.com'),('helpsite','pagestruct','2009-06-20 15:41:00','helpsite-pagestruct.jpg','docowner@mydomain.com'),('helpsite','rss','2009-06-21 11:53:00','helpsite-rss.jpg','root@mydomain.com'),('helpsite','showcomments','2009-06-21 17:57:00','helpsite-showcomments.jpg','root@mydomain.com'),('helpsite','templates','2009-06-21 12:14:00','helpsite-templates.jpg','root@mydomain.com'),('helpsite','userlayer','2009-06-20 20:51:00','helpsite-userlayer.jpg','root@mydomain.com'),('helpsite','userlist','2009-06-21 13:44:00','helpsite-userlist.jpg','root@mydomain.com');
/*!40000 ALTER TABLE `images` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `links`
--

DROP TABLE IF EXISTS `links`;
CREATE TABLE `links` (
  `hostid` varchar(255) NOT NULL,
  `groupid` int(11) NOT NULL,
  `documentid` varchar(255) NOT NULL,
  `link` varchar(255) NOT NULL,
  PRIMARY KEY  (`hostid`,`groupid`,`documentid`,`link`),
  KEY `link` (`link`),
  CONSTRAINT `links_ibfk_1` FOREIGN KEY (`hostid`, `groupid`, `documentid`) REFERENCES `documents` (`hostid`, `groupid`, `documentid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `links`
--

LOCK TABLES `links` WRITE;
/*!40000 ALTER TABLE `links` DISABLE KEYS */;
INSERT INTO `links` VALUES ('helpsite',23,'60','comments'),('helpsite',23,'70','config'),('helpsite',23,'10','content/10'),('helpsite',23,'15','content/15'),('helpsite',23,'20','content/20'),('helpsite',23,'30','content/30'),('helpsite',23,'32','content/32'),('helpsite',23,'35','content/35'),('helpsite',23,'36','content/36'),('helpsite',23,'37','content/37'),('helpsite',23,'38','content/38'),('helpsite',23,'50','content/50'),('helpsite',23,'55','content/55'),('helpsite',23,'60','content/60'),('helpsite',23,'70','content/70'),('helpsite',23,'80','content/80'),('helpsite',23,'85','content/85'),('helpsite',23,'90','content/90'),('helpsite',23,'50','documents'),('helpsite',24,'1','faq/1'),('helpsite',24,'2','faq/2'),('helpsite',23,'36','feed'),('helpsite',23,'35','fragments'),('helpsite',23,'30','hosts'),('helpsite',23,'38','images'),('helpsite',25,'000','root/000'),('helpsite',26,'1','tecnica/1'),('helpsite',26,'2','tecnica/2'),('helpsite',26,'3','tecnica/3'),('helpsite',23,'37','templates'),('helpsite',23,'32','texts'),('helpsite',23,'20','users');
/*!40000 ALTER TABLE `links` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rssfeeds`
--

DROP TABLE IF EXISTS `rssfeeds`;
CREATE TABLE `rssfeeds` (
  `hostid` varchar(255) NOT NULL default 'localhost',
  `rssid` varchar(255) NOT NULL default 'feed',
  `filename` varchar(255) NOT NULL default 'feed.rss',
  `title` varchar(255) NOT NULL default 'Feed Rss',
  `description` text,
  `link` varchar(255) NOT NULL default '',
  `language` varchar(5) NOT NULL default 'it-it',
  `author` varchar(255) NOT NULL default '',
  `copyright` varchar(255) NOT NULL default '(c)',
  `subject` varchar(255) NOT NULL default 'feed rss',
  `taxo` varchar(255) NOT NULL default '',
  `lastdone` datetime default NULL,
  PRIMARY KEY  (`hostid`,`rssid`),
  CONSTRAINT `rssfeeds_ibfk_1` FOREIGN KEY (`hostid`) REFERENCES `hosts` (`hostid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `rssfeeds`
--

LOCK TABLES `rssfeeds` WRITE;
/*!40000 ALTER TABLE `rssfeeds` DISABLE KEYS */;
/*!40000 ALTER TABLE `rssfeeds` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `templates`
--

DROP TABLE IF EXISTS `templates`;
CREATE TABLE `templates` (
  `hostid` varchar(255) NOT NULL default 'localhost',
  `templateid` varchar(255) NOT NULL default 'default',
  `title` varchar(255) NOT NULL default 'default template',
  `content` text NOT NULL,
  `updated` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `isdefault` enum('yes','no') NOT NULL default 'no',
  PRIMARY KEY  (`hostid`,`templateid`),
  CONSTRAINT `templates_ibfk_1` FOREIGN KEY (`hostid`) REFERENCES `hosts` (`hostid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `templates`
--

LOCK TABLES `templates` WRITE;
/*!40000 ALTER TABLE `templates` DISABLE KEYS */;
INSERT INTO `templates` VALUES ('helpsite','fancy','fancy','<center>\r\n<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\" width=\"95%\" bgcolor=\'blue\'> \r\n<tr> \r\n<td align=\'left\' valign=\'center\' width=\'80%\'>\r\n<div class=\'title\'>CMS Fdt Help!</div>\r\n</div>\r\n</td>\r\n<td valign=\"center\" align=\"right\">\r\n<!--icon=width=64px height=64px-->\r\n</td>\r\n</tr>\r\n<tr bgcolor=\'lightgreen\'>\r\n<td align=\'left\' valign=\'top\' colspan=\'2\'><font color=\'white\'><!--position--> </font></td>\r\n</tr>\r\n</table>\r\n<table border=\"0\" cellpadding=\"2\" cellspacing=\"5\" width=\"95%\" bgcolor=\'white\'> \r\n<tr>\r\n<td width=\'70%\' valign=\'top\' align=\'left\'>\r\n<h2><!--title--></h2>\r\n\r\n<!--text-->\r\n\r\n<!--prev--> <!--next-->\r\n<hr>\r\n<!--comments-->\r\n</td>\r\n<td valign=\'top\' align=\'left\'>\r\n<!--loginform-->\r\n<hr>\r\n<!--include=content-->\r\n</td>\r\n</tr>\r\n<tr>\r\n<td> &nbsp; </td>\r\n</tr>\r\n</table>\r\n<hr>\r\n<p>\r\nIcons by <a href=\"mailto:mattahan@gmail.com\">Paul Davey</a> aka <a href=\"http://mattahan.deviantart.com\">Mattahan</a>. All rights reserved.<br>\r\nCMS FDT (C) Davide Bianchi - 2008 - averyfarawaydate<p>\r\n</center>\r\n','2009-06-28 06:24:41','yes'),('helpsite','fancylist','fancylist','<div class=\'doctitle\'>\n<!--icon-->\n<a href=\'<!--docname-->\' border=\'0\'>\n<!--title--></a></div>\n<div class=\'docdetails\'>\n<!--getatext=by-->\n<!--field=name-->\n<!--getatext=updated-->\n<!--updated-->\n-\n<!--numcomments-->\n</div>\n<div class=\'docexcerpt\'>\n<!--excerpt-->\n</div>\n<p>\n','2009-06-20 08:24:00','no');
/*!40000 ALTER TABLE `templates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `userdescs`
--

DROP TABLE IF EXISTS `userdescs`;
CREATE TABLE `userdescs` (
  `userid` varchar(255) NOT NULL default 'anonymous@localhost',
  `language` varchar(2) NOT NULL default 'en',
  `content` text,
  PRIMARY KEY  (`userid`,`language`),
  CONSTRAINT `userdescs_ibfk_1` FOREIGN KEY (`userid`) REFERENCES `users` (`email`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `userdescs`
--

LOCK TABLES `userdescs` WRITE;
/*!40000 ALTER TABLE `userdescs` DISABLE KEYS */;
/*!40000 ALTER TABLE `userdescs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `email` varchar(255) NOT NULL default 'anonymous@localhost',
  `icon` varchar(255) NOT NULL default '',
  `name` varchar(255) NOT NULL,
  `registered` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `lastseen` datetime default NULL,
  `password` varchar(255) NOT NULL default 'nopass',
  `random` varchar(255) default NULL,
  `isroot` enum('yes','no') NOT NULL default 'no',
  `signature` varchar(255) NOT NULL default '',
  `userchk` varchar(255) default NULL,
  PRIMARY KEY  (`email`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
INSERT INTO `users` VALUES ('anonymous@localhost','user.png','Anonymous coward','2009-06-23 11:57:25',NULL,'nopass',NULL,'no','',NULL),('docowner@mydomain.com','Werewolf-48x48.png','docowner','2009-06-18 22:00:00','2009-06-29 13:30:23','EltZN3N0l3GC6',NULL,'no','The Doc Owner','903pEvd+i7fcl2keTAP/ww'),('groupowner@mydomain.com','TechSupport.png','groupowner','2009-06-18 22:00:00','2009-06-29 13:36:06','7nG38PNNND2.M',NULL,'no','The Group Owner','rP22DzLcDjLzmjI3arJr5g'),('hostowner@mydomain.com','girl_2.png','hostowner','2009-06-18 22:00:00','2009-06-29 13:14:12','nRYRgef2IEoi6',NULL,'no','The Host Owner','0IR1p7Kdv//qNv/3aSpb5Q'),('moderator@mydomain.com','Bigfoot-48x48.png','moderator','2009-06-18 22:00:00','2009-06-29 13:29:51','dDuwPDugL/5q2',NULL,'no','The Moderator','vSpEa3K9RSlRYrMHmWyq7g'),('root@mydomain.com','boy_8.png','root','2009-06-18 22:00:00','2009-06-28 08:23:45','xurjAt6CAJVDc',NULL,'yes','The Superuser','+avB8kUg+CA8VLGA9PALbw');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2009-07-02 18:51:38
